<?php
/* $Id: function.inc.php 2350 2008-11-06 14:13:35Z vadim $ */


function AttemptToAuthorize()
{
	$sname  = session_name();
	unset($perm);

	global $db, $perm;
	global $AUTHORIZE_BY;
	global $PHP_AUTH_USER, $PHP_AUTH_PW, $PHP_AUTH_SID, $PHP_AUTH_LANG;
	global $AUTHORIZATION_TYPE, $MODULE_VARS, $ADMIN_AUTHTIME, $HTTP_HOST, $SUB_FOLDER;
	global $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $$sname, $current_user, $catalogue;

	$IP_CHECK_LEVEL = &$MODULE_VARS['auth']['IP_CHECK_LEVEL'];
	$IpCheckLevel = ( $IP_CHECK_LEVEL != '' && $IP_CHECK_LEVEL >= 0 && $IP_CHECK_LEVEL <=4 ? (int)$IP_CHECK_LEVEL : 2);

	$AUTH_USER_ID    = 0;
	$AUTH_USER_GROUP = 0;

	if ($AUTHORIZATION_TYPE != 'http') {
		if ($$sname) {
			$_GET[session_name()]  = $$sname;
			$_POST[session_name()] = $$sname;
		}
		else {
			$session_id = md5(uniqid(rand(), 1));
			session_id($session_id);
		}
		session_start();
		$glbSid = session_id();
		if ($_SESSION['User']['IsLogin'] == "1") {
			if ($_SESSION['User']['IP'] != getenv("REMOTE_ADDR")) header ("Location: ".$SUB_FOLDER);
			if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) unset($_SESSION['User']);
		}
		$_SESSION['User']['datetime'] = time();
		if ($AUTHORIZATION_TYPE == 'session' && !$_SESSION['User']['ID'] && $_SESSION_USER_ID != "0") {$AUTH_USER_ID = $_SESSION['User']['ID'];}
	}


	//  IP 
	if ($AUTH_TYPE != 'http') {

		if ($IpCheckLevel == 0) {
			$SqlCheckIp = '';
		}
		elseif ($IpCheckLevel == 4) {
			$SqlCheckIp = ' AND s.UserIP = '.sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
		}
		else {
			$IpVal = explode('.', $_SERVER['REMOTE_ADDR'],$IpCheckLevel+1);
			array_pop($IpVal);
			$IpVal = implode('.', $IpVal);
			$UserIPBegin = $IpVal.str_repeat('.0', 4-$IpCheckLevel);
			$UserIPEnd = $IpVal.str_repeat('.255', 4-$IpCheckLevel);
			$SqlCheckIp = ' AND s.UserIP >= '.sprintf("%u", ip2long($UserIPBegin)).' AND s.UserIP <= '.sprintf("%u", ip2long($UserIPEnd));
		}
	}

	$query_where_cat = $MODULE_VARS['auth']['USER_BIND_TO_CATALOGUE'] ? " AND u.Catalogue_ID IN(0,".$catalogue.")" : "";

	// HTTP 
	if ($AUTHORIZATION_TYPE == 'http') {
		$current_user = $db->get_row("SELECT *
			FROM User WHERE ".$AUTHORIZE_BY."='".$PHP_AUTH_USER."' AND Password=PASSWORD('".$PHP_AUTH_PW."')", ARRAY_A);

	}
	// SESSION 
	elseif ($AUTHORIZATION_TYPE == 'session') {
		$current_user = $db->get_row("SELECT *
			FROM User AS u
			RIGHT JOIN Session AS s
			ON u.User_ID = s.User_ID
			WHERE u.Checked = 1 AND s.Session_ID = '".$$sname."' AND s.SessionTime > ".time().$SqlCheckIp.$query_where_cat, ARRAY_A);

	}
	// COOKIE 
	elseif ($AUTHORIZATION_TYPE == 'cookie') {
		$current_user = $db->get_row("SELECT *
			FROM User AS u
			RIGHT JOIN Session AS s
			ON u.User_ID = s.User_ID
			WHERE u.Checked = 1 AND s.Session_ID = '".$PHP_AUTH_SID."' AND s.SessionTime > ".time().$SqlCheckIp.$query_where_cat, ARRAY_A);
	}




	//  
	if ($current_user) {
		$AUTH_USER_ID    = $current_user['User_ID'];
		$AUTH_USER_GROUP = $current_user['PermissionGroup_ID'];
		$PHP_AUTH_USER   = $current_user[$AUTHORIZE_BY];
		$PHP_AUTH_PW     = $current_user['Password'];
		$LoginSave       = ($current_user['LoginSave'] || $ADMIN_AUTHTYPE == 'always' ? 1 : 0);
		$Catalogue_ID    = $current_user['Catalogue_ID'];

		$SessionTime = ($ADMIN_AUTHTIME ? time()+$ADMIN_AUTHTIME : time()+24*3600);

		if ($AUTHORIZATION_TYPE == 'session') {
			$db->query("UPDATE Session SET SessionTime = ".$SessionTime." WHERE Session_ID = '".$$sname."'");
		}
		elseif ($AUTHORIZATION_TYPE == 'cookie') {
			$db->query("UPDATE Session SET SessionTime = ".$SessionTime." WHERE Session_ID = '".$PHP_AUTH_SID."'");
			if (!$LoginSave) $SessionTime = 0;
			$cookie_domain = ($MODULE_VARS['auth']['COOKIES_WITH_SUBDOMAIN'] ? str_replace("www.", "", $HTTP_HOST) : NULL);
			setcookie('PHP_AUTH_SID', $PHP_AUTH_SID, $SessionTime, "/", $cookie_domain);
			setcookie('PHP_AUTH_LANG', $PHP_AUTH_LANG, $SessionTime, "/", $cookie_domain);
		}


	}
	
	// 
	else {
		$SessionTime = time()+($ADMIN_AUTHTIME ? $ADMIN_AUTHTIME : 24*3600);
		$PHP_AUTH_SID = ($$sname ? $$sname : $glbSid);
		$PHP_AUTH_USER = '';
		$PHP_AUTH_PW = '';
		
		$update_res = $db->query("UPDATE Session SET SessionTime = IF (SessionTime=".$SessionTime.", SessionTime+1,".$SessionTime.") WHERE Session_ID = '".$PHP_AUTH_SID."'");
		if (!$update_res) {
			$db->query("INSERT INTO Session (Session_ID, User_ID, SessionStart, SessionTime, UserIP, Catalogue_ID) VALUES ('".$PHP_AUTH_SID."', 0, ".time().", ".$SessionTime.", ".sprintf("%u", ip2long($_SERVER['REMOTE_ADDR'])).", ".$catalogue.")");
			//   
			if (!rand(0,50)) $db->query("DELETE FROM Session WHERE User_ID = 0 AND SessionTime < ".($SessionTime-300));
		}
	}

	if ($AUTH_USER_ID) {
		$perm = new Permission ($AUTH_USER_ID, $AUTH_USER_GROUP, 1);
	}
	
	else {
		return false;
	}
}


function UserLoginForm($IsReturn = 0)
{
	global $HTTP_ROOT_PATH, $AUTH_USER, $REQUEST_URI, $REQUESTED_FROM, $REQUEST_METHOD, $SUB_FOLDER;
	global $db, $catalogue, $sub, $cc, $AUTH_USER_ID, $AUTHORIZATION_TYPE, $ADMIN_AUTHTYPE, $REQUESTED_BY;
	
	if ($AUTH_USER_ID) return;
	
	if (!$REQUESTED_FROM) $REQUESTED_FROM = $REQUEST_URI;
	if (!isset($REQUESTED_BY) || isset($REQUESTED_BY) && (strtoupper($REQUESTED_BY) != 'GET' && strtoupper($REQUESTED_BY) != 'POST')) $REQUESTED_BY = $REQUEST_METHOD;

	$isDisable = $db->get_var("SELECT Value FROM Auth_Settings WHERE SettingsKey = 'UserLoginFormIsDisable'");
	if ($isDisable) return;

	$template = $db->get_var("SELECT Value FROM Auth_Settings WHERE SettingsKey = 'UserLoginForm'");
	eval ('$result = "'.$template.'";');

	if ($IsReturn) {
		return $result;
	}
	else {
		echo $result;
	}
}


function ChangePasswordForm($IsResult = 0)
{
	global $db, $catalogue, $sub, $cc;
	global $HTTP_ROOT_PATH, $SUB_FOLDER;

	if (isset($_REQUEST['uid'])) $uid = (int)$_REQUEST['uid'];
	if (isset($_REQUEST['ucc'])) $ucc = htmlspecialchars($_REQUEST['ucc'], ENT_QUOTES);

	$template = $db->get_var("SELECT Value FROM Auth_Settings WHERE SettingsKey = 'ChangePasswordForm'");
	eval ('$result = "'.$template.'";');

	if ($IsResult) {
		return $result;
	}
	else {
		echo $result;
	}
}


function PasswordRecoveryForm($IsResult = 0)
{
	global $Login, $Email;
	global $db, $catalogue, $sub, $cc;
	global $HTTP_ROOT_PATH, $SUB_FOLDER;

	$template = $db->get_var("SELECT Value FROM Auth_Settings WHERE SettingsKey = 'PasswordRecoveryForm'");
	eval ('$result = "'.$template.'";');

	if ($IsResult) {
		return $result;
	}
	else {
		echo $result;
	}
}


function GetAllProjectDomains ()
{
	global $db, $DOMAIN_NAME, $SUB_FOLDER;

	$res = $db->get_results("SELECT IF(LOCATE('.',Domain),Domain,IF(Domain<>'',CONCAT(Domain,'.".$DOMAIN_NAME."'),'".$DOMAIN_NAME."')),Mirrors FROM Catalogue ORDER BY Priority", ARRAY_N);
	$k = 0;
	$CatCount = $db->num_rows;
	for ($i=0; $i<$CatCount; $i++) {
		list($Domain,$Mirrors) = $res[$i];
		$DomainArray[$k] = $Domain;
		$MirrorArray = explode("\n",$Mirrors);
		for ($j=0;$j<count($MirrorArray);$j++) {
			$k++;
			$DomainArray[$k] = trim($MirrorArray[$j]);
		}
	}
	return ($DomainArray);
}


/*======= USER FUNCTIONS =======*/


/**
 *     " "
 * name of the function by N
 *
 * @param integer ID  (optional)
 * @return string     
 */
function nc_auth_regform_url($catalogue_id=0)
{
	global $db, $SUB_FOLDER;

	$catalogue_id = ($catalogue_id ? (int)$catalogue_id : $GLOBALS['catalogue']);

	$url = $db->get_var("SELECT CONCAT(sub.Hidden_URL, cc.EnglishName, '.html')
		FROM Subdivision as sub, Sub_Class as cc, Class as class
		WHERE class.System_Table_ID=3
		AND class.Class_ID=cc.Class_ID
		AND cc.Catalogue_ID = $catalogue_id
		AND cc.DefaultAction='add'
		AND cc.Checked = 1
		AND cc.Subdivision_ID=sub.Subdivision_ID
		LIMIT 1");
	return $SUB_FOLDER.$url;
}


/**
 * url    
 *
 * @param mixed $User_ID   (optional)
 * @return mixed     
 */
function nc_auth_profile_url($User_ID = 0)
{
	global $db;
	global $catalogue;
	global $MODULE_VARS, $SUB_FOLDER;

	$UserListCc = $MODULE_VARS['auth']['USER_LIST_CC'];
	if ($UserListCc) {
		if (!$MODULE_VARS['auth']['UserListUrl']) {
			$MODULE_VARS['auth']['UserListUrl'] = $db->get_var("SELECT CONCAT(sd.Hidden_URL, sc.EnglishName)
				FROM Sub_Class AS sc
				LEFT JOIN Subdivision AS sd
				ON sc.Subdivision_ID = sd.Subdivision_ID
				WHERE sc.Catalogue_ID = ".(int)$catalogue." AND sc.Sub_Class_ID IN (".$UserListCc.")");
		}
		$url = $MODULE_VARS['auth']['UserListUrl'];

		if (is_array($User_ID)) {
			foreach ($User_ID as $id) $result[] = $SUB_FOLDER.$url.'_'.$id.'.html';
			return $result;
		}
		elseif ($User_ID) {
			return $SUB_FOLDER.$url.'_'.(int)$User_ID.'.html';
		}
		else {
			return $SUB_FOLDER.$url.'_';
		}

	}
	else {
		return false;
	}


}


/**
 *  online
 *
 * @param mixed $template        (optional)
 * @param string $select_fields     (optional)
 * @return mixed
 */
function nc_auth_users_online($template = NULL, $select_fields = NULL)
{
	global $db, $catalogue;
	global $MODULE_VARS, $ADMIN_AUTHTIME, $AUTHORIZE_BY, $SUB_FOLDER;

	$result = NULL;
	$TimeLeft = ($ADMIN_AUTHTIME ? time()+$ADMIN_AUTHTIME : time()+24*3600) - $MODULE_VARS['auth']['USER_ONLINE_TIME_LEFT'];
	$tags  = array('%NAME', '%URL');
	$tags2 = array('%GUESTS', '%REGISTERED', '%ONLINE');
	$select_fields   = ($select_fields ? $select_fields.', ' : 'u.'.$AUTHORIZE_BY.' AS Name, ');
	$query_where_cat = $MODULE_VARS['auth']['USER_BIND_TO_CATALOGUE'] ? "Catalogue_ID IN(0,".$catalogue.")" : "";

	switch ($template) {
		case ARRAY_N:
			return (array)$db->get_col("SELECT User_ID
				FROM Session
				WHERE User_ID != 0 AND SessionTime>".$TimeLeft.($query_where_cat ? " AND ".$query_where_cat : "")."
				GROUP BY User_ID
				ORDER BY User_ID");
			break;

		case ARRAY_A:
			return (array)$db->get_results("SELECT u.User_ID, ".$select_fields."CONCAT('".nc_auth_profile_url()."', u.User_ID, '.html') AS `Url`
				FROM User AS u
				INNER JOIN Session AS s
				ON u.User_ID=s.User_ID
				WHERE s.SessionTime>".$TimeLeft.($query_where_cat ? " AND s.".$query_where_cat : "")."
				GROUP BY u.User_ID
				ORDER BY Name", ARRAY_A);
			break;
	}

	if (!$template) {
		unset ($template);
		$template['prefix']  = "";
		$template['suffix']  = "";
		$template['divider'] = ", ";
		$template['link']    = "<a href='%URL'>%NAME</a>";
	}

	$Guests = $db->get_var("SELECT COUNT(Session_ID)
		FROM Session
		WHERE User_ID=0 AND SessionTime>".$TimeLeft.($query_where_cat ? " AND ".$query_where_cat : ""));

	if (is_array($template)) {

		$OnlineUsers = $db->get_results("SELECT u.".$AUTHORIZE_BY." AS `Name`, CONCAT('".nc_auth_profile_url()."', u.User_ID, '.html') AS `Url`
			FROM User AS u
			INNER JOIN Session AS s
			ON u.User_ID=s.User_ID
			WHERE s.User_ID!=0 AND s.SessionTime>".$TimeLeft.($query_where_cat ? " AND s.".$query_where_cat : "")."
			GROUP BY u.User_ID
			ORDER BY Name", ARRAY_A);

		if ($Registered = count($OnlineUsers)) {
			if ($template['link']) {
				foreach ($OnlineUsers as $user) $result[] = str_replace($tags, $user, $template['link']);
				$result = join(($template['divider'] ? $template['divider'] : ''), $result);
			}
			$result = ($template['prefix'] ? $template['prefix'] : '').$result.($template['suffix'] ? $template['suffix'] : '');

			$result = str_replace($tags2, array($Guests, $Registered, $Guests+$Registered), $result);
		}


	}
	else {
		$Registered = count($db->get_results("SELECT User_ID
			FROM Session
			WHERE User_ID != 0 AND SessionTime>".$TimeLeft.($query_where_cat ? " AND ".$query_where_cat : "")."
			GROUP BY User_ID", ARRAY_N));
		$result = str_replace($tags2, array($Guests, $Registered, $Guests+$Registered), $template);
	}


	return $result;
}


/**
 *    
 * 
 * @param int $User_ID  
 */
function nc_auth_is_online($User_ID)
{	
	static $online;
	
	if (!is_array($online)) {
		$online = nc_auth_users_online(ARRAY_N);
	}
	
	return is_array($online) && in_array($User_ID, $online) ? true : false;
}


/**
 *        
 *
 * @param int $User_ID   (optional)
 * @return int
 */
function nc_auth_messages_new($User_ID = 0, $Sub_Class_ID = 0)
{
	global $db, $current_user, $catalogue;
	global $MODULE_VARS;

	if (!$current_user) return false;

	if (!$User_ID) $User_ID = $current_user['User_ID'];

	if (!isset($MODULE_VARS['auth']['UserMessagesNew'])) {
		$MODULE_VARS['auth']['UserMessagesNew'] = $db->get_var("SELECT COUNT(m.Message_ID)
			FROM Message".$MODULE_VARS['auth']['USER_MESSAGES_CLASS']." AS m
			RIGHT JOIN Sub_Class AS s
			ON m.Sub_Class_ID = s.Sub_Class_ID
			WHERE m.Status = 0 AND m.ToUser = ".$User_ID." AND s.Catalogue_ID = ".$catalogue.($Sub_Class_ID ? " AND m.Sub_Class_ID = ".(int)$Sub_Class_ID : ""));
	}
	return $MODULE_VARS['auth']['UserMessagesNew'];
}


/**
 * URL     /   
 *
 * @param int $User_ID   ()    (optional)
 * @param int $Sub_Class_ID       (optional)
 * @return string
 */
function nc_auth_messages_url($User_ID = 0, $Sub_Class_ID = 0)
{
	global $db, $catalogue;
	global $MODULE_VARS, $SUB_FOLDER;

	if (!isset($MODULE_VARS['auth']['UserMessagesUrl'])) {
		$res = $db->get_row("SELECT sd.Hidden_URL, sc.EnglishName
			FROM Sub_Class AS sc
			LEFT JOIN Subdivision AS sd
			ON sc.Subdivision_ID = sd.Subdivision_ID
			WHERE sc.Class_ID = ".$MODULE_VARS['auth']['USER_MESSAGES_CLASS']." AND sc.Catalogue_ID = ".$catalogue.($Sub_Class_ID ? " AND sc.Sub_Class_ID = ".(int)$Sub_Class_ID : "")."
			LIMIT 1", ARRAY_A);

		$MODULE_VARS['auth']['UserMessagesClassEnName'] = $res['EnglishName'];
		$MODULE_VARS['auth']['UserMessagesUrl'] = $res['Hidden_URL'];
	}

	return $SUB_FOLDER.$MODULE_VARS['auth']['UserMessagesUrl'].($User_ID ? "add_".$MODULE_VARS['auth']['UserMessagesClassEnName'].".html?uid=".$User_ID : "");
}
?>