<?php
/* $Id: function.inc.php 2349 2008-11-05 20:57:52Z denis $ */

/**
  *      
  * @param int   
  * @return string html- 
  */
function nc_set_calendar($id = 0) {
global $db, $SUB_FOLDER, $HTTP_ROOT_PATH;

	$id = (int)$id;
	
	$css = $db->get_var("SELECT `CalendarCSS`
		FROM `Calendar_Settings`
		WHERE ".($id ? "ID = '".$id."'" : "DefaultTheme = '1'")."");

	$result = "<style type='text/css'>\r\n".$css."</style>\r\n";
	$result.= "<script type='text/javascript'>var SUB_FOLDER = '".$SUB_FOLDER."', NETCAT_PATH = '".$HTTP_ROOT_PATH."';</script>\r\n";
	$result.= "<script type='text/javascript' src='/netcat/admin/js/lib.js'></script>\r\n";
	$result.= "<script type='text/javascript' src='".$SUB_FOLDER.$HTTP_ROOT_PATH."modules/calendar/calendar.js'></script>";
	
return $result;
}


/**
  *     ,    , ..   
  * @param int  
  * @param int   ,   
  * @param int  
  * @param int   ,   
  * @param int    
  * @param int   ,     
  * @return bool
  */
function nc_calendar_read_permission($catalogue, $sub, $cc) {
global $db, $AUTH_USER_ID, $perm;

	#        $perm
	if( !$AUTH_USER_ID || !class_exists("Permission") || !is_object($perm) ) return false;
  if ( !$perm->isSubClass($cc, MASK_READ) ) return false;
  
  return true;
  /*
  #   
	$i = 0;
	$parent_sub = $sub;
	$parent_sub_array = array($sub);
	while($parent_sub) {
		$parent_sub = $db->get_var("SELECT `Parent_Sub_ID`
			FROM `Subdivision`
			WHERE `Subdivision_ID` = '".$parent_sub."'");
		if(!$parent_sub) break;
		$parent_sub_array[] = $parent_sub;
	$i++;
	}

	#   
	$Permissions = $perm->ARRAY;
	# AdminType==4:  
	# AdminType==3:  
	# AdminType==9:    
	# $Permission[0] - Catalogue_ID -   (, ,   )
	# $Permission[1] - Permission_ID -  	
	# $Permission[2] - PermissionSet -    (1 - ,3 - ,7 - ,15 - ,31 - ,63 - )
	if ( !empty($Permissions) ) {
		foreach($Permissions AS $AdminType => $Permission) {
			foreach($Permission AS $value) {
				if($AdminType==4 && $value[2]>=1 && $value[0]==$catalogue) return true;
				if($AdminType==3 && $value[2]>=1 && in_array($value[0], $parent_sub_array) ) return true;
				if($AdminType==9 && $value[2]>=1 && $value[0]==$cc) return true;
			}
		}
	}
	
return false;*/
}


/**
  *  
  * @param int   
  * @param int    
  * @param string   
  * @param bool     
  * @return string html- 
  */
function nc_show_calendar($theme = 0, $cc = 0, $setDate = 0, $DateField = "Date", $filled = false, $queryDate = false) {
  global $db, $DOCUMENT_ROOT, $SUB_FOLDER, $HTTP_ROOT_PATH, $action;

	#   
	if($DateField) $DateField = $db->escape($DateField);
  # 
	$antiJumper = true;
	$theme = (int)$theme;
	$curr_year = date("Y");
	$imagesPath = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/calendar/images/";

	#    $cc,   
	if(!$cc) {
		global $catalogue, $sub, $cc, $classID;
    global $current_catalogue, $current_sub, $current_cc;
		$Sub_Class_Read_Access = $current_cc['Read_Access_ID'];
    $Cache_Access_ID = $current_cc['Cache_Access_ID'];
    $Cache_Lifetime = $current_cc['Cache_Lifetime'];
		$Hidden_URL = $current_sub['Hidden_URL'];
	}
	else {
    // get Sub_Class env
    $cc_data = InheritSubClassEnv($cc);
		// set variables
		if( !empty($cc_data) ) {
			$catalogue = $cc_data['Catalogue_ID'];
			$sub = $cc_data['Subdivision_ID'];
			$classID = $cc_data['Class_ID'];
			$Sub_Class_Read_Access = $cc_data['Sub_Class_Read_Access'];
      $Cache_Access_ID = $cc_data['Cache_Access_ID'];
      $Cache_Lifetime = $cc_data['Cache_Lifetime'];
			$Hidden_URL = $cc_data['Hidden_URL'];
		}
		else {
			trigger_error("<b>nc_show_calendar()</b>: Incorrect \$cc (".$cc.")", E_USER_WARNING);
			return false;
		}
	}
	
	// check user right to read this info
	/*
	$read_access = ( $Sub_Class_Read_Access==1 ? true : ( $Sub_Class_Read_Access==2 && $AUTH_USER_ID ? true : ( $Sub_Class_Read_Access==3 && nc_calendar_read_permission($catalogue, $sub, $cc) ? true : false ) ) );
	*/
	$read_access = false;
	switch ($Sub_Class_Read_Access) {
	  case 1:
	    $read_access = true;
	    break;
	  case 2:
	    if ($AUTH_USER_ID) $read_access = true;
	    break;
	  case 3:
	    //$read_access = CheckUserRights($current_cc['Sub_Class_ID'], 'read', 0);
	    $read_access = nc_calendar_read_permission($catalogue, $sub, $cc);
	    break;
	}
	
  // date from adress line
  if ($queryDate || preg_match("/\/(\d{4})\/(?:(\d{2})\/)?(?:(\d{2})\/)?/s", $_SERVER['REQUEST_URI'], $matches) ) {
    if (!$queryDate) {
      array_shift($matches);
      $query_date_year = $matches[0];
      $query_date_month = $matches[1] ? $matches[1] : 0;
      $query_date_day = $matches[2] ? $matches[2] : 0;
      $queryDate = join("-", $matches);
    }
    else {
      // query date
      list($query_date_year, $query_date_month, $query_date_day) = split("-", $queryDate);
      if(!$query_date_month) $query_date_month = 0;
      if(!$query_date_day) $query_date_day = 0;
    }
  }
  else {
    $queryDate = false;
  }
  
  #   
	$date = $setDate ? $setDate : $GLOBALS['date'];
  if($date && preg_match("/^([0-9]{1,4}-?){1,3}$/", $date) ) {
		// simply date value in script
    list($year, $month, $day) = split("-", $date);
		if(!$month) $month = 1;
		if(!$day) $day = 1;
  } 
	else {
		list($year, $month, $day) = split("-", date("Y-m-d") );
	}

	#  
	$settings = $db->get_row("SELECT * FROM `Calendar_Settings`
		WHERE ".($theme ? "`ID` = '".$theme."'" : "`DefaultTheme` = '1'")."", ARRAY_A);

	if( empty($settings) ) {
		trigger_error("<b>nc_show_calendar()</b>: No calendar theme found (".$theme.")", E_USER_WARNING);
		return false;
	}
	
	#   
	if(!$theme) $theme = $settings['ID'];
  
  // cache section
  if ( nc_module_check_by_keyword("cache") && $Cache_Access_ID==1) {
    // load need files
    nc_calendar_cache();
    // try to read cache
    try {
      $nc_cache_calendar = nc_cache_calendar::getObject();
      // check cached data
      $cached_data = $nc_cache_calendar->read($cc, $theme, $DateField, $year."-".$month."-".$day, $Cache_Lifetime);
      if ($cached_data!=-1) {
        // debug info
        $cache_debug_info = "Readed, cc[".$cc."], theme[".$theme."], Access_ID[".$Cache_Access_ID."], Lifetime[".$Cache_Lifetime."], bytes[".strlen($cached_data)."]";
        $nc_cache_calendar->debugMessage($cache_debug_info, __FILE__, __LINE__);
        // return cache data
        return $cached_data;
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_calendar->errorMessage($e);
    }
  }
	
	###_BEGIN:   
	$calendarBody = $settings['dayTemplatePrefix'];
	
	###_BEGIN:   
	$calendarBody.= $settings['dayTemplateBegin'];
	
	#  ,  
	if($settings['DaysName']) {
		$DaysNameArray = split(",", $settings['DaysName']);
		#     ,      :)
		if( !empty($DaysNameArray) && is_array($DaysNameArray) ) {
			$DaysNameArray = array_map("trim", $DaysNameArray);
			$DaysNameArray = array_pad($DaysNameArray, -8, "");
		}
	}
	
	#      
	for($i = 1; $i<=7; $i++) {
		$DayName = $DaysNameArray[$i];
		if( ($i%7)==6 ) $calendarBody.= str_replace("%NAME_DAY", $DayName, $settings['daySETTemplateHeader']);
		elseif( !($i%7) ) $calendarBody.= str_replace("%NAME_DAY", $DayName, $settings['daySUNTemplateHeader']);
		else $calendarBody.= str_replace("%NAME_DAY", $DayName, $settings['dayTemplateHeader']);
	}
	
	$calendarBody.= $settings['dayTemplateEnd'];
	###_END:   
	
	###_BEGIN:  
	$calendarBody.= $settings['dayTemplateBegin'];
	
	#      
	$weekDayBehind = date("w", mktime(0, 0, 0, $month, 1, $year) );
	# 0 - 
	if($weekDayBehind==0) $weekDayBehind=7;
	
	#     
	for($i=1; $i<$weekDayBehind; $i++) {
		# 
		if(($i%7)==6) $calendarBody.= $settings['nodaySETTemplate'];
		# 
		elseif(!($i%7)) $calendarBody.= $settings['nodaySUNTemplate'];
		#     
		else $calendarBody.= $settings['nodayTemplate'];
	} 
	if($weekDayBehind!=1) $lines = $lines + 1;

	#    $month
	$daysInMonth = date("t", mktime(0, 0, 0, $month, 1, $year));

	#  ,  "0",       $month
	$daysMask = array_fill(0, $daysInMonth, $filled ? 1 : 0);
	
	if (!$filled) {
		#    ""  ,     
		if($read_access) {
			# ,    
			$DateFieldExist = nc_calendar_possibility_check($classID, $DateField);
			#    
			if($DateFieldExist) {
				$res = $db->get_col("SELECT DAYOFMONTH(`".$DateField."`)
					FROM `Message".$classID."`
					WHERE `Sub_Class_ID` = '".$cc."'
					AND MONTH(`".$DateField."`) = '".$month."'
					AND YEAR(`".$DateField."`) = '".$year."'
					AND Checked = '1'
					GROUP BY DAYOFMONTH(`".$DateField."`)");
			}
		}
			
		#  ,      - "0",   - "1"
		if( !empty($res) ) {
			foreach($res AS $value) {
				$daysMask[$value-1] = 1;
		    }
		}
	}

	###_BEGIN:  
	for($i=1; $i<=$daysInMonth; $i++) {
		#    ,   (  )
		if($daysMask[$i-1]==1) {
			$dayLinkBegin = "<a href='".$SUB_FOLDER.$Hidden_URL.$year."/".sprintf("%02d", $month)."/".sprintf("%02d", $i)."/'>";
			$dayLinkEnd = "</a>";
		}
		else {
			$dayLinkBegin = $dayLinkEnd = "";
		}
		
		#    
		if( ($weekDayBehind + $i - 1)%7==1 ) {
			if($lines) $calendarBody.= $settings['dayTemplateEnd'].$settings['dayTemplateBegin'];
			$lines = $lines + 1;
		}

    switch (true) {
      case ($weekDayBehind + $i - 1)%7==6 && $i!=$day:
        # 
        $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['daySETTemplate']); 
      break;
      case ($weekDayBehind + $i - 1)%7==0 && $i!=$day:
        # 
        $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['daySUNTemplate']);
      break;
      case $queryDate && $i==$query_date_day && $query_date_month==$month && $query_date_year==$year:
        #  
        $calendarBody.= str_replace("%DAY", ($action=="full" ? $dayLinkBegin.$i.$dayLinkEnd : $i), $settings['dayCurTemplate']);
      break;
      case !$queryDate && $i==$day && date("m")==$month && date("Y")==$year:
        #   + 
        $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['dayCurTemplate']);
      break;
      default:
        #     
        $calendarBody.= str_replace("%DAY", $dayLinkBegin.$i.$dayLinkEnd, $settings['dayTemplate']);
    }

	}
	###_END:  
	
	#      
	$weekDayAfter = date("w", mktime(0, 0, 0, $month, $daysInMonth, $year) );
	# 0 - 
	if($weekDayAfter==0) $weekDayAfter=7;
	
	#  ,    "",   
	$daysEnd = ($antiJumper ? 7*($lines<6 ? 7-$lines : 1) : 7);
	
	#      
	for($i=$weekDayAfter; $i<$daysEnd; $i++) {
		#    
		if(($i+1)%7==1 && $daysEnd>7) $calendarBody.= $settings['dayTemplateEnd'].$settings['dayTemplateBegin'];
		# 
		if((($i+1)%7)==6) $calendarBody.= $settings['nodaySETTemplate'];
		# 
		else if(!(($i+1)%7)) $calendarBody.= $settings['nodaySUNTemplate'];
		#     
		else $calendarBody.= $settings['nodayTemplate'];
	}
	
	$calendarBody.= $settings['dayTemplateEnd'];
	###_END:  
	
	$calendarBody.= $settings['dayTemplateSuffix'];
	###_END:   

	#       
	eval("\$MonthArray = ".NETCAT_MODULE_CALENDAR_MONTH_NAME_ARRAY.";");
	#      ,  
	if( is_array($MonthArray) ) $MonthArray = array_pad($MonthArray, -13, "");

	#   ""
	$month_select = "<select onchange='nc_calendar_generate(".$day.", this.value, ".$year."); return false;'>";
	for($monthCount = 1; $monthCount<=12; $monthCount++) {
		$month_select.= "<option value='".$monthCount."'".($month==$monthCount ? " selected" : "").">".$MonthArray[$monthCount]."</option>";
	}
    $month_select.= "</select>";
	
	#   ""
	$year_select = "<select onchange='nc_calendar_generate(".$day.", ".$month.", this.value); return false;'>";
    $limit = $curr_year + 10; 
	for($yearCount=($curr_year-10); $yearCount<=$limit; $yearCount++) {
		$year_select.= "<option value='".$yearCount."'".($year==$yearCount ? " selected" : "").">".$yearCount."</option>";
	}
    $year_select.= "</select>";
	
	if( $settings['StatusImage'] && file_exists($DOCUMENT_ROOT.$imagesPath.$settings['StatusImage']) ) $IMG_STATUS = true; else $IMG_STATUS = false;
	if( $settings['PrevImage'] && file_exists($DOCUMENT_ROOT.$imagesPath.$settings['PrevImage']) ) $IMG_PREV_MONTH = true; else $IMG_PREV_MONTH = false;
	if( $settings['NextImage'] && file_exists($DOCUMENT_ROOT.$imagesPath.$settings['NextImage']) ) $IMG_NEXT_MONTH = true; else $IMG_NEXT_MONTH = false;
	
	$CalendarHeader = str_replace("%SELECT_MONTH", $month_select, $settings['CalendarHeader']);
	$CalendarHeader = str_replace("%SELECT_YEAR", $year_select, $CalendarHeader);
	
	$CalendarHeader = str_replace("%MONTH_NAME", $MonthArray[(int)$month], $CalendarHeader);
	$CalendarHeader = str_replace("%MONTH_DIGIT", $month, $CalendarHeader);
	$CalendarHeader = str_replace("%YEAR_DIGIT", $year, $CalendarHeader);
		
	$CalendarHeader = str_replace("%IMG_STATUS", ($IMG_STATUS ? "<img src='".$imagesPath.$settings['StatusImage']."' style='display:none;' id='ImgWaiting' alt='waiting' title='waiting' />" : ""), $CalendarHeader);

	$CalendarHeader = str_replace("%IMG_PREV_MONTH", ($IMG_PREV_MONTH ? "<img src='".$imagesPath.$settings['PrevImage']."' onclick='nc_calendar_generate(".($day ? $day : 1).", ".($month==1 ? 12 : $month-1).", ".($month==1 ? $year-1 : $year)."); return false;' alt='".$MonthArray[$month==1 ? 12 : $month-1]."' title='".$MonthArray[$month==1 ? 12 : $month-1]."' />" : "&lt;"), $CalendarHeader);
	$CalendarHeader = str_replace("%MONTH_LINK", ($DateFieldExist ? "<a href='".$Hidden_URL.$year."/".sprintf("%02d", $month)."/'>" : "").$MonthArray[(int)$month].($DateFieldExist ? "</a>" : ""), $CalendarHeader);
	$CalendarHeader = str_replace("%YEAR_LINK", ($DateFieldExist ? "<a href='".$Hidden_URL.$year."/'>" : "").sprintf("%04d", $year).($DateFieldExist ? "</a>" : ""), $CalendarHeader);
	$CalendarHeader = str_replace("%IMG_NEXT_MONTH", ($IMG_NEXT_MONTH ? "<img src='".$imagesPath.$settings['NextImage']."' onclick='nc_calendar_generate(".($day ? $day : 1).", ".($month==12 ? 1 : $month+1).", ".($month==12 ? $year+1 : $year)."); return false;' alt='".$MonthArray[$month==12 ? 1 : $month+1]."' title='".$MonthArray[$month==12 ? 1 : $month+1]."' />" : "&gt;"), $CalendarHeader);
	
	if(!$setDate) {
		$calendarBlockBegin = "<div id='nc_calendar_block'>";
		$calendarBlockEnd = "</div>\r\n<input type='hidden' id='calendar_cc' value='".$cc."' />\r\n<input type='hidden' id='calendar_theme' value='".$theme."' />\r\n<input type='hidden' id='calendar_field' value='".$DateField."' />\r\n<input type='hidden' id='calendar_filled' value='".$filled."' />\r\n<input type='hidden' id='calendar_querydate' value='".$queryDate."' />\r\n";
	}
		
	# , html- 
	$result = $calendarBlockBegin.$settings['CalendarPrefix'].$CalendarHeader.$calendarBody.$settings['CalendarSuffix'].$calendarBlockEnd;
	
  // cache section
  if ( nc_module_check_by_keyword("cache") && $Cache_Access_ID==1 && is_object($nc_cache_calendar) ) {
    try {
      $bytes = $nc_cache_calendar->add($cc, $theme, $DateField, $year."-".$month."-".$day, $result);
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, cc[".$cc."], theme[".$theme."], Access_ID[".$Cache_Access_ID."], Lifetime[".$Cache_Lifetime."], bytes[".$bytes."]";
        $nc_cache_calendar->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_calendar->errorMessage($e);
    }
  }
  
return $result;
}

function nc_calendar_cache () {
  global $MODULE_FOLDER;

  if ( nc_module_check_by_keyword("cache") ) {
    // include need classes
    include_once ($MODULE_FOLDER."cache/function.inc.php");
  }
  
  return;
}

/**
  *     MessageXX  $DateField
  * @param int  
  * @param string  
  * @return bool
  */
function nc_calendar_possibility_check($classID, $DateField = "Date") {
global $db;

	$classID = (int)$classID;
	$DateField = $db->escape($DateField);
	
	if(!$classID || !$DateField) return false;
	
	$table_exist = $db->get_var("SHOW TABLES LIKE 'Message".$classID."'");
	if (!$table_exist) return false;
	$result = $db->get_var("SHOW COLUMNS FROM `Message".$classID."` LIKE '".$DateField."'");

return $result;
}
?>