<?php
/* $Id: index.php 2404 2008-11-18 15:20:08Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
require ($ADMIN_FOLDER."subdivision/function.inc.php");
require ($INCLUDE_FOLDER."s_files.inc.php");
require ($INCLUDE_FOLDER."s_common.inc.php");
require ($ADMIN_FOLDER."catalogue/function.inc.php");

$Delimeter = " &gt ";
$main_section = "control";
$item_id = 1;
$Title2 = CONTROL_CONTENT_CATALOUGE_SITE;
$Title3 = "<a href=\"".$ADMIN_PATH."catalogue/\">".CONTROL_CONTENT_SUBDIVISION_INDEX_SITES."</a>";
$Title5 = GetCatalogueNameByID ($CatalogueID);
$Title6 = "<a href=\"".$ADMIN_PATH."catalogue/?phase=6&CatalogueID=".$CatalogueID."\">".GetCatalogueNameByID ($CatalogueID)."</a>";
$Title7 = CONTROL_CONTENT_CATALOUGE_SITEDELCONFIRM;
$Title8 = GetCatalogueNameByID ($CatalogueID);
$Title9 = CONTROL_CONTENT_CATALOUGE_ADDSECTION;
$Title10 = CONTROL_CONTENT_CATALOUGE_ADDSITE;
$Title11 = GetCatalogueNameByID ($CatalogueID);
$Title12 = CONTROL_CONTENT_CATALOUGE_SITEDELCONFIRM;
$Title13 = CONTROL_CONTENT_CATALOUGE_SITEOPTIONS;


if (!isset($phase)) $phase=1;

switch ($phase) {
	case 1: #show all catalogue
	  BeginHtml ($Title13, $Title3.$Delimeter.$Title6.$Delimeter.$Title13, "http://".$DOC_DOMAIN."/management/sites/settings/");
	  $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, 'viewall', 0, 0, 0);
	  $UI_CONFIG = new ui_list_catalogue();
	  ShowCatalogueList();
	  break;

	case 2: #show form for add\edit catalogue
    if ($type == 1) { #add
      BeginHtml ($Title10, $Title3.$Delimeter.$Title10, "http://".$DOC_DOMAIN."/management/sites/add/");
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_ADD, 0, 0, 0);
      $UI_CONFIG = new ui_config_catalogue('add');
		}
		if ($type == 2) { #edit
		  BeginHtml ($Title13, $Title3.$Delimeter.$Title6.$Delimeter.$Title13, "http://".$DOC_DOMAIN."/management/sites/settings/");
		  $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_EDIT, $CatalogueID, 0, 0);
		  $UI_CONFIG = new ui_config_catalogue('edit', $CatalogueID);
		}
	
		CatalogueForm ($CatalogueID, 3, "index.php", $type);
    break;

	case 3:
		#        
		if ($type == 1) {
          BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/sites/");
          $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_ADD, 0, 0, 1);
		}
		if ($type == 2) {
          BeginHtml ($Title11, $Title3.$Delimeter.$Title5, "http://".$DOC_DOMAIN."/management/sites/info/");
          $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_EDIT, $CatalogueID, 0, 1);
		}

	 if ($Catalogue_Name == "") {
  	nc_print_status(CONTROL_CONTENT_CATALOUGE_ERROR_CASETREE_ONE, 'error');;
  	CatalogueForm ($CatalogueID, 3, "index.php", $type);
  	break;
	 }

	if (!IsAllowedDomain ($Domain, $CatalogueID)) {
  	nc_print_status(CONTROL_CONTENT_CATALOUGE_ERROR_DUPLICATE_DOMAIN, 'error');
  	CatalogueForm ($CatalogueID, 3, "index.php", $type);
  	break;
	}

	if ( strspn(strtolower($Domain), "abcdefghijklmnopqrstuvwxyz0123456789-.") != strlen($Domain) ) {
		nc_print_status(CONTROL_CONTENT_CATALOUGE_ERROR_CASETREE_THREE, 'error');
		CatalogueForm ($CatalogueID, 3, "index.php", $type);
		break;
	}

	if (ActionCatalogueCompleted ($CatalogueID, $type)) {
	  $UI_CONFIG = new ui_config_catalogue('map', $CatalogueID);

    $site = $db->get_row("SELECT Catalogue_ID, Catalogue_Name, Domain, Mirrors, Checked
                          FROM Catalogue
                          WHERE Catalogue_ID = '".$CatalogueID."'", ARRAY_A);
    
    $image = $site['Checked'] ? 'i_site.gif' :'i_site_disabled.gif';

    if ($type == 1) {
      $buttons = array();
      $buttons[] = array("image" => "i_preview.gif",
                               "label" => CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_VIEW,
                               "action" => "window.open('http://". (($site['Domain']) ? $site['Domain'] : $HTTP_HOST) . "');"
                              );

      $buttons[] = array("image" => "i_folder_add.gif",
                               "label" => CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION,
                               "href" => "subdivision.add(0,$site[Catalogue_ID])");
      $UI_CONFIG->treeChanges['addNode'][] = array("nodeId" => "site-$site[Catalogue_ID]",
                 "name" => $site[Catalogue_ID].". ".$site["Catalogue_Name"],
                 "href" => "#site.map($site[Catalogue_ID])",
                 "image" => $image,
                 "hasChildren" => true,
                 "acceptDropFn" => "treeSitemapAcceptDrop",
                 "onDropFn" => "treeSitemapOnDrop",
                 "dragEnabled" => true,
                 "buttons" => $buttons );
      nc_print_status(CONTROL_CONTENT_CATALOUGE_SUCCESS_ADD, 'ok');
      ShowFullSubdivisionList();
    }
    else if ($type == 2) {
      $UI_CONFIG = new ui_config_catalogue('edit', $CatalogueID);
      $UI_CONFIG->treeChanges['updateNode'][] = array("nodeId" => "site-$site[Catalogue_ID]",
                 "name" => $site[Catalogue_ID].". ".$site["Catalogue_Name"],
                 "image" => $image );
      nc_print_status(CONTROL_CONTENT_CATALOUGE_SUCCESS_EDIT, 'ok');
      CatalogueForm ($CatalogueID, 3, "index.php", 2);
    }



	}

	break;

	case 4:
		# ,     
		if (CheckIfDelete()) {
			BeginHtml ($Title12, $Title3.$Delimeter.$Title7, "http://".$DOC_DOMAIN."/management/sites/");
			$perm->ExitIfNotAccess(NC_PERM_ITEM_SITE,NC_PERM_ACTION_DEL, 0, 0, 1 );
			UpdateCataloguePriority ();
			$UI_CONFIG = new ui_config_catalogue('delete', $CatalogueID);
			AscIfDelete (5, "index.php");
		}
		else {
			BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/sites/");
			$perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_DEL, 0, 0, 1);
			UpdateCataloguePriority ();
			$UI_CONFIG = new ui_list_catalogue();
			ShowCatalogueList ();
		}
		
	  break;

	case 5:
		#  
		BeginHtml ($Title13, $Title3.$Delimeter.$Title6.$Delimeter.$Title13, "http://".$DOC_DOMAIN."/management/sites/settings/");
	  $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_DEL, 0, 0, 1);
	  $UI_CONFIG = new ui_list_catalogue();
	  DeleteCatalogue ();
	  ShowCatalogueList();
    break;

	case 6:
		# show info
		BeginHtml ($Title11, $Title3.$Delimeter.$Title5, "http://".$DOC_DOMAIN."/management/sites/info/");
		$perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_INFO, $CatalogueID, 0, 0);
		$UI_CONFIG = new ui_config_catalogue('info', $CatalogueID, 'info');
		ShowMenu ($CatalogueID, 2, "index.php", 11, "index.php");
	  break;

	
}


EndHtml ();
?>
