<?php

ob_start("ob_gzhandler");

define("NC_ADMIN_ASK_PASSWORD", false);

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");

/*
 *   ,       
 */

if (!$perm->isAccessDevelopment() && !$perm->isGuest() ) {
	exit(NETCAT_MODERATION_ERROR_NORIGHT);
}

//echo $node;

list($node_type, $node_id) = explode("-", $node);
if ($node_type != 'group') $node_id = (int)$node_id;

$field_types = array(1 => 'i_type_string.gif',
                     2 => 'i_type_int.gif',
                     3 => 'i_type_text.gif',
                     4 => 'i_type_classificator.gif',
                     5 => 'i_type_bool.gif',
                     6 => 'i_type_file.gif',
                     7 => 'i_type_float.gif',
                     8 => 'i_type_date.gif',
                     9 => 'i_type_link.gif',
                     10 => 'i_type_multiclassificator.gif');

/*
 *        
 */

if ($_GET['action']=='get_path' && ($node_type=='group' || $node_type=='dataclass' || $node_type=='field') && $node_id) {

	switch ($node_type) {
		case 'dataclass':
			$row = $db->get_row("SELECT Class_Group FROM Class WHERE Class_ID = '".$node_id."' AND System_Table_ID=0", ARRAY_A);
			$ret[] = "group-".md5($row[Class_Group]);
		break;
		case 'field':
			$row = $db->get_row("SELECT Class_ID FROM Field WHERE Field_ID = '".$node_id."'", ARRAY_A);
			$ret[] = "dataclass-".$row[Class_ID];
			$row = $db->get_row("SELECT Class_Group FROM Class WHERE Class_ID = '".$row[Class_ID]."' AND System_Table_ID=0", ARRAY_A);
			$ret[] = "group-".md5($row[Class_Group]);
		break;
	}

	$ret[] = "dataclass.list";
	$ret = array_reverse($ret);
	print nc_array_json($ret);
	exit;
}

/*
 *        
 */

if ($_GET['action']=='get_path' && $node_type=='classificator' && $node_id) {
	$ret[] = "classificator.list";
	$ret = array_reverse($ret);
	print nc_array_json($ret);
	exit;
}

if ($_GET['action']=='get_path' && $node_type=='template' && $node_id) {
	while ($node_id) {
		$templates = $db->get_results("SELECT Template_ID, Description, Parent_Template_ID FROM Template WHERE Template_ID = '".$node_id."' ORDER BY Template_ID", ARRAY_A);
		foreach ((array)$templates as $template) {
			$hasChildren = $db->get_var("SELECT COUNT(*) FROM Template WHERE Parent_Template_ID = $template[Template_ID]");
			$ret[] = "template-$template[Template_ID]";
			$node_id = $template[Parent_Template_ID];
		}
	}
	$ret[] = 'templates';
	$ret = array_reverse($ret);
	array_pop($ret);
	print nc_array_json($ret);
	exit;
}

if ($_GET['action']=='get_path' && ($node_type == 'systemclass' || $node_type == 'systemfield') && $node_id) {
	if ($node_type == 'systemfield') {
		$row = $db->get_var("SELECT System_Table_ID FROM Field WHERE Field_ID = $node_id");
		$ret[] = "systemclass-$row[System_Table_ID]";
	}
	$ret[] = 'systemclass.list';
	$ret = array_reverse($ret);
	print nc_array_json($ret);
	exit;
}

$ret = array();
$ret_dev = array();
$ret_groups = array();
$ret_classes = array();
$ret_class_group = array();
$ret_fields = array();
$ret_classificators = array();
$ret_system_class = array();
$ret_system_fields = array();
$ret_templates = array();

/*
 *   
 */


if ($node_type == 'root') {
 //For each buttons make checking - access or no 
  $classes_buttons[] = array("image" => "i_class_import.gif",
                             "label" => CONTROL_CLASS_IMPORT,
                             "href" => "dataclass.import()");
  $classes_buttons[] = array("image" => "i_class_add.gif",
                             "label" => CONTROL_CLASS_ADD,
                             "href" => "dataclass.add()");
  
  if ( $perm->isSupervisor() || $perm->isGuest()) { // Menu class
    $ret_dev[] = array("nodeId" => "dataclass.list",
                 "name" => SECTION_INDEX_DEV_CLASSES,
                 "href" => "#dataclass.list",
                 "image" => 'i_classes.gif',
                 "buttons" => $classes_buttons,
                 "hasChildren" => true,
                 "dragEnabled" => false);
  }
  
  if ( $perm->isSupervisor() || $perm->isGuest() ) { // Menu system tables
    $ret_dev[] = array("nodeId" => "systemclass.list",
                 "name" => SECTION_SECTIONS_OPTIONS_SYSTEM,
                 "href" => "#systemclass.list",
                 "image" => 'i_sysclasses.gif',
                 "hasChildren" => true,
                 "dragEnabled" => false);
  }
  
  if ( $perm->isSupervisor() || $perm->isGuest() ) { // Menu template 
    $templates_buttons[] = array("image" => "i_template_add.gif",
                                 "label" => CONTROL_TEMPLATE_TEPL_CREATE,
                                 "href" => "template.add(0)");
    $ret_dev[] = array("nodeId" => "templates",
                 "name" => SECTION_INDEX_DEV_TEMPLATES,
                 "href" => "#template.list",
                 "image" => 'i_templates.gif',
                 "buttons" => $templates_buttons,
                 "hasChildren" => true,
                 "dragEnabled" => false);
  }
  
  /* ----- CLASSIFICATOR ----- */
  if ( $perm->isAccess(NC_PERM_CLASSIFICATOR, NC_PERM_ACTION_LIST, 0, 0) ) { // Menu classificator
    if( $perm->isAccess(NC_PERM_CLASSIFICATOR, NC_PERM_ACTION_ADD, 0, 0) ){
      $classificators_buttons[] = array("image" => "i_classificator_import.gif",
                                      "label" => CLASSIFICATORS_IMPORT_HEADER,
                                      "href" => "classificator.import()");
      $classificators_buttons[] = array("image" => "i_classificator_add.gif",
                                      "label" => CONTENT_CLASSIFICATORS_ADDLIST,
                                      "href" => "classificator.add()");
    }
    $ret_dev[] = array("nodeId" => "classificator.list",
                       "name" => SECTION_CONTROL_CONTENT_CLASSIFICATOR,
                       "href" => "#classificator.list",
                       "image" => 'i_classificators.gif',
                       "buttons" => $classificators_buttons,
                       "hasChildren" => true,
                       "dragEnabled" => false);
  }

/*
 *   
 */

} elseif ($node_type == 'dataclass.list') {
/*
 *   
 */
  $class_groups = $db->get_results("SELECT Class_Group FROM Class WHERE System_Table_ID=0 GROUP BY Class_Group ORDER BY Class_Group", ARRAY_A);

  foreach ((array)$class_groups as $class_group) {
    $classgroup_buttons = array();
	$classgroup_buttons[] = array("image" => "i_class_add.gif",
        		                  "label" => CONTROL_CLASS_ADD,
                		          "href" => "dataclass.add(".md5($class_group[Class_Group]).")");
    $ret_groups[] = array("nodeId" => "group-".md5($class_group[Class_Group]),
                          "name" => $class_group["Class_Group"],
                          "href" => "#classgroup.edit(".md5($class_group[Class_Group]).")",
                          "image" => 'i_classgroup.gif',
                          "buttons" => $classgroup_buttons,
                          "acceptDropFn" => "treeClassAcceptDrop",
                          "onDropFn" => "treeClassOnDrop",
                          "hasChildren" => true,
                          "dragEnabled" => true);
  }
} elseif ($node_type == 'group' && $node_id) {
/*
 *    
 */
  $classes = $db->get_results("SELECT Class_ID, Class_Name FROM Class WHERE md5(Class_Group) = '$node_id' AND System_Table_ID=0 ORDER BY Class_Group, Class_ID", ARRAY_A);

  foreach ((array)$classes as $class) {
	$hasChildren = $db->get_var("SELECT COUNT(Field_ID) FROM Field WHERE Class_ID = '".$class[Class_ID]."'");
	$class_buttons = array();
	$class_buttons[] = array("image" => "i_field_add.gif",
        		             "label" => CONTROL_FIELD_LIST_ADD,
                		     "href" => "field.add(".$class[Class_ID].")");
	$class_buttons[] = array("image" => "i_class_delete.gif",
        		             "label" => CONTROL_CLASS_DELETE,
                		     "href" => "dataclass.delete(".$class[Class_ID].")");
    $ret_classes[] = array("nodeId" => "dataclass-$class[Class_ID]",
                           "name" => $class["Class_ID"].". ".$class["Class_Name"],
                           "href" => "#dataclass.edit($class[Class_ID])",
                           "image" => 'i_class.gif',
                           "buttons" => $class_buttons,
                           "acceptDropFn" => "treeClassAcceptDrop",
                           "onDropFn" => "treeClassOnDrop",
                           "hasChildren" => $hasChildren,
                           "dragEnabled" => true);
  }
} elseif ($node_type == 'dataclass' && $node_id) {
/*
 *    
 */
  $fields = $db->get_results("SELECT Field_ID, Field_Name, TypeOfData_ID FROM Field WHERE Class_ID = $node_id AND System_Table_ID=0 ORDER BY Priority", ARRAY_A);

  foreach ((array)$fields as $field) {
	$field_buttons = array();
	$field_buttons[] = array("image" => "i_field_delete.gif",
        		             "label" => CONTROL_FIELD_LIST_DELETE,
                		     "href" => "field.delete(".$node_id.",".$field[Field_ID].")");
    $ret_fields[] = array("nodeId" => "field-$field[Field_ID]",
                          "name" => $field["Field_ID"].". ".$field["Field_Name"],
                          "href" => "#field.edit($field[Field_ID])",
                          "image" => $field_types[$field["TypeOfData_ID"]],
                          "buttons" => $field_buttons,
                          "acceptDropFn" => "treeFieldAcceptDrop",
                          "onDropFn" => "treeFieldOnDrop",
                          "hasChildren" => false,
                          "dragEnabled" => true);
  }

/*
 *   
 */

} elseif ($node_type == 'systemclass.list') {
/*
 *   
 */

  $system_classes = $db->get_results("SELECT a.System_Table_ID, a.System_Table_Rus_Name, b.Class_ID, IF(b.AddTemplate<>'' OR b.AddCond<>'' OR b.AddActionTemplate<>'',1,0) AS IsAdd, IF(b.EditTemplate<>'' OR b.EditCond<>'' OR b.EditActionTemplate<>'' OR b.CheckActionTemplate<>'' OR b.DeleteActionTemplate<>'',1,0) AS IsEdit, IF(b.SearchTemplate<>'' OR b.FullSearchTemplate<>'',1,0) AS IsSearch, IF(b.SubscribeTemplate<>'' OR b.SubscribeCond<>'',1,0) AS IsSubscribe FROM System_Table AS a LEFT JOIN Class AS b ON a.System_Table_ID=b.System_Table_ID ORDER BY a.System_Table_ID", ARRAY_A);


  foreach ((array)$system_classes as $system_class) {
	$hasChildren = $db->get_var("SELECT COUNT(Field_ID) FROM Field WHERE System_Table_ID = '".$system_class[System_Table_ID]."'");
	$system_class_buttons = array();
	$system_class_buttons[] = array("image" => "i_field_add.gif",
        		             "label" => CONTROL_FIELD_LIST_ADD,
                		     "href" => "systemfield.add(".$system_class[System_Table_ID].")");
	if ($system_class["Class_ID"]) {
		$href = "#systemclass.edit($system_class[System_Table_ID])";
	} else {
		$href = "#systemclass.fields($system_class[System_Table_ID])";
	}
	$ret_system_class[] = array("nodeId" => "systemclass-$system_class[System_Table_ID]",
                                "name" => $system_class["System_Table_ID"].". ".constant($system_class["System_Table_Rus_Name"]),
                                "href" => $href,
                                "image" => 'i_sysclass.gif',
                                "buttons" => $system_class_buttons,
                                "hasChildren" => $hasChildren,
                                "dragEnabled" => false);
  }
} elseif ($node_type == 'systemclass' && $node_id) {
/*
 *    
 */
  $system_fields = $db->get_results("SELECT field.Field_ID, field.Field_Name, field.TypeOfData_ID FROM Field AS field LEFT JOIN Classificator_TypeOfData AS type ON type.TypeOfData_ID = field.TypeOfData_ID WHERE field.System_Table_ID = '".$node_id."' ORDER BY field.Priority", ARRAY_A);

  foreach ((array)$system_fields as $system_field) {
	$system_field_buttons = array();
	$system_field_buttons[] = array("image" => "i_field_delete.gif",
        		                    "label" => CONTROL_FIELD_LIST_DELETE,
                		            "href" => "systemfield.delete(".$node_id.",".$system_field[Field_ID].")");
    $ret_system_fields[] = array("nodeId" => "systemfield-$system_field[Field_ID]",
                                 "name" => $system_field["Field_ID"].". ".$system_field["Field_Name"],
                                 "href" => "#systemfield.edit($system_field[Field_ID])",
                                 "image" => $field_types[$system_field["TypeOfData_ID"]],
                                 "buttons" => $system_field_buttons,
                                 "acceptDropFn" => "treeSystemFieldAcceptDrop",
                                 "onDropFn" => "treeSystemFieldOnDrop",
                                 "hasChildren" => false,
                                 "dragEnabled" => true);
  }


/*
 *  
 */

} elseif (($node_type == 'template' && $node_id) || ($node_type == 'templates')) {
/*
 *   
 */
	if (!$node_id) $node_id = 0;

	$templates = $db->get_results("SELECT Template_ID, Description FROM Template WHERE Parent_Template_ID = $node_id ORDER BY Template_ID", ARRAY_A);
	foreach ((array)$templates as $template) {
		$hasChildren = $db->get_var("SELECT COUNT(*) FROM Template WHERE Parent_Template_ID = $template[Template_ID]");
		$template_buttons = array();
		$template_buttons[] = array("image" => "i_template_add.gif",
        		                    "label" => CONTROL_TEMPLATE_TEPL_CREATE,
                		            "href" => "template.add(".$template[Template_ID].")");
		if (!$hasChildren) {
			$template_buttons[] = array("image" => "i_template_delete.gif",
        		                    	"label" => CONTROL_TEMPLATE_DELETE,
                		             	"href" => "template.delete(".$template[Template_ID].")");
		}
		$ret_templates[] = array("nodeId" => "template-$template[Template_ID]",
					             "name" => $template["Template_ID"].". ".$template["Description"],
                                 "href" => "#template.edit($template[Template_ID])",
                                 "image" => 'i_template.gif',
                                 "buttons" => $template_buttons,
                                 "hasChildren" => $hasChildren,
                                 "dragEnabled" => false);
	}

/*
 *  
 */

} elseif ($node_type == 'classificator.list') {
/*
 *   
 */
  $query = "SELECT `Classificator_ID`, `Classificator_Name`, `System` FROM `Classificator` ORDER BY `Classificator_ID`"; 
  $classificators = $db->get_results($query, ARRAY_A);
  
  $admin_cl = $perm->isAccess(NC_PERM_CLASSIFICATOR, NC_PERM_ACTION_DEL, 0, 0 );  

  foreach ((array)$classificators as $classificator) {
    $c_id = $classificator['Classificator_ID']; //for short
    
    //   
    if ( !$classificator['System'] && !$perm->isAccess(NC_PERM_CLASSIFICATOR, NC_PERM_ACTION_VIEW, $c_id ) ) continue;
    //       
    if ( $classificator['System'] && !$perm->isDirectAccessClassificator(NC_PERM_ACTION_VIEW, $c_id ) ) continue;

    $classificator_buttons = array();
    //       ,      
    if ( $admin_cl && !$classificator['System'] ) {
              $classificator_buttons[] = array("image" => "i_classificator_delete.gif",
       		                    		 "label" => CONTENT_CLASSIFICATORS_LIST_DELETE,
               		             		 "href" => "classificator.delete(".$c_id.")");
    }
    $ret_classificators[] = array("nodeId" => "classificator-$c_id",
                        		      "name" => $classificator["Classificator_ID"].". ".$classificator["Classificator_Name"],
                        		      "href" => "#classificator.edit($c_id)",
                        		      "image" => 'i_classificator.gif',
                        		      "buttons" => $classificator_buttons,
                        		      "hasChildren" => false,
                        		      "dragEnabled" => false);
    
  }
}



$ret = array_merge(array_values($ret_dev), array_values($ret_groups), array_values($ret_classes), array_values($ret_fields), array_values($ret_classificators), array_values($ret_templates), array_values($ret_class_group), array_values($ret_system_class), array_values($ret_system_fields));

print nc_array_json($ret);

?>