<?
/* $Id: index.php 2349 2008-11-05 20:57:52Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
require ($ADMIN_FOLDER."class/function.inc.php");
require ($ADMIN_FOLDER."field/function.inc.php");

InitVars(); // Initialization field name, field types

if ( !isset($isSys) ) $isSys = 0;
if( isset($ClassID) ) $Id = $ClassID;               
if( isset($SystemTableID) ) $Id = $SystemTableID;  
if ( !isset($Id) ) $Id = $isSys ? GetSystemTableIDByFieldID($FieldID) : GetClassIDByFieldID ($FieldID);

if ($isSys) {
  $main_section = "settings";
  $item_id = 1;
  $Title1 = "<a href=\"".$ADMIN_PATH."field/system.php\">".SECTION_SECTIONS_OPTIONS_SYSTEM."</a>";
  $Title2 = CONTROL_FIELD_FIELDS." (".GetSystemTableRusName ($SystemTableID).")";
  $Title3 = "<a href=\"".$ADMIN_PATH."field/systemField.php?SystemTableID=".$SystemTableID."\">".CONTROL_FIELD_FIELDS." (".GetSystemTableRusName ($SystemTableID).")</a>";
  $DocPath = "http://".$DOC_DOMAIN."/settings/systables/fields/"; 
}
else{
  $main_section = "control";
  $item_id = 8;
 
  $Title1 = "<a href=\"".$ADMIN_PATH."class/\">".CONTROL_CLASS."</a>";
  $Title2 = CONTROL_FIELD_FIELDS." (".GetClassNameByID($ClassID).")";
  $Title3 = "<a href=\"".$ADMIN_PATH."field/?ClassID=".$ClassID."\">".CONTROL_FIELD_FIELDS." (".GetClassNameByID($ClassID).")</a>";
  $DocPath = "http://".$DOC_DOMAIN."/management/class/fields/"; 
}
  $Title4 = CONTROL_FIELD_ADDING;
  $Title5 = GetFieldName ($FieldID);
  $Title6 = CONTROL_FIELD_EDITING;
  $Delimeter = " &gt ";




if (!isset($phase)) $phase=1;

switch ($phase) {
	case 1:
		#    
    BeginHtml ($Title2, $Title1.$Delimeter.$Title2, $DocPath);
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 0);
    $UI_CONFIG = $isSys ? new ui_config_system_class('fields', $Id) : new ui_config_class('fields', $Id);
    FieldList ($Id, $isSys);
  	break;

	case 2:
    #    
    BeginHtml ($Title4, $Title1.$Delimeter.$Title3.$Delimeter.$Title4, $DocPath."form/");
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 0);
    $UI_CONFIG = new ui_config_field('add', 0, $Id, $isSys);  
    FieldForm (0, $Id, $isSys);
  	break;

	case 3:
    #      
    global $field_types, $type_of_error;
    BeginHtml ($Title2, $Title1.$Delimeter.$Title2, $DocPath);
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 1);
        
    $new_id = FieldCompleted();
    if ($new_id <= 0){ #error
      $UI_CONFIG = new ui_config_field('add', 0, $Id, $isSys);
      nc_print_status($type_of_error[-$new_id], 'error');
      FieldForm (0, $Id, $isSys);
    }
    else { #ok
      nc_print_status(CONTROL_FIELD_MSG_ADDED, 'ok');
      $UI_CONFIG = $isSys ? new ui_config_system_class('fields', $Id) : new ui_config_class('fields', $Id); 
      FieldList($Id, $isSys);
      
      $field = $db->get_row("SELECT field.`Field_ID`, field.`Field_Name`, field.`TypeOfData_ID` 
                             FROM `Field` AS field 
                             LEFT JOIN `Classificator_TypeOfData` AS type 
                             ON type.`TypeOfData_ID` = field.`TypeOfData_ID` 
                             WHERE field.`Field_ID` = '".$new_id."' 
                             ORDER BY field.`Priority`", ARRAY_A);

      $field_buttons[] = array("image" => "i_field_delete.gif",
    		                       "label" => CONTROL_FIELD_LIST_DELETE,
            		               "href" => "field.delete(".$Id.",".$new_id.")");

      $UI_CONFIG->treeChanges['addNode'][] = array("nodeId" => $isSys ? "systemfield-".$new_field_id : "field-".$new_id,
                             "parentNodeId" => $isSys ? "systemclass-".$Id : "dataclass-".$Id, 
                             "name" => $new_id.". ".$field["Field_Name"],
                             "href" => $isSys ?  "#systemfield.edit(".$new_id.")" : "#field.edit(".$new_id.")",
                             "image" => $field_types[$field["TypeOfData_ID"]],
                             "buttons" => $field_buttons,
                             "acceptDropFn" => $isSys ? "treeSystemFieldAcceptDrop" : "treeFieldAcceptDrop",
                             "onDropFn" => $isSys ? "treeSystemFieldOnDrop" : "treeFieldOnDrop",
                             "hasChildren" => false,
                             "dragEnabled" => true,
                             "parentMustBeLoaded" => true);
    }
    break;

	case 4:
    #       
    BeginHtml ($Title6, $Title1.$Delimeter.$Title3.$Delimeter.$Title5, $DocPath."form/");
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 0);
    $UI_CONFIG = new ui_config_field('edit', $FieldID, $Id, $isSys);
    FieldForm ($FieldID, 0, $isSys);
  	break;

	case 5:
    #   
    BeginHtml ($Title2, $Title1.$Delimeter.$Title2, $isSys);
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 1);
       
    if (($errorcode = FieldCompleted()) > 0 ) { #ok
      nc_print_status(CONTROL_FIELD_MSG_EDITED, 'ok');
      $UI_CONFIG = new ui_config_field('edit', $FieldID, 0, $isSys);
      $UI_CONFIG->updateTreeFieldNode($FieldID, $TypeOfDataID);
    }
    else { #error
      $UI_CONFIG = new ui_config_field('add', 0, $Id, $isSys);
      nc_print_status($type_of_error[-$errorcode], 'error');
    }  
    
    FieldForm ($FieldID, 0, $isSys);   
    break;
    
  case 6:
    #      
    BeginHtml ($Title2, $Title1.$Delimeter.$Title2, $DocPath);
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 1);
        
    if ($Delete) {
      $UI_CONFIG = new ui_config_field('delete', 0, $Id, $isSys);
      ConfirmFieldsRemoval($Delete, $Id, $isSys);
    } 
    else {
      $UI_CONFIG = $isSys ? new ui_config_system_class('fields', $Id) : new ui_config_class('fields', $Id); 
      UpdateFieldPriority($priority);
      nc_print_status(CONTROL_FIELD_MSG_FIELDS_CHANGED, 'ok');
      FieldList($Id, $isSys);
    }
    break;
        
	case 7:
    #     
    BeginHtml ($Title2, $Title1.$Delimeter.$Title2, $DocPath);
    $perm->ExitIfNotAccess(NC_PERM_FIELDS, 0, 0, 0, 1);
    $UI_CONFIG = $isSys ? new ui_config_system_class('fields', $Id) : new ui_config_class('fields', $Id);    

    UpdateFieldPriority($priority);
    
    if (DeleteFields($Delete) > 1) {
      nc_print_status(CONTROL_FIELD_MSG_DELETED_MANY, 'ok');
    } 
    else {
      nc_print_status(CONTROL_FIELD_MSG_DELETED_ONE, 'ok');
    }
    
    FieldList($Id, $isSys);
	  break;
}

EndHtml();

?>
