<?
/* $Id: function.inc.php 2299 2008-10-03 14:19:03Z vadim $ */

###############################################################

function InstallationAborted ()
{
    global $TMP_FOLDER;

    print TOOLS_MODULES_ERR_INSTALL.".<br>\n";
    DeleteFilesInDirectory ($TMP_FOLDER);
    EndHtml ();
    exit;
}

###############################################################

function UninstallationAborted ()
{
    global $TMP_FOLDER;

    print TOOLS_MODULES_ERR_UNINSTALL.".<br>\n";
    DeleteFilesInDirectory ($TMP_FOLDER);
    EndHtml ();
    exit;
}

#########################
#    :)
########################
function GetSiteLang ($CatalogueID)
{
    global $db;

	if ($CatalogueID)
	{
		$res=$db->get_var("SELECT Language FROM Catalogue WHERE Catalogue_ID='".$CatalogueID."' LIMIT 1");
		if(!is_null($res))
		{
			return($res);
		}
		else
		{
			return(false);
		}
	}
	else
	{
		$current_catalogue = $db->get_row("SELECT * FROM Catalogue LIMIT 1",ARRAY_A);
		if ($current_catalogue['Language'])
			return($current_catalogue['Language']);
		else
			return(false);
	}
}

###############################################################

function LoadID ()
{
    global $TMP_FOLDER;
    global $Keyword, $SystemVersion, $SystemID, $Patch, $Name;
    global $ExampleURL, $HelpURL, $Description, $Parameters, $SysMessage;

    $FileID = "id.txt";
    $fp = fopen ($TMP_FOLDER.$FileID, "r");
    $Keyword = chop (fgets($fp, 4096));
    $SystemID = chop (fgets($fp, 4096));
    $SystemVersion = chop (fgets($fp, 4096));
    $Patches = chop (fgets($fp, 4096));

    $tok = strtok($Patches," ");
    while ($tok)
    {
        $Patch [] = $tok;
        $tok = strtok(" ");
    }

    $Name = chop (fgets($fp, 4096));
    $ExampleURL = chop (fgets($fp, 4096));
    $HelpURL = chop (fgets($fp, 4096));
    $Description = chop (fgets($fp, 4096));

    fclose ($fp);

    $FileParam = "parameters.txt";
    $fp = fopen ($TMP_FOLDER.$FileParam, "r");
    while (!feof ($fp))
    {
        $Parameters .= fgets($fp, 4096);
    }
    fclose ($fp);
    if (MAIN_LANG!="ru")
    {
        $SysMessage = join("",@file($TMP_FOLDER."message_int.txt"));
    }
    else
    {
        $SysMessage = join("",@file($TMP_FOLDER."message.txt"));
    }

}

###############################################################

function CopyFiles () {
    global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $DOCUMENT_ROOT;
    global $Keyword;

    @mkdir ($MODULE_FOLDER.$Keyword, 0775);

    copy ($TMP_FOLDER."index.php", $MODULE_FOLDER.$Keyword."/index.php");
    copy ($TMP_FOLDER."function.inc.php", $MODULE_FOLDER.$Keyword."/function.inc.php");
    copy ($TMP_FOLDER."en.lang.php", $MODULE_FOLDER.$Keyword."/en.lang.php");
    copy ($TMP_FOLDER."ru.lang.php", $MODULE_FOLDER.$Keyword."/ru.lang.php");

    if(is_readable($TMP_FOLDER."admin.php"))	copy ($TMP_FOLDER."admin.php", $MODULE_FOLDER.$Keyword."/admin.php");
    if(is_readable($TMP_FOLDER."admin.inc.php"))	copy ($TMP_FOLDER."admin.inc.php", $MODULE_FOLDER.$Keyword."/admin.inc.php");
    if(is_readable($TMP_FOLDER."setup.php"))	copy ($TMP_FOLDER."setup.php", $MODULE_FOLDER.$Keyword."/setup.php");

    $FileList = "files.txt";
    $fp = fopen ($TMP_FOLDER.$FileList, "r");
    while (!feof ($fp)) {
        $file_name = chop (fgets($fp, 4096));
        if (strlen ($file_name) == 0) break;
        copy ($TMP_FOLDER.$file_name, $MODULE_FOLDER.$Keyword."/".basename($file_name));
    }
    fclose ($fp);

}

###############################################################

function CheckFiles ()
{
    global $TMP_FOLDER;

    if (!is_readable ($TMP_FOLDER."id.txt") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." id.txt.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."sql.txt") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." sql.txt.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."sql_int.txt") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." sql_int.txt.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."files.txt") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." files.txt.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."parameters.txt") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." parameters.txt.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."index.php") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." index.php.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."install.php") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." install.php.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."function.inc.php") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." function.inc.php.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."en.lang.php") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." en.lang.php.<br>\n";
        InstallationAborted ();
    }

    if (!is_readable ($TMP_FOLDER."ru.lang.php") )
    {
        print TOOLS_MODULES_ERR_CANTOPEN." ru.lang.php.<br>\n";
        InstallationAborted ();
    }

    if (MAIN_LANG!="ru")
    {
        if (!is_readable ($TMP_FOLDER."message_int.txt") )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." message_int.txt.<br>";
            InstallationAborted ();
        }
    }
    else
    {
        if (!is_readable ($TMP_FOLDER."message.txt") )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." message.txt.<br>";
            InstallationAborted ();
        }
    }
}

###############################################################

function CheckDeps () {
global $TMP_FOLDER, $db, $Patch;

	$ReturnValue = 1;
	LoadID ();
	if (!count($Patch))	return $ReturnValue;

	$Array = $db->get_col("SELECT `Patch_Name` FROM `Patch`");

	while ( list($key, $val) = each($Patch) ) {
		$cmp = 0;
		for ($i=0; $i<count($Array); $i++) {
			if ( strcmp( (int)sprintf("%0-3s", $Array[$i]), (int)sprintf("%0-3s", $val) )==0 ) {
				$cmp++;
				break;
			}
		}
		if ($cmp==0) {
			print TOOLS_MODULES_ERR_PATCH." ".$val.".<br>\r\n";
			$ReturnValue = 0;
		}
	}

return $ReturnValue;
}

###############################################################

function IsAlreadyInstalled ()
{
    global $TMP_FOLDER, $db;
    global $Keyword;

    $select = "select Keyword from Module where Keyword='".$Keyword."'";
    $Result = $db->query ($select);
    if ( $db->num_rows > 0 )
    {
        return 1;
    }
    return 0;
}

###############################################################

function ModuleList ()
{
    global $db;
    global $DOMAIN_NAME, $MODULE_FOLDER, $SUB_FOLDER, $HTTP_ROOT_PATH, $ADMIN_TEMPLATE;

    if ($Result = $db->get_results ("select Module_ID,Module_Name,Description,Keyword,Installed from Module", ARRAY_A) )
    {
    ?>
    <table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

    <table border=0 cellpadding=4 cellspacing=1 width=100%>
    <tr>
    <td bgcolor=eeeeee><font size=-2><b>ID</td>
    <td bgcolor=eeeeee width=80%><font size=-2><b><?=TOOLS_MODULES_MOD_NAME?></b></td>
    <td bgcolor=eeeeee align=center><font size=-2><b><?=TOOLS_MODULES_MOD_PREFS?></b></td>
    </tr>
    <?

    foreach ($Result as $Array  )
    {

        $keyword=$Array["Keyword"];

        if ($Array["Keyword"]!='default')
        {
            if(file_exists($MODULE_FOLDER.$keyword."/".MAIN_LANG.".lang.php"))
            {
                require_once($MODULE_FOLDER.$keyword."/".MAIN_LANG.".lang.php");
            }
            else
            {
                require_once($MODULE_FOLDER.$keyword."/en.lang.php");
            }
        }


        $str = "<tr><td bgcolor=white><font size=-2><b>".$Array["Module_ID"]."</td>".
        "<td bgcolor=white><table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td>".(file_exists($MODULE_FOLDER.$Array["Keyword"]."/admin.php")?"<a href=".$SUB_FOLDER.$HTTP_ROOT_PATH."modules/".$Array["Keyword"]."/admin.php>":"").constant($Array["Module_Name"]).(file_exists($MODULE_FOLDER.$keyword."/admin.php")?"</a>":"")."</td><td align=right>".((file_exists($MODULE_FOLDER.$keyword."/setup.php") && ($Array["Installed"]=="0"))?"<a href=".$SUB_FOLDER.$HTTP_ROOT_PATH."modules/".$keyword."/setup.php><font size=-2 color=cc3300><b>".TOOLS_MODULES_MOD_GOINSTALL." &raquo;":"")."</td></tr></table></td>".
        "<td align=center bgcolor=white><a href=\"index.php?phase=2&&module_name=".$keyword."\"><img border=0 src='".$ADMIN_TEMPLATE."img/i_settings.gif' width='16' height='16' alt='".TOOLS_MODULES_MOD_EDIT."' title='".TOOLS_MODULES_MOD_EDIT."'></a></td>";

        print($str);
        unset($str);

    }
    print "</table></td></tr></table>";
    }

}

###############################################################

function ModuleUpdateForm ($ModuleID) {
  global $db, $MODULE_FOLDER;
  global $ADMIN_PATH, $ADMIN_TEMPLATE;

  $Array = $db->get_row("SELECT * FROM `Module` WHERE `Module_ID` = '".$ModuleID."'", ARRAY_A);

  $keyword=$Array["Keyword"];

  if ($Array["Keyword"]!='default') {
    if(file_exists($MODULE_FOLDER.$keyword."/".MAIN_LANG.".lang.php")) {
        require_once($MODULE_FOLDER.$keyword."/".MAIN_LANG.".lang.php");
    } else {
        require_once($MODULE_FOLDER.$keyword."/en.lang.php");
    }
  }
  ?>
  <form method='post' action='index.php'>
  <font color='gray'>
  <?=constant($Array["Description"])?><br/><br/>

  <table cellpadding='5' cellspacing='1' style='background:#CCC; width:100%; border:none' id='tableParam'> 
     <col style='width:35%'/><col style='width:60%'/><col style='width:5%'/>
      <tbody>
       <tr>
          <td style='background:#EEE' align='center'><font size='-2'><b><?=NETCAT_MODULES_PARAM?></b></font></td>
          <td style='background:#EEE' align='center' ><font size='-2'><b><?=NETCAT_MODULES_VALUE?></b></font></td>
          <td style='background:#EEE' align='center'><img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
       </tr>

  <?php
  $ParamArray = ConvertToDiffer($Array["Parameters"]);
  
  foreach ( $ParamArray as $k => $v ){
    print "<tr>\n";
    print " <td style='background:#FFF'><input type='text' value='".$k."' style = 'width:100%' name='Name_".$k."'></td>\n"; 
    print " <td style='background:#FFF'><input type='text' value='".$v."' style = 'width:100%' name='Value_".$k."'></td>\n";
    print " <td style='background:#FFF' align='center'><input type='checkbox' name='Delete_".$k."'></td>\n";
    print "</tr>\n";
  }
  print "</tbody></table>\n";
  print "<input type='hidden' name='ModuleID' value=".$ModuleID.">\n";
  print "<input type='hidden' name='phase' value='3'>";

  global $UI_CONFIG, $module_name;
  print "<input type='hidden' name='module_name' value='".$module_name."'></form>";
  
  $UI_CONFIG = new ui_config_module($module_name, 'settings');
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                      "action" => "mainView.submitIframeForm()");
  $UI_CONFIG->actionButtons[] = array("id" => "addparam",
                                      "caption" => NETCAT_MODULES_ADDPARAM,
                                      "align" => "left",
                                      "action" => "AddNewParam(); return false;" );
}

###############################################################

function AddModuleForm () {
  global $db, $UI_CONFIG;

  echo "<form enctype='multipart/form-data' action='index.php' method='POST''>";
  echo "<input type='hidden' name='MAX_FILE_SIZE' value='1000000'>";
  echo "<fieldset>";
  echo "<legend><b>".TOOLS_MODULES_MOD_LOCAL."</b></legend>";
  echo "<input size='60' name='FilePatch' type='file'>";
  echo "</fieldset>";
  echo "<input type='hidden' name='phase' value='4'>";
  echo "<input type='submit' class='hidden'>";
  echo "</form>";
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => CONTROL_CLASS_IMPORT_UPLOAD,
                                      "action" => "mainView.submitIframeForm()");

}

/**
 *    
 * 
 * @return boolean true
 */

function ModuleUpdateCompleted() {
  global $db;

  reset($_POST);
  $Parameters = "";
 
  while (list($key, $val) = each($_POST)) {
    $key = trim($key);
    $val = trim($val);
    
    if (substr($key,0,4)=="Name") {
      if( $add && $tmpParam)
        $Parameters .= $tmpParam;
      $add = 1;
      $tmpParam = $val;
      $tmpParam .= "=";
      if( !$val )
          $add = 0;
    }
    else if (substr($key,0,5)=="Value") {
            $tmpParam .= $val;
            $tmpParam .= "\n";
    }
    
    else if (substr($key,0,6)=="Delete") {
           $add = 0;
    }
     
  }
   if( $add && $tmpParam)
        $Parameters .= $tmpParam;
        
  $ModuleID = $_POST['ModuleID'];

  if ($db->query("UPDATE Module SET Subdivision_ID='".$SubdivisionID."',Parameters='".$Parameters."' WHERE Module_ID='".$ModuleID."'")) {
    //        .
    nc_print_status(TOOLS_MODULES_PREFS_SAVED, 'ok');
  } else {
    nc_print_status(TOOLS_MODULES_PREFS_ERROR, 'error');
  }
  
  return true;
}


function TitleModule ()
{
    global $perm, $PLUGS_INSTALL_TYPE;

    if ( ($perm->isSupervisor() || $perm->isGuest()) && $PLUGS_INSTALL_TYPE=="int") AddModuleForm ();
    elseif ($PLUGS_INSTALL_TYPE=="ext") echo TOOLS_MODULES_MOD_INSTALL_EXT."<br><br>";
    ModuleList ();
}



/**
 * Convert parametr to diffrent parametrs
 * @param str 
 * @return array, hash - name of param
 */
function ConvertToDiffer ( $parametrs ) {
  $ret = Array();
  $parametr = explode( "\n", $parametrs );

  foreach ( $parametr as  $v) {
    $param_name = trim(strtok( $v, "=" ));
    $parm_value = trim(strtok(""));
    if( $param_name && substr($param_name, 0, 1) != '/' && substr($param_name, 0, 1) != '#' )
      $ret[$param_name] = $parm_value ;
  }
  
  return $ret;
}


?>