<?php
/* $Id: subdivision.inc.php 2336 2008-10-25 15:19:07Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require($ADMIN_FOLDER.'consts.inc.php');

function UpdateHiddenURL ($parent_url, $parent_sub, $catalogue) {
    global $db;

    $res = $db->get_results("SELECT EnglishName,Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID='$parent_sub' AND Catalogue_ID='$catalogue'",ARRAY_N);
    $subCount = $db->num_rows;
    for ($i=0; $i<$subCount; $i++) list($english_name[$i],$sub_id[$i]) = $res[$i];

    for ($i=0; $i<$subCount; $i++) {
        $new_parent_url = $parent_url.$english_name[$i]."/";

        $res = $db->query("UPDATE Subdivision SET Hidden_URL = '".$new_parent_url."',LastUpdated=LastUpdated where Subdivision_ID='".$sub_id[$i]."'");
        UpdateHiddenURL($new_parent_url, $sub_id[$i], $catalogue);
    }
}

function GetHiddenURL ($SubdivisionID) {
    global $db;
    $hidden_url = $db->get_var("SELECT Hidden_URL FROM Subdivision WHERE Subdivision_ID='".$SubdivisionID."'");
    return $hidden_url;
}

function UpdateSubdivisionName ($SubdivisionID, $SubdivisionName)
{
    global $db;

    $update = "UPDATE Subdivision SET Subdivision_Name='";
    $update .= htmlspecialchars($SubdivisionName)."' WHERE Subdivision_ID='".$SubdivisionID."'";
    $UpdateResult = $db->query ($update);
    if ($UpdateResult)
    print '   .<br>';
    else
    print '   . !<br>';
}

function UpdateParentSubID($SubdivisionID, $NewParentSubID)
{
    global $db;

    $update  = "UPDATE Subdivision SET Parent_Sub_ID='{$NewParentSubID}' ";
    $update .= "WHERE Subdivision_ID='{$SubdivisionID}'";
    $Result = $db->query($update);
    if ($Result)
    return 1;
    else
    return 0;
}

function IsSubdivisionExist($SubdivisionID)
{
    global $db;
    $select = "SELECT Subdivision_ID FROM Subdivision WHERE Subdivision_ID='{$SubdivisionID}'";
    $Result = $db->query ($select);
    $num_rows = $db->num_rows;
    if ($num_rows > 0)
    return 1;
    else
    return 0;
}

function ChildrenNumber($SubdivisionID) {
global $db, $perm;

	#  sql-,    ,    
	$security_limit = "";
	$access = false;
	$Array = array();

	if ( $perm->isDirector() || $perm->isSupervisor() ) {
		return $db->get_var("SELECT COUNT(Subdivision_ID) FROM `Subdivision` AS a WHERE Parent_Sub_ID = '{$SubdivisionID}'");
	}
	
	# id ,    
	$catalogue_admin = $perm->listItems('catalogue');
	if ( !empty($catalogue_admin) ) $access = true;

	# id ,    
	$sub_admin = $perm->listItems('subdivision');
	if ( !empty($sub_admin) ) $access = true;
	
	# id   ,    
	$cc_admin = $perm->listItems('subclass');
	if ( !empty($cc_admin) ) $access = true;

	if (!$access) return false;
		
	# id ,   ,   $sub_admin + $cc_admin
	$sub_and_cc_admin = $sub_admin;

	if ($cc_admin) {
		$res = $db->get_results("SELECT `Subdivision_ID`
			FROM `Sub_Class`
			WHERE `Sub_Class_ID` IN (".join(',', $cc_admin).")", ARRAY_A);
		foreach ($res AS $row) {
			$sub_and_cc_admin[] = $row['Subdivision_ID'];
		}
	}
	
	if ( !empty($sub_and_cc_admin) || !empty($catalogue_admin) ) {
		#     ,   
		#   
		$res = $db->get_results("SELECT parent.Subdivision_ID
			FROM `Subdivision` AS parent, `Subdivision` AS allowed
			WHERE (allowed.Subdivision_ID IN (".join(',', array_unique($sub_and_cc_admin)).")
			OR allowed.Catalogue_ID IN (".join(',', array_unique($catalogue_admin))."))
			AND allowed.Hidden_URL LIKE CONCAT(parent.Hidden_URL, '%')", ARRAY_A);

		# ,    
		$allowed_subs = array();
		foreach ((array)$res AS $row) {
			$allowed_subs[] = $row['Subdivision_ID'];
		}


		# id ,      ,        --    (as of 3.0)
		
		$sub_child_administrator = array();
		#     
		$res = $db->get_results("SELECT child.Subdivision_ID, allowed.Subdivision_ID AS Allowed_Subdivision_ID
			FROM Subdivision AS child, Subdivision AS allowed
			WHERE allowed.Subdivision_ID IN (".join(',', array_unique($sub_admin)).")
			AND child.Hidden_URL LIKE CONCAT(allowed.Hidden_URL, '_%')", ARRAY_A);
		
		foreach ((array)$res as $row) {
			$allowed_subs[] = $row['Subdivision_ID'];
			$sub_child_administrator[ $row['Subdivision_ID'] ] = $row['Allowed_Subdivision_ID'];
		}

		if ($allowed_subs) {
			$qry_where.= " AND a.Subdivision_ID IN (".join(',', $allowed_subs).") ";
		}
	}

	$Array = $db->get_var("SELECT COUNT(Subdivision_ID) FROM `Subdivision` AS a WHERE Parent_Sub_ID = '{$SubdivisionID}'$qry_where");

return $Array;
}

function GetParentSubID($SubdivisionID)
{
    global $db;
    $ResultArray = $db->get_var("SELECT Parent_Sub_ID FROM Subdivision WHERE Subdivision_ID='{$SubdivisionID}'");
    return $ResultArray;
}

function GetSubClassCount($SubdivisionID)
{
    global $db;
    $ResultArray = $db->get_var( "SELECT COUNT(*) FROM Sub_Class WHERE Subdivision_ID='{$SubdivisionID}'");
    return $ResultArray;
}

function DeleteFromSubClass($SubdivisionID) {
  global $db, $MODULE_FOLDER;

	$res = $db->get_results("SELECT `Catalogue_ID`, `Sub_Class_ID`, `Class_ID` FROM `Sub_Class` WHERE `Subdivision_ID` = '".(int)$SubdivisionID."'", ARRAY_A);
	if ($res) {
    $CatalogueID = $res[0]['Catalogue_ID'];
		foreach ($res as $val) {
			DeleteSubClassFiles ($val['Sub_Class_ID'], $val['Class_ID']);
      $subclass_to_delete_arr[] = $val['Sub_Class_ID'];
      $cache_class_arr[] = $val['Class_ID'];
		}
	}

  if ( nc_module_check_by_keyword("comments") ) {
    if ( !empty($subclass_to_delete_arr) ) {
      include_once ($MODULE_FOLDER."comments/function.inc.php");
      // delete comment rules
      nc_comments::dropRuleSubClass($db, $subclass_to_delete_arr);
      // delete comments
      nc_comments::dropComments($db, $subclass_to_delete_arr, "Sub_Class");
    }
  }
  
  if ( nc_module_check_by_keyword("cache") ) {
    include_once ($MODULE_FOLDER."cache/function.inc.php");
    // init listener
    $nc_cache_listener = nc_cache_listener::getObject();
    // delete cache
    if ($CatalogueID && $subclass_to_delete_arr) {
      $nc_cache_listener->event("dropSubClass", $CatalogueID, $SubdivisionID, $subclass_to_delete_arr);
    }
    if ($cache_class_arr) {
      $nc_cache_listener->event("dropClass", $cache_class_arr);
    }
  }
  
  $db->query("DELETE FROM `Sub_Class` WHERE `Subdivision_ID` = '".(int)$SubdivisionID."'");
 
  return;
}

function DeleteFromPermission ($SubdivisionID)
{
    global $db;

    $delete = "DELETE FROM Permission WHERE AdminType=";
    $delete .= SUBDIVISION_ADMIN;
    $delete .= " AND Catalogue_ID='{$SubdivisionID}'";

    $db->query($delete);
}

function DeleteMessages($SubdivisionID)
{
    global $db;

    $ClassResult = $db->get_col("SELECT Class_ID FROM Class WHERE Class_ID<>0 AND System_Table_ID=0");

    if ($ClassResult) {
		foreach ($ClassResult as $ClassID) {
			$DeleteMessage = "DELETE FROM Message".$ClassID." WHERE Subdivision_ID='{$SubdivisionID}'";
			$res = $db->query ($DeleteMessage);
		}
    } else {
	    return;
    }
}


class SubdivisionLocation
{
    var $CatalogueID, $ParentSubID, $SubdivisionID;

    function SubdivisionLocation ()
    {
        global $CatalogueID, $ParentSubID, $SubdivisionID;
        global $db;

        if ($SubdivisionID)
        {
            $this->SubdivisionID = $SubdivisionID;
            $Array = $db->get_row("SELECT Catalogue_ID, Parent_Sub_ID FROM Subdivision WHERE Subdivision_ID='{$SubdivisionID}'",ARRAY_A);
            $this->ParentSubID = $Array['Parent_Sub_ID'];
            $this->CatalogueID = $Array['Catalogue_ID'];
        }
        else
        {
            $this->SubdivisionID = 0;

            if (isset($ParentSubID) && $ParentSubID)
            $this->ParentSubID = $ParentSubID;
            else
            $this->ParentSubID = 0;

            if ($this->ParentSubID)
            {
                $this->CatalogueID = $db->get_var("SELECT Catalogue_ID FROM Subdivision WHERE Subdivision_ID='".$this->ParentSubID."'");
            }
            else
            {
                if (isset($CatalogueID) && $CatalogueID)
                $this->CatalogueID = $CatalogueID;
                else
                $this->CatalogueID = 0;
            }
        }
    }

    function printVars ()
    {
        print "SubdivisionLocation.CatalogueID=".$this->CatalogueID."<br>\n";
        print "SubdivisionLocation.ParentSubID=".$this->ParentSubID."<br>\n";
        print "SubdivisionLocation.SubdivisionID=".$this->SubdivisionID."<br>\n";
    }
}

function IsAllowedSubdivisionEnglishName($EnglishName, $ParentSubID, $SubdivisionID, $CatalogueID)
{
    global $db;

    if (!$EnglishName) return 0;

    $select  = "SELECT EnglishName FROM Subdivision WHERE EnglishName='".$EnglishName."' AND Parent_Sub_ID='".$ParentSubID."'";
    $select .= " AND EnglishName<>'' AND Subdivision_ID<>'".$SubdivisionID."' AND Catalogue_ID='".$CatalogueID."'";

    $Result = $db->query($select);
    $num_rows = $db->num_rows;

    if ($num_rows == 0)  return 1;

    return 0;
}

function CascadeDeleteSubdivision ($SubdivisionID) {
  global $db, $MODULE_FOLDER;
  
  $CatalogueID = $db->get_var("SELECT `Catalogue_ID` FROM `Subdivision` WHERE `Subdivision_ID` = '".(int)$SubdivisionID."'");
  
  if ( nc_module_check_by_keyword("comments") ) {
    include_once ($MODULE_FOLDER."comments/function.inc.php");
    // delete comment rules
    nc_comments::dropRule( $db, array($CatalogueID, $SubdivisionID) );
    // delete comments
    nc_comments::dropComments($db, $SubdivisionID, "Subdivision");
  }
  
  if ( nc_module_check_by_keyword("cache") ) {
    include_once ($MODULE_FOLDER."cache/function.inc.php");
    // init listener
    $nc_cache_listener = nc_cache_listener::getObject();
    // delete cache
    $nc_cache_listener->event("dropSubdivision", $CatalogueID, $SubdivisionID);
  }
  
  $LockQuery = 'LOCK TABLES `Subdivision` WRITE, `Class` WRITE, `Sub_Class` WRITE, `Permission` WRITE, `Field` WRITE, `Filetable` WRITE';

  $ClassResult = $db->get_col("SELECT `Class_ID` FROM `Class` WHERE `System_Table_ID` = 0");
  foreach ($ClassResult AS $class_id  ) {
    $LockQuery.= ", `Message".$class_id."` WRITE";
  }
  
  if ( nc_module_check_by_keyword("cache") ) {
    // delete cache
    $nc_cache_listener->event("dropClass", $ClassResult);
  }

  $LockResult = $db->query($LockQuery);

  $delete = "DELETE FROM `Subdivision` WHERE `Subdivision_ID` = '".(int)$SubdivisionID."'";
  
  if ( $db->query($delete) ) {
    DeleteFromSubClass($SubdivisionID);
    DeleteSubdivisionDir($SubdivisionID);
    DeleteFromPermission($SubdivisionID);
    DeleteMessages($SubdivisionID);
  }
  
  $db->query('UNLOCK TABLES');
  
  return;
}

?>