<?php
/* $Id: function.inc.php 2495 2008-12-08 14:53:44Z vadim $ */

$systemMessageID = $UserID;
$systemTableName = 'User';
$systemTableID = GetSystemTableID ($systemTableName);

/**
 * Return array with error discrp.
 *
 * @return array array[code_error] = error
 */
function GetArrayWithError_User () {
  global $NO_RIGHTS_MESSAGE;
  return array(2 => $NO_RIGHTS_MESSAGE,
              3 => CONTROL_USER_RIGHTS_ERROR_NOSELECTED,
              4 => CONTROL_USER_RIGHTS_ERROR_DATA,
              5 => CONTROL_USER_RIGHTS_ERROR_DB );  
}

/**
 * Return html-code with form for user search
 *
 * @return string html-code
 */
function SearchUserForm () {
  global $db, $ROOT_FOLDER, $INCLUDE_FOLDER, $admin_mode;
  global $systemTableID, $systemMessageID, $systemTableName, $ADMIN_PATH;
  
  $html = ""; //       
  $html .= "<a onclick=\"document.getElementById('userSearchForm').style.display='block';
   this.style.display='none'; return false;\" href='#'>
   ".CONTROL_USER_FUNCS_USERSGET."<br /><br />
  </a>
  <form method='get' action='index.php' id='userSearchForm' style='display:none'>
      <fieldset>
          <legend><b><font color=gray>".CONTROL_USER_FUNCS_USERSGET."</font></b></legend>
          <table border=0 cellpadding=6 cellspacing=0 width=100%>
              <tr>
                  <td width='5%'><font color=gray>ID: </td><td><input type=text name=UserID size=5 maxlength=10 value=''></td>
              </tr>
              <tr>
                  <td><font color=gray>".CONTROL_USER_GROUP.":&nbsp;</td>";
 
  $html .="<td><SELECT NAME=PermissionGroupID><OPTION VALUE=0>".CONTROL_USER_MAIL_ALLGROUPS;
  if ($Result = $db->get_results("SELECT `PermissionGroup_ID`, `PermissionGroup_Name` FROM `PermissionGroup`",ARRAY_N)) {
    foreach($Result AS $GroupArray) $html .= "<option value='".$GroupArray[0]."'>".$GroupArray[0].":".$GroupArray[1];
  }
  $html .= "</SELECT>";
  
  $html .= "     </td>
              </tr>
              <tr>
                  <td colspan='2'><font color=gray>
                  <input checked id=chk1 type='radio' name=Checked value=''> <label for=chk1>".CONTROL_USER_FUNCS_ALLUSERS."</label>
                  <input id=chk2 type='radio' name=Checked value=1> <label for=chk2>".CONTROL_USER_FUNCS_ONUSERS."</label>
                  <input id=chk3 type='radio' name=Checked value=2> <label for=chk3>".CONTROL_USER_FUNCS_OFFUSERS."</label>
                  <br>
                  </td>
              </tr>";
  

  require_once $INCLUDE_FOLDER."s_list.inc.php";
  $is_there_any_files = 0;

  require $ROOT_FOLDER."message_fields.php"; 
    
  if ($searchForm=showSearchForm($fldName, $fldType, $fldDoSearch, $fldFmt)) {
  
   $html .= " <tr>
                <td colspan ='2'>
                  <fieldset>
                    <legend><a href='".$ADMIN_PATH."field/index.php?isSys=1&amp;SystemTableID=".$systemTableID."'>
                      <b><font color=gray>".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_EXTFIELDS."</font></b></a>
                    </legend>
                    <table border=0 cellpadding=6 cellspacing=0 width=100%>
                      <tr>
                       <td><font color=gray>";
  
  $html .= $searchForm;
  $html .= "
                        </td>
                      </tr>
                    </table>
                  </fieldset>
                </td>
              </tr>";
  
  } 
  
  $html .= "</table>
  
      <br>
      <fieldset>
        <legend><b><font color=gray>".CONTROL_USER_FUNCS_VIEWCONTROL."</font></b></legend>
        <table border ='0'>
          <tr>
            <td> ".CONTROL_USER_FUNCS_SORTBY." </td>
            <td> 
             <select name='sort_by' style='width: 100%'>
             <option value='0'>".CONTROL_USER_GROUP."</option>
             <option value='-1'>ID</option>";

  foreach ( $fldID as $k => $v ) 
    $html .= "<option value='".$fldID."'>".$fldName[$k]."</option>";
  $html .= "</select><br></td></tr>";
  $html .= "<tr><td>".CONTROL_USER_FUNCS_SORT_ORDER."</td> 
      <td><select name='sort_order' style='width: 100%'>
        <option value='0'>".CONTROL_USER_FUNCS_SORT_ORDER_ACS."</option>
        <option value='1'>".CONTROL_USER_FUNCS_SORT_ORDER_DESC."</option>
      </select></td><tr>
      <tr><td>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOW."</td>
      <td><input type='text' value='20' name='objcount' size='3'>&nbsp;".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ."</td>
      </tr></table>
      </fieldset>
      </fieldset>
      <div align=right><input type=submit class=s value='".CONTROL_USER_FUNCS_DOGET."'></div>
      <input type='hidden' name=phase value='2'>
      <input type='hidden' name='order_by' value='".$order_by."'>
	    <input type='submit' class='hidden'>
      </form>";
    
  return $html;
}


function ListUserPages($totRows, $queryStr, $PermissionGroupID, $Checked, $sort_by, $sort_order, $objcount)
{
    global $db, $curPos;

    $range = 10;
    $maxRows = intval($objcount);
    if ( $maxRows < 1 ) $maxRows = 20;

    $curPos += 0;
    $PermissionGroupID += 0;
    $Checked += 0;
    $sort_by += 0;
    $sort_order += 0;

    if (!$maxRows || !$totRows)
    {
        return;
    }

    $page_count = ceil($totRows / $maxRows);
    $half_range = ceil($range / 2);
    $cur_page = ceil($curPos / $maxRows) + 1;

    if ($page_count < 2)
    {
        return;
    }

    $maybe_from = $cur_page - $half_range;
    $maybe_to = $cur_page + $half_range;

    if ($maybe_from < 0)
    {
        $maybe_to = $maybe_to - $maybe_from;
        $maybe_from = 0;

        if ($maybe_to > $page_count)
        {
            $maybe_to = $page_count;
        }
    }

    if ($maybe_to > $page_count)
    {
        $maybe_from = $page_count - $range;
        $maybe_to = $page_count;

        if ($maybe_from < 0)
        {
            $maybe_from = 0;
        }
    }

    echo "<div align='center'><font size='-1'>";
    $native_pars="&sort_by=".$sort_by."&sort_order=".$sort_order."&objcount=".$objcount;
    if ($PermissionGroupID)
    {
        $native_pars.="&PermissionGroupID=".$PermissionGroupID;
    }
    if ($Checked)
    {
        $native_pars.="&Checked=".$Checked;
    }

    if ($cur_page > 1 && $page_count > $range)
    {
        $url = "?phase=2".$native_pars."&amp;".$queryStr."&curPos=".($curPos - $maxRows);
        echo "| <a href='{$url}' title=' '>&laquo;</a> | ";
    }

    for ($i=$maybe_from; $i<$maybe_to; $i++)
    {
        $page_number = $i + 1;
        $page_from = $i * $maxRows;
        $page_to = $page_from + $maxRows;
        $url = "?phase=2".$native_pars."&amp;".$queryStr."&curPos=".$page_from;

        if ($curPos == $page_from)
        {
            echo "<b>$page_number</b>";
        }
        else
        {
            echo "<a href='$url'>$page_number</a>";
        }

        if ($i!=($maybe_to-1))
        {
            echo " | ";
        }
    }

    if ($cur_page != $page_count && $page_count > $range)
    {
        $url = "?phase=2".$native_pars."&amp;".$queryStr."&curPos=".($curPos + $maxRows);
        echo " | <a href='{$url}' title=' '>&raquo;</a> |";
    }

    echo "</font></div><br>";
}


/**
 * Show table with all users
 *
 */
function SearchUserResult() {
  global $db, $perm, $ROOT_FOLDER, $INCLUDE_FOLDER;
  global $UserID, $PermissionGroupID, $Checked, $sort_by, $sort_order, $objcount;
  global $srchPat, $admin_mode, $curPos;
  global $systemTableID, $systemMessageID, $systemTableName;
  global $AUTHORIZE_BY, $ADMIN_PATH, $ADMIN_TEMPLATE;

  $curPos += 0;
  $PermissionGroupID += 0;
  $Checked += 0;
  $sort_by += 0;
  $sort_order += 0;
  $objcount += 0;
  
  require ($ROOT_FOLDER."message_fields.php");
  require_once ($INCLUDE_FOLDER."s_list.inc.php");
  
  //-    
  if ( $objcount < 1 ) $objcount = 20;
  
  // ,     
  switch ($sort_by) {
    case -2:
      $order_by_fld = "a.".$AUTHORIZE_BY;
      break;
    case -1:
      $order_by_fld = "a.User_ID";
      break;
    case 0:
      $order_by_fld = "g.PermissionGroup_ID";
      break;
    default:
      $order_by_fld = "a.`".$fld[$sort_by]."`";
      break;
  }
  

  $html =  SearchUserForm( $order_by );

  $search_params = getSearchParams($fld, $fldType, $fldDoSearch, $srchPat);
  $fullSearchStr = $search_params['query'];
  

  $select = "SELECT COUNT(*) FROM `User` AS a, `PermissionGroup` AS g ";
  $select .= " WHERE a.PermissionGroup_ID = g.PermissionGroup_ID";
  
  if ($UserID)  $select.= " AND a.User_ID = '".$UserID."'";
  if ($PermissionGroupID) $select.= " AND a.PermissionGroup_ID = '".$PermissionGroupID."'";
  
  if ($Checked!="" && $Checked!=2) $select.= " AND a.Checked = '".$Checked."'";
  if ($Checked==2) $select.= " AND a.Checked = 0";
  
  $select.= $fullSearchStr;

  $totRows = $db->get_var($select);
  
  echo "<b>".CONTROL_USER_FUNCS_SEARCHEDUSER.": </b><u>".$totRows."</u><br><br>";
  echo $html;
  
  ListUserPages($totRows, $search_params['link'], $PermissionGroupID, $Checked, $sort_by, $sort_order, $objcount);

  $native_pars="";
  if ($PermissionGroupID) $native_pars.="&amp;PermissionGroupID=".$PermissionGroupID;
  if ($Checked)           $native_pars.="&amp;Checked=".$Checked;
  $url = $native_pars."&amp;".$search_params['link']."&amp;curPos=".$curPos."&amp;objcount=".$objcount;

  $select = "SELECT a.`User_ID`, a.`".$AUTHORIZE_BY."`, a.`PermissionGroup_ID`, a.`Checked`, g.`PermissionGroup_Name` 
             FROM `User` AS a, `PermissionGroup` AS g 
             WHERE a.`PermissionGroup_ID` = g.`PermissionGroup_ID`";
            
  
  if ($UserID)  $select.= " AND a.User_ID = '".$UserID."'";
  if ($PermissionGroupID) $select.= " AND a.PermissionGroup_ID = '".$PermissionGroupID."'";
  
  if ($Checked!="" && $Checked!=2) $select.= " AND a.Checked = '".$Checked."'";
  if ($Checked==2) $select.= " AND a.Checked = 0";

  $select.= $fullSearchStr." ORDER BY ".$order_by_fld.($sort_order ? " DESC" : " ASC")." LIMIT ".$curPos.",".$objcount;

  if ($Result = $db->get_results($select,ARRAY_N)) {
    
    $morePreference = $perm->GetUserWithMoreRights(); //id ,      
    $edit_access    = $perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_EDIT,  -1);  //       
    $del_access     = $perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_DEL,   -1);  //                              
    //$right_access   = $perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, -1);  //                               
    $right_access = $edit_access; //      =   
 
    ?>
    <form method='post' action='index.php' id='mainForm'>
    <table border='0' cellpadding='0' cellspacing='0' width='100%'>
      <tr>
        <td bgcolor=cccccc>
          <table border=0 cellpadding=4 cellspacing=1 width=100%>
            <tr>
              <td bgcolor=eeeeee><font size=-2>
                <a href='?sort_by=-1&amp;sort_order=<?=($sort_by == -1)?!$sort_order:0?>&<?=$url?>'><b>ID</b></a>
              </td>
              <td bgcolor=eeeeee width="40%">
                <font size=-2><a href='?sort_by=-2&amp;sort_order=<?=($sort_by == -2)?!$sort_order:0?>&<?=$url?>'><b><?=CONTROL_USER?></b></a>
              </td>
              <td bgcolor=eeeeee>
                <font size=-2><a href='?sort_by=0&amp;sort_order=<?=($sort_by == 0)?!$sort_order:0?>&<?=$url?>'><b><?=CONTROL_USER_GROUP?></b></a>
              </td>
              <? if ($edit_access) : ?>
              <td align=right bgcolor=eeeeee width=25%><font size=-2><b><?=CONTROL_USER_ACTIONS ?></td> 
              <? endif; if ($right_access): ?>
              <td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_USER_RIGHTS?></td>
              <? endif; if ($del_access): ?>
              <td bgcolor=eeeeee align=center><img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
              <? endif; ?>
               </tr>
    <?

    foreach ($Result as $Array ) {
      $this_user_edit = !in_array($Array[0], $morePreference); //    

      print "<tr>\n";

      print"<td bgcolor=white><font size=-2><b>".$Array[0]."</td>\n
            <td bgcolor=white>\n";
      if ( $edit_access && $this_user_edit )
        print "<a href=\"index.php?phase=4&UserID=".$Array[0]."\" ".(!$Array[3]?"style='color:#cccccc;'":"").">\n"; 
      print ($AUTHORIZE_BY != "User_ID") ? $Array[1] : CONTROL_USER_EDIT;
      print "</a></td>";
                      
      print "<td bgcolor=white><font size=-2>".$Array[2].". ".$Array[4]."</td>";

      if ($edit_access ) {
        print "<td align=right bgcolor=white nowrap><font size=-2>\n";
        if ($this_user_edit) 
          print "<a href=index.php?phase=12&UserID=".$Array[0].">".($Array[3]?NETCAT_MODERATION_TURNTOOFF:NETCAT_MODERATION_TURNTOON)."</a> | <a href=\"index.php?phase=6&UserID=".$Array[0]."\">".CONTROL_USER_CHANGEPASS."</a>\n";
        print "</td>\n";
      }
      if ($right_access) {
        print "<td align=center bgcolor=white>\n";
        if ($this_user_edit)
          print "<a href=\"index.php?phase=8&UserID=".$Array[0]."\"><img border=0 src=".$ADMIN_PATH."images/setup".(!$Array[3]?"_g":"").".gif width=18 height=18 alt='".CONTROL_USER_FUNCS_EDITACCESSRIGHT."' title='".CONTROL_USER_FUNCS_EDITACCESSRIGHT."'></a>";
        print "</td>";
      }
         
      if ($del_access) {             
        print "<td bgcolor=white align=center>\n";
        if ( $this_user_edit )
          print "<input type=checkbox name=\"Delete".$Array[0]."\" value=".$Array[0].">\n";
        print "</td>\n";
      }
        print "</tr>\n";
      }

      ?>
              </table>
          </td>
      </tr>
  </table>
  <?php
    global $UI_CONFIG;
    if ($perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_ADD) )
      $UI_CONFIG->actionButtons[] = array("id" => "adduser",
                                        "caption" => CONTROL_USER_REG,
                                        "align" => "left",
                                        "location" => "user.add()");
    if ( $del_access)
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => NETCAT_ADMIN_DELETE_SELECTED,
                                        "action" => "mainView.submitIframeForm('mainForm')");

  
  ?>
  <input type='hidden' name=phase value=14>
<input type='submit' class='hidden'>
  </form>
      <?
      ListUserPages($totRows, $search_params['link'], $PermissionGroupID, $Checked, $sort_by, $sort_order, $objcount);
  }
  else
  {
      echo CONTROL_USER_MSG_USERNOTFOUND;
  }

  return ;
}

###############################################################################

function GroupList ()
{
    global $db, $ROOT_FOLDER;
    global $Email;
    global $srchPat;
    global $systemTableID, $systemMessageID, $systemTableName, $ADMIN_TEMPLATE;

    $Result = $db->get_results("select PermissionGroup_ID, PermissionGroup_Name from PermissionGroup ",ARRAY_N)
    ?>
    <form method=post action=group.php>
        <table border=0 cellpadding=0 cellspacing=0 width=100%>
            <tr>
                <td bgcolor=cccccc>
                <table border=0 cellpadding=4 cellspacing=1 width=100%>
                    <tr>
                        <td bgcolor=eeeeee><font size=-2><b>ID</td>
                        <td bgcolor=eeeeee width=80%><font size=-2><b><?=CONTROL_USER_GROUP?></td>
                        <td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_USER_RIGHTS?></td>
                        <td bgcolor=eeeeee align=center><img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
                    </tr>
    <?
    foreach ($Result as $Array)
    {
        print "
                    <tr>
                        <td bgcolor=white><font size=-2><b>".$Array[0]."</td>
                        <td bgcolor=white><a href=\"group.php?phase=3&PermissionGroupID=".$Array[0]."\">".$Array[1]."</a></td>
                        <td bgcolor=white align=center><a href=\"group.php?phase=8&PermissionGroupID=".$Array[0]."\"><img src='".$ADMIN_TEMPLATE."img/i_settings.gif' border=0 width=16 height=16 alt='".CONTROL_USER_CHANGERIGHTS."' title='".CONTROL_USER_CHANGERIGHTS."'></a></td>";
        if(!$db->get_var("select User_ID from User where PermissionGroup_ID='".$Array[0]."' limit 0,1"))
        {
            print "
                        <td bgcolor=white align=center><INPUT TYPE=CHECKBOX NAME=\"Delete".$Array[0]."\" VALUE=".$Array[0]."></td>";
        }
        else
        {
            print "
                        <td bgcolor=white align=center></td>";
        }
        print "
                    </tr>";
    }
    ?>
                </table>
            </td>
        </tr>
    </table><br>
    <?php
      global $UI_CONFIG;
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => NETCAT_ADMIN_DELETE_SELECTED,
                                          "action" => "mainView.submitIframeForm()");

      $UI_CONFIG->actionButtons[] = array("id" => "adduser",
                                          "caption" => CONTROL_USER_ADDNEWGROUP,
                                          "align" => "left",
                                          "location" => "usergroup.add()");
    ?>
    <input type='hidden' name=phase VALUE=2>
	<input type='submit' class='hidden'>
    </form>
    <?
}

###############################################################################

function UserForm ($UserID, $action_file, $phase, $type)
{
    # type = 1 -  insert
    # type = 2 -  update
    global $db, $ROOT_FOLDER, $admin_mode, $DOMAIN_NAME;
    global $HTTP_FILES_PATH, $FILES_FOLDER;
    global $systemTableID, $systemMessageID, $systemTableName;
    global $Checked, $PermissionGroupID;
    global $INCLUDE_FOLDER, $ADMIN_PATH;

    require_once $INCLUDE_FOLDER."s_files.inc.php";
    $is_there_any_files = getFileCount(0,$systemTableID);

    while (list($key, $val) = each($_POST))
    {
        eval("global \$".$key.";");
    }
    while (list($key, $val) = each($_FILES))
    {
        eval("global \$".$key.";");
    }

    if ($type == 1) {
        $Array['Checked']            = $Checked;
        $Array['PermissionGroup_ID'] = $PermissionGroupID;
        $Array['InsideAdminAccess']  = $InsideAdminAccess;
    }
    elseif ($type == 2) {
        $Array = $db->get_row("SELECT Checked, PermissionGroup_ID, InsideAdminAccess, Catalogue_ID
        	FROM User 
        	WHERE User_ID='".$UserID."'", ARRAY_A);
        if (!$Array) {
            nc_print_status(CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DBERROR, 'error');
        }
    }
    
    echo "<form ".($is_there_any_files ? "enctype='multipart/form-data'" : "")." method='post' action='".$action_file."'>";
    
    if ($type == 2) echo "ID: <b>$UserID</b>&nbsp;&nbsp;";

    echo "<input id='chk' type='checkbox' name='Checked' ".($Array['Checked']?" checked":"")." value='1'> <label for='chk'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_TURNON."</label>&nbsp;&nbsp;";
    echo "<input id='InsideAdminAccess' type='checkbox' name='InsideAdminAccess' ".($Array['InsideAdminAccess']?" checked":"")." value='1'> <label for='InsideAdminAccess'>".NETCAT_MODULE_AUTH_INSIDE_ADMIN_ACCESS."</label><br><br>";
    
    
    // PermissionGroupID
    $UserPermGroupID = ($PermissionGroupID ? (int)$PermissionGroupID : $Array['PermissionGroup_ID']);
    $Result = $db->get_results("SELECT PermissionGroup_ID, PermissionGroup_Name FROM PermissionGroup", ARRAY_N);
    echo CONTROL_USER_GROUP.":<br><select name='PermissionGroupID'>";
    foreach ($Result as $GroupArray) {
        echo "<option".($GroupArray[0]==$UserPermGroupID ? " selected" : "")." value='".$GroupArray[0]."'>".$GroupArray[0].":".$GroupArray[1]."</option>";
    }
    echo "</select><br><br>";
    
    
    if ($db->get_var("SELECT Keyword FROM Module WHERE Keyword='auth'")) {
	    // Catalogue_ID
	    $UserCatID = (isset($_POST['Catalogue_ID']) ? (int)$_POST['Catalogue_ID'] : $Array['Catalogue_ID']);
	    $Result = $db->get_results("SELECT Catalogue_ID, Catalogue_Name FROM Catalogue", ARRAY_N);
	    echo CONTROL_AUTH_ON_ONE_SITE.":<br><select name='Catalogue_ID'><option value='0'".(!$UserCatID ? " selected" : "").">".CONTROL_AUTH_ON_ALL_SITES."</option>";
	    foreach ($Result as $row) {
	        echo "<option value='".$row[0]."'".($UserCatID==$row[0] ? " selected" : "").">".$row[0].'.'.$row[1]."</option>";
	    }
	    echo "</select><br><br>";
    }

    
    if ($type == 1) {
        echo CONTROL_AUTH_HTML_PASSWORD.":<br><input type='password' name='Pass1' size='30' maxlength='32'><br><br>";
        echo CONTROL_AUTH_HTML_PASSWORDCONFIRM.":<br><input type='password' name='Pass2' size='32' maxlength='32'><br>";
        $action = "add";
    }
    elseif ($type==2) {
        $action  = "change";
        $message = $systemMessageID;
    }

    require $ROOT_FOLDER."message_fields.php";

    if ($fldCount)
    {
        if ($type == 2)
        {
            $fieldQuery = join($fld, ",");
            $fldValue = $db->get_row("select $fieldQuery from User where User_ID='".$systemMessageID."'",ARRAY_N);
        }

        echo "<br><br>";
        ?>
<fieldset>
<legend><a href=<?="".$ADMIN_PATH."field/systemField.php?SystemTableID=".$systemTableID?>><font color=gray><b><?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_EXTFIELDS?></b></font></a></legend>
<table border=0 cellpadding=6 cellspacing=0 width=100%><tr><td><font color=gray>
<?
require $ROOT_FOLDER."message_edit.php";
?>
</td></tr></table>
</fieldset><br>
        <?
    }
    else
    {
        ?><hr size=1 color=cccccc><?
    }
    print "<INPUT type='hidden' NAME=UserID VALUE=".$UserID.">";
    print "<INPUT type='hidden' NAME=posting VALUE=1>";
    ?>
 <div align=right>
  <?
    global $UI_CONFIG;
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => ($type==1 ? CONTROL_USER_FUNCS_ADDUSER
                                                               : CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE),
                                        "action" => "mainView.submitIframeForm()");
  ?>
 </div>
 <input type='hidden' name=phase value=<?= $phase; ?>>
 <input type='submit' class='hidden'>
 </form>
  <?
}

###############################################################################

function ActionUserCompleted ($action_file, $type)
{
    global $db, $ROOT_FOLDER, $admin_mode;
    global $systemTableID, $systemTableName, $systemMessageID;
    global $FILES_FOLDER, $INCLUDE_FOLDER;
    global $DIRCHMOD, $FILECHMOD;

    require_once $INCLUDE_FOLDER."s_files.inc.php";
    $is_there_any_files = getFileCount(0,$systemTableID);

    if ($type==1)
    {
        $action = "add";
    }
    if ($type==2)
    {
        $action = "change";
        $message = $systemMessageID;
    }

    while (list($key, $val) = each($_POST))
    {
        eval("global \$".$key.";");
    }
    while (list($key, $val) = each($_FILES))
    {
        eval("global \$".$key.";");
    }

    $Priority += 0;

    require $ROOT_FOLDER."message_fields.php";

    if ($posting == 0)
    {
        echo $warnText;
        #UpdateUserForm ($UserID);
        UserForm ($UserID, $action_file, $phase, $type);
        return false;
    }

    require $ROOT_FOLDER."message_put.php";

    if ($type == 1)
    {
        $Password = $Pass1;

        $insert = 'insert into User (';
        for($i=0;$i<$fldCount;$i++)
        {
            $insert .= $fld[$i].",";
        }
        $insert .= 'Password, Checked, PermissionGroup_ID,Created,InsideAdminAccess) values (';
        for($i=0;$i<$fldCount;$i++)
        {
            if ( !$fldValue[$i]) { //    sql,   
              $insert .= "'', ";
            }
            else {
              $insert .= $fldValue[$i].",";
            }
        }
        $insert .= "password('".$Password."'),'$Checked','$PermissionGroupID','".date("Y-m-d H:i:s")."', '".(int)$InsideAdminAccess."')";
        $Result = $db->query($insert);
        $UserID = $db->insert_id ;
        $message = $UserID;
        if ($Result)
        {
            nc_print_status(CONTROL_USER_NEW_ADDED, 'ok');
        }
        else
        {
            nc_print_status(CONTROL_USER_NEW_NOTADDED, 'error');
        }
    }

    if ($type == 2)
    {
        $update = "update User set ";
        for($i=0;$i<$fldCount;$i++)
        {
            $update .= $fld[$i]."=".$fldValue[$i].",";
        }
        $update .= "PermissionGroup_ID=\"".$PermissionGroupID."\",";
        $update .= "Checked=\"".$Checked."\",";
        $update .= "InsideAdminAccess=".(int)$InsideAdminAccess;
        if(isset($_POST['Catalogue_ID'])) $update.= ", Catalogue_ID=".(int)$_POST['Catalogue_ID'];
        $update .= " where User_ID=".$UserID;
        $Result = $db->query($update);
    }

    /***/
    if ($filetable_lastid)
    {
        foreach ($filetable_lastid as $id)
        {
            $Result = $db->query("UPDATE Filetable SET Message_ID='{$message}' WHERE ID = '{$id}'");
        }
    }
    /***/

    if ($tmpFile)
    {
        @mkdir($FILES_FOLDER."u/", $DIRCHMOD);
    }
    for ($i=0; $i<count($tmpFile); $i++)
    {
        eval ("\$tmpNewFile[\$i] = \"".$tmpNewFile[$i]."\";");
        @rename($FILES_FOLDER.$tmpFile[$i], $FILES_FOLDER."u/".$tmpNewFile[$i]);
        @chmod($FILES_FOLDER."u/".$tmpNewFile[$i], $FILECHMOD);
    }
    return true;
}

###############################################################################

function GroupForm ($PermissionGroupID, $action, $phase, $type)
{
    # type = 1 -  insert
    # type = 2 -  update
    global $db, $ROOT_FOLDER;
    global $systemTableID, $systemMessageID, $systemTableName;
    global $Email, $Checked;

    if ($type == 1)
    {

    }
    else if ($type == 2)
    {
        $Array = $db->get_row("select PermissionGroup_Name from PermissionGroup where PermissionGroup_ID='".$PermissionGroupID."'",ARRAY_A);
        if (!$Array)
        {
            nc_print_status(CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DBERROR, 'error');
        }
    }
    ?>
    <form method=post action="<?= $action ?>">
        <font color=gray><?=CONTROL_USER_GROUPNAME?>:<br><input type=text name=PermissionGroupName size=50 maxlength=64 value='<?=$Array['PermissionGroup_Name']?>'>
        <INPUT type='hidden' NAME=PermissionGroupID VALUE='<?=$PermissionGroupID?>'>

    <?php
      global $UI_CONFIG;
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => ($type==1 ? CONTROL_USER_ADDNEWGROUP
                                                                 : CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE),
                                          "action" => "mainView.submitIframeForm()");
    ?>
        <input type='hidden' name=phase value=<?= $phase; ?>>
		<input type='submit' class='hidden'>
    </form>
 <?
}

###############################################################################

function ActionGroupCompleted ($action, $type)
{
    global $db, $ROOT_FOLDER;

    while (list($key, $val) = each($_POST)) {
        eval("\$".$key."='".$val."';");
    }
    if ($type == 1)
    {
        $insert = 'insert into PermissionGroup (';
        $insert .= 'PermissionGroup_Name) values (';
        $insert .= "'$PermissionGroupName')";
        $Result = $db->query($insert);
    }
    if ($type == 2)
    {
        $update = "update PermissionGroup set ";
        $update .= "PermissionGroup_Name=\"".$PermissionGroupName."\"";
        $update .= " where PermissionGroup_ID='".$PermissionGroupID."'";
        $Result = $db->query($update);
    }
}

###############################################################################

function ChangePasswordForm ($UserID)
{
    global $db;
    ?>
    <form method=post action=index.php>
        <font color=gray>
        <?=CONTROL_USER_NEWPASSWORD?>:<br>
        <INPUT TYPE=PASSWORD NAME=Password1 SIZE=30 MAXLENGTH=32><br><br>
        <?=CONTROL_USER_NEWPASSWORDAGAIN?>:<br>
        <INPUT TYPE=PASSWORD NAME=Password2 SIZE=30 MAXLENGTH=32><br>
        <INPUT type='hidden' NAME=UserID VALUE=<?=$UserID?>>
        <input type='hidden' name=phase value=7>
        <?
          global $UI_CONFIG;
          $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                              "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                              "action" => "mainView.submitIframeForm()");
        ?>
		<input type='submit' class='hidden'>
    </form>
    <?
}


/**
 * Show user permission
 *
 * @param int $UserID - user id
 * @param int $phase  phase in hidden
 * @param string $action action in form
 * @param int $PermissionGroupID PermissionGroupID
 */
function ShowUserPermissions ($UserID, $phase, $action = "index.php", $PermissionGroupID = 0) {
  global $db, $UI_CONFIG;
  global $USER_PERM_ARRAY, $USER_PERM_COUNT;
  global $perm, $ADMIN_PATH, $ADMIN_TEMPLATE;
 
 
 $allPerm = Permission::GetAllPermission($UserID, $PermissionGroupID);
 $count_td_colspan = NC_PERM_COUNT_PERM;
 $module_subsribe = nc_module_check_by_keyword('subscriber', false);
 $module_comments = nc_module_check_by_keyword('comments');
 
 if ( !$module_subsribe ) $count_td_colspan--;
 if ( !$module_comments ) $count_td_colspan--;
 
 if (!empty($allPerm)) { // User has rights
    ?>
    <form method='post' action='<?=$action?>'>
      <table border='0' cellpadding='0' cellspacing='0' width='100%'>
        <tr>
          <td style='background:#CCC'>
            <table cellpadding='5' cellspacing='1' style='width:100%; border:none'>
              <tr>
                <td style='background:#EEE' align='center' width='50%' rowspan='2'><font size='-2'><b><?=SECTION_INDEX_USER_RIGHTS_TYPE?></font></td>
                <td style='background:#EEE' align='center' colspan='<?=$count_td_colspan?>'>
                  <font size='-2'><b><?=SECTION_INDEX_USER_RIGHTS_RIGHTS?></font></td>
                <td style='background:#EEE' align='center' rowspan='2'>
                  <?=CONTROL_USER_RIGHTS_LIVETIME?>
                </td>
                <td style='background:#EEE' align='center' rowspan='2'>
                  <img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'>
                </td>
                
              </tr>
              <tr>
              <?php
                for ($i = 0; $i < NC_PERM_COUNT_PERM; $i++ ) {
                  $name = (($i == NC_PERM_READ_ID)     ? CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_VIEW : 
                          (($i == NC_PERM_COMMENT_ID)  ? CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_COMMENT :
                          (($i == NC_PERM_ADD_ID)      ? CONTROL_CONTENT_CATALOUGE_ADD :
                          (($i == NC_PERM_EDIT_ID)     ? CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CHANGE :
                          (($i == NC_PERM_SUBCRIBE_ID) ? CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SUBSCRIBE :
                          (($i == NC_PERM_MODERATE_ID) ? CONTROL_CLASS_ACTIONS_MODERATE :
                          (($i == NC_PERM_ADMIN_ID)    ? CONTROL_CLASS_ACTIONS_ADMIN : '')))))));
                  
                  if (!$module_subsribe && $i == NC_PERM_SUBCRIBE_ID) continue; 
                  if (!$module_comments && $i == NC_PERM_COMMENT_ID) continue; 
                  print "<td style='background:#EEE' align='center'><font size='-2'>".$name."</font></td>";
                }
                print "</tr>";
               

    foreach ($allPerm as $k =>  $v) {
      /* $k - Permission ID
         $v - array with perm. parametrs: title, live, ..
      */
  
      print "<tr>\n";
      print "<td style='background:#FFF'>\n<font size='-2'>".$v['title']."</font>\n</td>\n";
      if ($v[NC_PERM_READ_ID]['checkbox'] == -1) { // Director, Supervisor, Guest
        print "<td colspan='".$count_td_colspan."' style='background:#FFF'>\n";
      }
      else { // editor, moderator, developer
        for ($i = 0; $i < NC_PERM_COUNT_PERM; $i++) { 
          if (!$module_subsribe && $i == NC_PERM_SUBCRIBE_ID ) continue;
          if (!$module_comments && $i == NC_PERM_COMMENT_ID  ) continue;
          $hidden = ""; //       
          print "<td align='center' style='background:#FFF'>\n";
          if ($v[$i]['checkbox'] != 3 ){ //  3 -  0, 1  2 -  
            print "<input class='wh' type='checkbox' name='PermissionID".$k."x".$i."' value='".$v[$i]['mask']."'";
            if ($v[$i]['checkbox'] == 1 ) print " checked ";    
            if ($v[$i]['checkbox'] == 2 ) { 
              print " checked disabled ";
              $hidden = "<input type='hidden' name='PermissionID".$k."x".$i."' value='".$v[$i]['mask']."'>";
            }
            print "/>\n";
            print $hidden;
          } 
          print "</td>\n";
        }
      }
      print "<td style='background:#FFF'>".$v['live']."</td>\n";
      print "<td style='background:#FFF'><input class='wh' type='checkbox' name='Delete".$k."' value='".$k."'></td>\n"; 
      print "</tr>\n"; 
    } 
    
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                        "action" => "mainView.submitIframeForm()");
    
  }
  else {
    nc_print_status(CONTROL_USER_FUNCS_NORIGHTS, 'info');
  }

  $UI_CONFIG->actionButtons[] = array("id" => "addrights",
                                      "caption" => CONTROL_USER_FUNCS_ADDNEWRIGHTS,
                                      "align" => "left",
      "action" => "mainView.loadIframe('".$ADMIN_PATH."user/".$action."?phase=9&UserID=".$UserID."&PermissionGroupID=".$PermissionGroupID."')");
  
 
     
  ?>
    <input type='hidden' name='phase' value='<?=$phase?>'>
    <input type='hidden' name='UserID' value='<?=$UserID?>'>
    <input type='hidden' name='PermissionGroupID' value='<?=$PermissionGroupID?>'>
    <input type='submit' class='hidden'>
  </form>
  <?
  
  return;
}





###############################################################################
function ConfirmDeleteUsers() {
  global $db;
  
  $num_user = 0;
  $html = "<ul>\n<form action ='index.php' method = 'post'>\n";
  $html .= "<input type='hidden' name='phase' value='3'>\n";
  while (list($key, $val) = each($_POST)) 
    if (substr($key, 0,6) == "Delete") {
      $html .= "<li>".$val.". ".GetLoginByID($val)."</li>\n"; 
      $num_user++; 
      $html .="<input type='hidden' name='Delete".$val."' value='".$val."'>\n";
    }
  
  $html .= "</ul>";
  if ($num_user) {
    nc_print_status(CONTROL_USER_FUNC_CONFIRM_DEL, 'info');
    echo $html; 
  }
  else {
    nc_print_status(CONTROL_USER_FUNC_CONFIRM_DEL_NOT_USER, 'error');
  }
  
  return $num_user;
 
}

function DeleteUsers ()
{
    global $db, $perm;

    while (list($key, $val) = each($_POST))
    {
        if ($key == 'Submit')
        {
            continue;
        }
        if ($key == 'phase')
        {
            continue;
        }

        $delete = "delete from User where User_ID=".$val;

        $allowToKill = true;
        
        //   
        if ($val==$perm->GetUserID() ) $allowToKill = false;
        //    
        if (!$perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_DEL, $val)) $allowToKill = false;
        //   
        $userCount = $db->get_var("SELECT count(*) FROM User");
        if ($userCount==1) $allowToKill = false;


        if ($allowToKill)
        {
            if ( $db->query("delete from User where User_ID=".$val) )
            {
                DeleteInSubscribe ($val);
                DeleteAllPermission($val);
                DeleteSystemTableFiles('User', $val);
            }
            if ($DeleteActionTemplate=$db->get_var("SELECT DeleteActionTemplate FROM Class WHERE System_Table_ID=3"))
            {
                eval("echo \"".$DeleteActionTemplate."\";");
            }
        }
    }
}

###############################################################################

function DeleteOneUser ($UserID)
{
    global $db, $perm, $AUTH_USER_ID, $AUTH_USER_GROUP;
    $allowToKill = true;
    $val = $UserID;
    
    
    if ($val==$perm->GetUserID())  $allowToKill = false;
    
    if (!$perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_DEL, $val)) $allowToKill = false;
  
    $userCount = $db->get_var("SELECT count(*) FROM User");
    if ($userCount==1)  $allowToKill = false;

    $res = 0;
    if ($allowToKill)
    {
        if ( $db->query("delete from User where User_ID='".$UserID."'") )
        {
            DeleteInSubscribe ($UserID);
            DeleteAllPermission ($UserID);
            DeleteSystemTableFiles('User', $UserID);
        }
    }
    if ($DeleteActionTemplate=$db->get_var("SELECT DeleteActionTemplate FROM Class WHERE System_Table_ID=3"))
    {
        eval("echo \"".$DeleteActionTemplate."\";");
    }
}

###############################################################################

function DeleteGroups ()
{
    global $db;
    while (list($key, $val) = each($_POST))
    {
        if ($key == 'Submit')
        {
            continue;
        }
        if ($key == 'phase')
        {
            continue;
        }
        $Array = $db->get_var("select PermissionGroup_Name from PermissionGroup where PermissionGroup_ID='".$val."'");
        if ($db->query("delete from PermissionGroup where PermissionGroup_ID='".$val."'") )
        {
        }
        else
        {
            nc_print_status(CONTROL_USER_FUNCS_ERR_CANTREMGROUP, 'error', $Array);
        }
    }
}

###############################################################################
 



/**
 * Show form to add new permission
 *
 * @param int User ID
 * @param int phase 
 * @param string action in form
 * @param int Permission Group ID
 */
function AddPermissionForm ($UserID, $phase = 10, $action = 'index.php', $PermissionGroupID = 0) {
  global $ADMIN_PATH;
  global $db, $UI_CONFIG;
  global $perm; 
 
  $site_list_id = $db->get_col("SELECT `Catalogue_ID`, `Catalogue_Name` From `Catalogue`");
  $site_list_name = $db->get_col(0,1);
  $site_id = join(".", $site_list_id);
  $site_name = join(".", $site_list_name);
 
  ?>

  <script language='javascript'>
    var site_id = '<?=$site_id?>'; 
    var site_name = '<?=$site_name?>';
    var some_const = {
      allclassificator : '<?=CONTENT_CLASSIFICATORS_NAMEALL?>',
      classificator : '<?=CONTENT_CLASSIFICATORS_NAMEONE?>',
      selectsite: '<?=CONTROL_USER_SELECTSITE?>', 
      allsite:    '<?=CONTROL_USER_SELECTSITEALL?>',   
      siteadmin: '<?=CONTROL_USER_RIGHTS_SITEADMIN?>',
      subadmin : '<?=CONTROL_USER_RIGHTS_SUBDIVISIONADMIN?>',
      ccadmin: '<?=CONTROL_USER_RIGHTS_SUBCLASSADMINS?>',
      site : '<?=SECTION_INDEX_MENU_SITE?>',
      sub : '<?=CONTROL_CONTENT_SUBDIVISION_FUNCS_SECTION?>',
      cc : '<?=CONTROL_USER_FUNCS_CLASSINSECTION?>',
      item : '<?=CONTROL_USER_RIGHTS_ITEM?>',
      selectitem : '<?=CONTROL_USER_RIGHTS_SELECT_ITEM?>',
      load : '<?=CONTROL_USER_RIGHTS_LOAD?>'
    }

  </script>
 

  

  
  <form action='<?=$action?>' method='post' name='admin' id='admin'>
    <input name='phase' value='<?=$phase?>' type='hidden'>
    <input type='hidden' name='UserID' value='<?=$UserID?>'>
    <input type='hidden' name='PermissionGroupID' value='<?=$PermissionGroupID?>'>
   
    <font color='gray'><br>
    <table border='0' bordercolor='#000000' width='60%' align='left' style='margin-left: 20px'>
    <tr><td width='30%' valign='top'>
     
     <fieldset><legend><b><font color='gray'><?=CONTROL_USER_RIGHTS_TYPE_OF_RIGHT?></font></b></legend>
       <? if ($perm->isDirector()): ?>
       <input id='dir' type='radio' name='AdminType' value='<?=DIRECTOR?>' onclick='nc_user_obj.handler_radio(1)'>
         <label for='dir'><?=CONTROL_USER_RIGHTS_DIRECTOR?></label><br>
       <? endif; ?>
       <? $disabled = $perm->isSupervisor() ? '' : 'disabled'; ?>
       <input id='sv'  type='radio' name='AdminType' value='<?=SUPERVISOR?>."' <?=$disabled?> onclick='nc_user_obj.handler_radio(2)'>
         <label for='sv'><?=CONTROL_USER_RIGHTS_SUPERVISOR?></label><br>
       <input id='man' type='radio' name='AdminType' value='<?=EDITOR?>' <?=$disabled?> onclick='nc_user_obj.handler_radio(3)'> 
         <label for='man'><?=CONTROL_USER_RIGHTS_EDITOR?></label><br>
       <input id='devel' type='radio' name='AdminType' value='<?=DEVELOPER?>' <?=$disabled?> onclick='nc_user_obj.handler_radio(4)'> 
         <label for='devel'><?=CONTROL_USER_RIGHTS_DEVELOPER?></label><br>
       <input id='ban' type='radio' name='AdminType' value='<?=BAN?>'  onclick='nc_user_obj.handler_radio(5)'> 
         <label for='man'><?=CONTROL_USER_RIGHTS_BAN?></label><br>
       <input id='guest' type='radio' name='AdminType' value='<?=GUEST?>' <?=$disabled?> onclick='nc_user_obj.handler_radio(6)'> 
         <label for='guest'><?=CONTROL_USER_RIGHTS_GUESTONE?></label><br>
     </fieldset>
     
   </td><td valign='top'>
   
     <div id='div_livetime' name='div_livetime' style='display: none'>
       <fieldset><legend><b><font color='gray'><?=CONTROL_USER_RIGHTS_LIVETIME?></font></b></legend> 
         <input id='unlimit' name='unlimit' type='checkbox' value='1' checked onclick='nc_user_obj.handler_checkbox(2)'>
           <label for='unlimit'><?=CONTROL_USER_RIGHTS_UNLIMITED?></label><br>
         <div name='div_time' id='div_time' style='display: none'>
           c&nbsp;&nbsp; <input id='start_day' name='start_day' type='text' value='' size='2' maxlength='3'><b>.</b>
           <input id='start_month' name='start_month' type='text' value='' size='2' maxlength='3'><b>.</b>
           <input id='start_year' name='start_year' type='text' value='' size='4' maxlength='4'>&nbsp;&nbsp;
           <input id='start_hour' name='start_hour' type='text' value='' size='2' maxlength='3'><b>:</b>
           <input id='start_minute' name='start_minute' type='text' value='' size='2' maxlength='3'>
           <input id='ignore_start' name='ignore_start' type='checkbox' value='1' onclick='nc_user_obj.handler_checkbox(3)'>
             <label for='ignore_start'><?=CONTROL_USER_RIGHTS_IGNORE?></label>
           <br>
            <input id='end_day' name='end_day' type='text' value='' size='2'><b>.</b>
           <input id='end_month' name='end_month' type='text' value='' size='2'><b>.</b>
           <input id='end_year' name='end_year' type='text' value='' size='4'>&nbsp;&nbsp;
           <input id='end_hour' name='end_hour' type='text' value='' size='2'><b>:</b>
           <input id='end_minute' name='end_minute' type='text' value='' size='2'>
           <input id='ignore_stop' name='ignore_stop' type='checkbox' value='1' onclick='nc_user_obj.handler_checkbox(4)'>
             <label for='ignore_stop'><?=CONTROL_USER_RIGHTS_IGNORE?></label>
         </div>
       </fieldset>
     </div>
     
   </td></tr><tr><td colspan='2'>
   
     <div name='div_main_right' id='div_main_right' style='display: none'>
       <fieldset><legend><b><font color='gray'><?=CONTROL_USER_RIGHTS_RIGHT?></font></b></legend> 
         <div name='div_usercontrol' id='div_usercontrol' style='display: none'>
           <input id='usercontrol' name='usercontrol' type='checkbox' value='1' onclick='nc_user_obj.handler_checkbox(1)'>
             <label for='user'><?=CONTROL_USER_RIGHTS_CONTROL_USERS?></label><br>
           <div name='userperm' id='userperm' style='display: none'>&nbsp;&nbsp;
             <input id='user_add' name='user_add' type='checkbox' value='1'>
               <label for='user_add'><?=CONTROL_USER_RIGHTS_CONTROL_ADD?></label>
             <input id='user_edit' name='user_edit' type='checkbox' value='1'>
               <label for='user_edit'><?=CONTROL_USER_RIGHTS_CONTROL_EDIT?></label>
             <input id='user_del' name='user_del' type='checkbox' value='1'>
               <label for='user_del'><?=CONTROL_USER_RIGHTS_CONTROL_DELETE?></label><br>
           </div>
         </div>
         <br>   
  
         <table id='tbl_item' name='tbl_item' width='75%' border='1'  
                bordercolor='#000000' cellpadding='5' cellspacing='0' style='border-collapse: collapse'>
           <tbody></tbody> 
         </table>
  
         <div name='div_perm' id='div_perm' style='display: none'>
           <input id='l01' type='checkbox' name='Read' value='1'><label for='l01'><?=CONTROL_CLASS_ACTIONS_VIEW?></label><br>
           <? if ( nc_module_check_by_keyword("comments") ): ?>
           <input id='l07' type='checkbox' name='Comment' value='1'><label for='l07'><?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_COMMENT?></label><br>
           <? endif; ?>
           <input id='l02' type='checkbox' name='Add' value='1'> <label for='l02'><?=CONTROL_CONTENT_CATALOUGE_ADD?></label><br>
           <input id='l03' type='checkbox' name='Edit' value='1'> <label for='l03'><?=CONTROL_CLASS_ACTIONS_EDIT?></label><br>
           <? if ( nc_module_check_by_keyword("subscriber", false) ): ?>
           <input id='l04' type='checkbox' name='Subscribe' value='1'> <label for='l04'><?=CONTROL_CLASS_ACTIONS_MAIL?></label><br>
           <? endif; ?>
           <input id='l05' type='checkbox' name='Moderate' value='1' onclick='nc_user_obj.handler_checkbox(5)'> 
             <label for='l05'><?=CONTROL_CLASS_ACTIONS_MODERATE?></label><br>
           <input id='l06' type='checkbox' name='Administer' value='1' onclick='nc_user_obj.handler_checkbox(6)'> 
             <label for='l06'><?=CONTROL_CLASS_ACTIONS_ADMIN?></label><br> 
         </div> 
         
         <div name='div_perm_ban' id='div_perm_ban' style='display: none'>
           <input id='l1' type='checkbox' name='Read' value='1'> <label for='l1'><?=CONTROL_CLASS_ACTIONS_VIEW?></label><br>
           <? if ( nc_module_check_by_keyword("comments") ): ?>
           <input id='l7' type='checkbox' name='Comment' value='1'> <label for='l7'><?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_COMMENT?></label><br>
           <? endif; ?>
           <input id='l2' type='checkbox' name='Add' value='1'> <label for='l2'><?=CONTROL_CONTENT_CATALOUGE_ADD?></label><br>
           <input id='l3' type='checkbox' name='Edit' value='1'> <label for='l3'><?=CONTROL_CLASS_ACTIONS_EDIT?></label><br>
           <? if ( nc_module_check_by_keyword("subscriber", false) ): ?>
           <input id='l4' type='checkbox' name='Subscribe' value='1'> <label for='l4'><?=CONTROL_CLASS_ACTIONS_MAIL?></label><br>
           <? endif; ?>
         </div>
         
         <div name='div_perm_classificator' id='div_perm_classificator' style='display: none'>
           <input id='l1' type='checkbox' name='Edit' value='1'> <label for='l3'><?=CONTROL_CLASS_ACTIONS_EDIT?></label><br>
           <input id='l2' type='checkbox' name='Add' value='1'> <label for='l2'><?=CONTROL_CONTENT_CATALOUGE_ADD?></label><br>
           <input id='l3' type='checkbox' name='Moderate' value='1'> <label for='l5'><?=CONTROL_CLASS_ACTIONS_MODERATE?></label><br>
         </div>   
       
       </fieldset>
     </div>
       
  
       
       
   </td></tr><tr><td colspan='2'>
     <div name="div_help" id="div_help" style='display: none'>
       <fieldset><legend><b><font color='gray'><?=CONTROL_USER_RIGHTS_CONTROL_HELP?></font></b></legend> 
         <div id='help' name = 'help' style='padding: 10px'></div>
       </fieldset>
     </div>
   </td></tr></table>
  </form>
  
  <script type="text/javascript" src='<?=$ADMIN_PATH?>js/user.js'></script>
  <script type="text/javascript">
    nc_user_obj = new nc_user_perm();
  </script>
            <?


  $UI_CONFIG->actionButtons[] = array("id" => "addright",
                                          "caption" => CONTROL_USER_RIGHT_ADDNEWRIGHTS,
                                          "action" => "mainView.submitIframeForm()");
}


/**
 * Add permission
 *
 * @return int code error (0 - ok)
 */
function AddPermissionComleted () {
  global $db, $perm;

  foreach ($_POST AS $key => $val) {
    ;//$$key=$val;
    
  }
  $UserID     = $_POST['UserID'];     $PermissionGroupID = $_POST['PermissionGroupID'];
  
  $start_day  = $_POST['start_day'];    $start_month    = $_POST['start_month'];  $start_year = $_POST['start_year'];
  $start_hour = $_POST['start_hour'];   $start_minute = $_POST['start_mintue'];   $end_day    = $_POST['end_day']; 
  $end_month    = $_POST['end_month'];  $end_year      = $_POST['end_year'];      $end_hour   = $_POST['end_hour'];
  $end_minute = $_POST['end_mintue'];   
  $unlimit    = $_POST['unlimit'];      $ignore_start = $_POST['ignore_start'];   $ignore_stop = $_POST['ignore_stop'];
  
  $AdminType  = $_POST['AdminType'];  $usercontrol  = $_POST['usercontrol'];
  $Read = $_POST['Read'];             $Add = $_POST['Add'];                     $Edit = $_POST['Edit'];
  $Subscribe = $_POST['Subscribe'];   $Moderate = $_POST['Moderate'];           $Administer = $_POST['Administer'];
  $Comment   = $_POST['Comment'];
  
  $user_add = $_POST['user_add'];     $user_edit = $POST['user_edit'];          $user_del = $_POST['user_del'];
  
  $site_list = $_POST['site_list'];   $sub_list = $_POST['sub_list'];           $subclass_list = $_POST['subclass_list'];
  $item = $_POST['item'];             $dev_item = $_POST['dev_item'];           $dev_classificator = $_POST['dev_classificator'];
 
 
  $day_now = date("d"); $month_now = date("m"); $year_now = date("Y"); $hour_now = date("H"); $minute_now = date("i"); 
  $temp = 0;
  $insert_user_flag = false; //     
  $insert_item_flag = true;  //      (, , , , ...)
  $ret_value = 0;            //  - 
  
  //     
  if ( !($UserID + $PermissionGroupID) ) return 3;
  
  //       
  if ( $PermissionGroupID && !$perm->isSupervisor() ) return 2;
  
  // ,        
  if ( $UserID && in_array($UserID, (array)$perm->GetUserWithMoreRights()) ) return 2;
 
  #   
  if ($unlimit) { //
    $start_perm = '';
    $end_perm = '';
  }
  else {
    if ( $ignore_start) { //     
      $start_perm = '';
    }
    else { 
      if (!ConfirmInputData(array($start_day, $start_month, $start_year, $start_hour, $start_minute))) return 4;
      
      if ( substr($start_day,0 ,1)    == '+' )  $start_day = substr($start_day, 1) + $day_now;
      if ( $start_day    == ''  )  $start_day =  $day_now;
      if ( substr($start_month,0 ,1)  == '+' )  $start_month = (substr($start_month, 1) + $month_now);
      if ( $start_month == '' )  $start_month = $month_now;
      if ( substr($start_year,0 ,1)   == '+' )  $start_year = (substr($start_year, 1) + $year_now);
      if ( $start_year   == '' )  $start_year =  $year_now;
      if ( substr($start_hour,0 ,1)   == '+' )  $start_hour = (substr($start_hour, 1) + $hour_now);
      if ( $start_hour   == '' )  $start_hour =  $hour_now;
      if ( substr($start_minute,0 ,1)   == '+' )  $start_minute = (substr($start_minute, 1) + $minute_now);
      if ( $start_minute == '' )  $start_minute = $minute_now;
     
      $temp = mktime($start_hour, $start_minute, 0, $start_month, $start_day, $start_year);
      $start_perm = strftime('%Y-%m-%d %H:%M:%S', $temp);
    }
    if ( $ignore_stop) { //     
      $end_perm = '';
    }
    else { 
      if (!ConfirmInputData(array($end_day, $end_month, $end_year, $end_hour, $end_minute))) return 4;
      
      if ( substr($end_day,0 ,1)    == '+' )  $end_day = substr($end_day, 1) + $day_now;
      if ( $end_day    == ''  )  $end_day =  $day_now;
      if ( substr($end_month,0 ,1)  == '+' )  $end_month = (substr($end_month, 1) + $month_now);
      if ( $end_month == '' )  $end_month = $month_now;
      if ( substr($end_year,0 ,1)   == '+' )  $end_year = (substr($end_year, 1) + $year_now);
      if ( $end_year   == '' )  $end_year =  $year_now;
      if ( substr($end_hour,0 ,1)   == '+' )  $end_hour = (substr($end_hour, 1) + $hour_now);
      if ( $end_hour   == '' )  $end_hour =  $hour_now;
      if ( substr($end_minute,0 ,1)   == '+' )  $end_minute = (substr($end_minute, 1) + $minute_now);
      if ( $end_minute == '' )  $end_minute = $minute_now;

      $temp = mktime($end_hour, $end_minute, 0, $end_month, $end_day, $end_year);
      $end_perm = strftime('%Y-%m-%d %H:%M:%S', $temp);

    }
  }
  
  $insert = "INSERT INTO `Permission` (`User_ID`, `PermissionGroup_ID`, `AdminType`, `Catalogue_ID`, `PermissionSet`, `PermissionBegin`, `PermissionEnd`)";
  $insert.= " VALUES ('".intval($UserID)."', '".intval($PermissionGroupID)."',";
  $insert_user = $insert; //    -  
  
  
  switch ($AdminType) {
    case DIRECTOR:
      //     
      if (!$perm->isDirector()) return 2;
      $insert.= DIRECTOR.",0,0, ";
      break;
    case SUPERVISOR:
      if (!$perm->isSupervisor()) return 2;
      $insert.= SUPERVISOR.",0,0, ";
      break;
    case EDITOR:
      if (!$perm->isSupervisor()) return 2; 
      $PermissionSet = intval($Read*MASK_READ + $Add*MASK_ADD + $Edit*MASK_EDIT + $Comment*MASK_COMMENT +
                              $Subscribe*MASK_SUBSCRIBE + $Moderate*MASK_MODERATE + $Administer*MASK_ADMIN);
      if( !$PermissionSet ) $insert_item_flag = false;
      
      //   % ,   ?
      if      ($item == 1) { $c_id = $site_list;     $at = CATALOGUE_ADMIN;   }
      else if ($item == 2) { $c_id = $sub_list;      $at = SUBDIVISION_ADMIN; }
      else if ($item == 3) { $c_id = $subclass_list; $at = SUB_CLASS_ADMIN;   }  
      else                   $insert_item_flag = false;  //    ,   ""  
  
      $c_id = intval($c_id); 
      
      if( $item != 1 && !$c_id ) $insert_item_flag = false; //    ,   ""   (  )
     
      $insert.= $at.",'".$c_id."','".$PermissionSet."',";
      
      //  checkbox  
      if ( $usercontrol ) {
        $PermissionSet = intval(MASK_READ + $user_add*MASK_ADD + $user_edit*MASK_EDIT + $user_del*MASK_MODERATE); // 1 == view -  default
        $insert_user .= MODERATOR.",'0','".$PermissionSet."',";
        $insert_user_flag = true;
        //         
        if (!$perm->isSupervisor()) $insert_user_flag = false;
      }
      break;
    case DEVELOPER:
      if (!$perm->isSupervisor()) return 2;
      $dev_item = intval($dev_item);
      if ($dev_item != 1 ) $insert_item_flag = false; // now only classificator admin
      $PermissionSet = intval(MASK_READ + $Edit*MASK_EDIT + $Add*MASK_ADD + $Moderate*MASK_MODERATE); // 1 == view -  default
      $c_id = intval($dev_classificator);
      $insert.= CLASSIFICATOR_ADMIN.",'".$c_id."','".$PermissionSet."',";
      break;  
    case BAN:
      $PermissionSet = intval($Read*MASK_READ + $Comment*MASK_COMMENT + $Add*MASK_ADD + $Edit*MASK_EDIT + $Subscribe*MASK_SUBSCRIBE);
      if( !$PermissionSet ) $insert_item_flag = false;
      
      if      ($item == 1) { $c_id = $site_list;     $at = BAN_SITE;}
      else if ($item == 2) { $c_id = $sub_list;      $at = BAN_SUB; }
      else if ($item == 3) { $c_id = $subclass_list; $at = BAN_CC;  }  
      else                   $insert_item_flag = false;
      
      $c_id = intval($c_id);
      if( $item != 1 && !$c_id ) $insert_item_flag = false;
      
      $insert.= $at.",'".$c_id."','".$PermissionSet."',";
      break;
    case GUEST:
      if (!$perm->isSupervisor()) return 2;
      $insert.= GUEST.",'0','0',"; //print $insert; exit();
      break;
    default:
      $insert_item_flag = false; 
  }
   
  if ( $insert_item_flag) {
    $insert .= $start_perm ? "'".$start_perm."', " : "NULL, ";
    $insert .= $end_perm ? "'".$end_perm."' )" : "NULL )";
    if ( !$db->query($insert) ) $ret_value = 5;

  }
  if ($insert_user_flag) {
    $insert_user .= $start_perm ? "'".$start_perm."', " : "NULL, ";
    $insert_user .= $end_perm ? "'".$end_perm."' )" : "NULL )";
    if ( !$db->query($insert_user) ) $ret_value = 5;   

  }
  if (!$insert_item_flag && !$insert_user_flag)  $ret_value = 3; //   

  return $ret_value;
  
}


function UpdatePermission () {
  global $db;
  global $perm, $UserID, $PermissionGroupID;

  $UserID = (int) $UserID;
  $PermissionGroupID = (int) $PermissionGroupID;

  $Result = $db->query("UPDATE `Permission` SET `PermissionSet` = 0 WHERE `User_ID` = '".$UserID."' AND `PermissionGroup_ID` = '".$PermissionGroupID."'");

  $error = false;
  foreach ($_POST AS $key => $val) {
      $$key = $val;
      //eval("\$".$key."='".$val."';");
      if ( strncmp($key, "Delete", 6) != 0 ) {
        if ( substr($key, 0, 12) == "PermissionID" ) {
          $PermissionID = substr ($key, 12, strlen($key) - 14); 
          // TODO:   PermissionId    
          //      6
          $Result = $db->query("UPDATE `Permission` SET `PermissionSet` = (PermissionSet | ".$val.") WHERE `Permission_ID` = '".$PermissionID."'");

        }
        continue;
      }

      $nonDeletableID = $db->get_var("SELECT `Permission_ID` FROM `Permission` WHERE `User_ID` = '".$perm->GetUserID()."' AND `AdminType` = '".DIRECTOR."'");

      $nonDeletableID+= 0;

      $db->query("DELETE FROM `Permission` WHERE `Permission_ID` = '".$val."' AND `Permission_ID` <> '".$nonDeletableID."'");

    if ($db->captured_errors) {
      nc_print_status(CONTROL_USER_RIGHTS_ERR_CANTREMPRIV, 'error');
      $db->vardump($db->captured_errors);
      $error = true;
    }
  }
  
  if (!$error) nc_print_status(CONTROL_USER_RIGHTS_UPDATED_OK, 'ok');
  
  return;
  
}

function ChangeCheckedForUser ($UserID) {
    global $db;
    global $AUTH_USER_ID, $AUTH_USER_GROUP, $perm;
    $CheckActionTemplate = $db->get_var("SELECT CheckActionTemplate FROM Class WHERE System_Table_ID=3");
    $db->query("UPDATE User SET Checked=1-Checked WHERE User_ID='".$UserID."' AND User_ID<>'".$AUTH_USER_ID."'");
    eval ("echo \"".$CheckActionTemplate."\";");
}


/**
 * Confirm: all values in array must be +3 or 4
 *
 * @param array array_data
 * @return bool
 */
function ConfirmInputData ($array_data) {
  foreach ((array)$array_data as $v) {
    if ( !preg_match("/^(()|([+]?[0-9]+))$/", $v) ) return 0;
  }
  return 1;
}




/**
  * UI_CONFIG_USER
  */
class ui_config_user extends ui_config {

  /**
    * 
    */
  function ui_config_user() {
    $this->treeMode = "users";
    $this->treeSelectedNode = "users";
  }

  /**
    * c " "
    */
  function user_list_page() {

    $this->headerText = CONTROL_USER_USERSANDRIGHTS;
    $this->headerImage = "i_usergroup_big.gif";
    $this->tabs = array(
                    array('id' => 'list',
                          'caption' => SECTION_CONTROL_USER,
                          'location' => "user.list()"),
                        );
    $this->activeTab = 'list'; // i.e. "tab1"
    $this->locationHash = "user.list()";
  }

  /**
    *    
    * (: ; )
    * @param integer user id
    * @param string login
    * @param string active tab ('user'; 'rights')
    * @param string optinal -   (  - )
    */
  function user_page($user_id, $user_login, $active_tab, $hash = "") {
    global $perm;  
  
    $this->headerText = CONTROL_USER . " $user_login";
    $this->headerImage = "i_user_big.gif";
    // , 
    $this->tabs[0] =     array('id' => 'edit',
                               'caption' => CONTROL_USER,
                               'location' => "user.edit($user_id)");
    if ($perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, $user_id)) $this->tabs[1] = array('id' => 'rights',
                                                                'caption' => SECTION_INDEX_USER_RIGHTS_RIGHTS,
                                                                'location' => "user.rights($user_id)");

                     
    $this->activeTab = $active_tab;
    if (!$perm->isAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, $user_id) ) $this->activeTab = 'user';
    $this->locationHash = ($hash ? $hash : "user.$active_tab($user_id)");
  }

  function new_user_page() {
    $this->headerText = CONTROL_USER_REG;
    $this->headerImage = "i_user_big.gif";
    $this->tabs = array(
                         array('id' => 'add',
                               'caption' => CONTROL_USER_REG,
                               'location' => "user.add()")
                        );
    $this->activeTab = "add";
    $this->locationHash = "user.add()";
  }

}

/**
  * UI_CONFIG_USERGROUP
  */

class ui_config_usergroup extends ui_config {

  /**
    * 
    */
  function ui_config_usergroup() {
    $this->treeMode = "users";
  }

  /**
    * c " "
    */
  function usergroup_list_page() {

    $this->headerText = CONTROL_USER_GROUPS;
    $this->headerImage = "i_usergroup_big.gif";
    $this->tabs = array(
                    array('id' => 'list',
                          'caption' => CONTROL_USER_GROUPS,
                          'location' => "usergroup.list()"),
                        );
    $this->activeTab = 'list';
    $this->locationHash = "usergroup.list()";
    $this->treeSelectedNode = "usergroup";
  }

  /**
    *    
    * (: ; )
    * @param integer id
    * @param string name
    * @param string active tab ('group'; 'rights')
    * @param string optinal -   (  - )
    */
  function group_page($group_id, $group_name, $active_tab, $hash = "") {
    $this->headerText = $group_name;
    $this->headerImage = "i_usergroup_big.gif";
    // , 
    $this->tabs = array(
                         array('id' => 'edit',
                               'caption' => CONTROL_USER_MAIL_GROUP,
                               'location' => "usergroup.edit($group_id)"),

                         array('id' => 'rights',
                               'caption' => SECTION_INDEX_USER_RIGHTS_RIGHTS,
                               'location' => "usergroup.rights($group_id)")

                        );
    $this->activeTab = $active_tab;
    $this->locationHash = ($hash ? $hash : "usergroup.$active_tab($group_id)");
    $this->treeSelectedNode = "usergroup-{$group_id}";
  }

  function new_group_page() {
    $this->headerText = CONTROL_USER_GROUPS_ADD;
    $this->headerImage = "i_usergroup_big.gif";
    $this->tabs = array(
                         array('id' => 'add',
                               'caption' => CONTROL_USER_GROUPS_ADD,
                               'location' => "usergroup.add()")
                        );
    $this->activeTab = "add";
    $this->locationHash = "usergroup.add()";
    $this->treeSelectedNode = "usergroup";
  }


}


?>