<?php
/* $Id: index.php 2467 2008-12-06 13:51:00Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
require ($ADMIN_FOLDER."user/function.inc.php");
require ($INCLUDE_FOLDER."s_files.inc.php");
require ($INCLUDE_FOLDER."s_common.inc.php");


if (is_numeric($UserID)) {
  $user_login = GetLoginByID($UserID);
}
else {
  $user_login = "";
}

$main_section = "control";
$item_id=5;
$Delimeter = " &gt ";
$Title2 = CONTROL_USER_USERSANDRIGHTS;
$Title3 = "<a href=\"".$ADMIN_PATH."user/\">".SECTION_CONTROL_USER_LIST."</a>";
$Title5 = $user_login;
$Title6 = CONTROL_USER_PASSCHANGE;
$Title7 = $user_login." (".CONTROL_USER_ACESSRIGHTS.")";
$Title8 = "<a href=\"".$ADMIN_PATH."user/?phase=8&UserID=".$UserID."\">".$user_login." (".CONTROL_USER_ACESSRIGHTS.")</a>";
$Title9 = CONTROL_USER_CATALOGUESWITCH;
$Title10 = CONTROL_USER_SECTIONSWITCH;
$Title11 = CONTROL_USER_TITLE_USERINFOEDIT;
$Title12 = CONTROL_USER_TITLE_PASSWORDCHANGE." ".$user_login;
$Title13 = CONTROL_SETTINGSFILE_TITLE_ADD;


//  
$UI_CONFIG = new ui_config_user();
$UI_CONFIG->user_list_page();


if (!isset($phase)) $phase=1;


switch ($phase) {
  case 1:
    #    
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_LIST,0, 0, 0);
    $UI_CONFIG = new ui_config_user();
    $UI_CONFIG->user_list_page();
    SearchUserResult ();
    break;

  case 2:
    #    
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_LIST, 0, 0, 0);
    $UI_CONFIG = new ui_config_user();
    $UI_CONFIG->user_list_page();
    SearchUserResult ();
    break;

  case 3:
    #  
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_DEL,-1, 0, 1);
    $UI_CONFIG = new ui_config_user();
    $UI_CONFIG->user_list_page();
    DeleteUsers ();
    SearchUserResult ();
    break;

  case 4:
    #    
    BeginHtml ($Title11, $Title3.$Delimeter.$Title5, "http://".$DOC_DOMAIN."/management/users/info/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_EDIT, $UserID, 0, 0);
    $UI_CONFIG = new ui_config_user();
    $UI_CONFIG->user_list_page();
    $UI_CONFIG->user_page($UserID, $user_login, "edit");
    UserForm ($UserID, "index.php", 5, 2);
    break;

  case 5:
    #    
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_EDIT, $UserID, 0, 1);

    eval("\$Login = \$f_${AUTHORIZE_BY};");
    if ( CheckLoginIfExist ($Login, $UserID, $db) )
    {
        $UI_CONFIG->user_page($UserID, $user_login, "edit");
        $posting = 0;
        nc_print_status(CONTROL_USER_ERROR_LOGININUSE, 'error');
        UserForm ($UserID, "index.php", 5, 2);
        EndHtml ();
        exit;
    }
    if ($posting == 1)
    {
        if (ActionUserCompleted ("index.php", 2) )
        {
            unset ($Checked);
            unset ($UserID);
            unset ($PermissionGroupID);
            SearchUserResult ();
        }
    }
    break;

  case 6:
    #    
    $UI_CONFIG->user_page($UserID, $user_login, "edit", "user.password($UserID)");
    BeginHtml ($Title12, $Title3.$Delimeter.$Title6, "http://".$DOC_DOMAIN."/management/users/password/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_EDIT, $UserID, 0, 0);
    ChangePasswordForm ($UserID);
    break;

  case 7:
    #   
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_EDIT, $UserID, 0, 1); 
    if ( ( strlen($Password1) == 0) && (strlen($Password2) == 0) ) {  
      BeginHtml ($Title2, $Title3.$Delimeter.$Title6, "http://".$DOC_DOMAIN."/management/users/password/");
      $UI_CONFIG->user_page($UserID, $user_login, "edit", "user.password($UserID)");
      nc_print_status(CONTROL_USER_ERROR_EMPTYPASS."<BR>\n".CONTROL_USER_ERROR_RETRY."<BR>\n", 'error');
      ChangePasswordForm ($UserID);
    }
    elseif ($Password1 == $Password2) {  
      BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");  
      ChangePassword ($UserID, $Password1, $db);
      unset ($UserID);
      SearchUserResult ();
    }
    else {
        $UI_CONFIG->user_page($UserID, $user_login, "edit", "user.password($UserID)");
        BeginHtml ($Title2, $Title3.$Delimeter.$Title6, "http://".$DOC_DOMAIN."/management/users/password/");       
        nc_print_status(CONTROL_USER_ERROR_PASSDIFF."<BR>\n".CONTROL_USER_ERROR_RETRY."<BR>\n", 'error');
        ChangePasswordForm ($UserID);
    }
    break;

  case 8:
    #    
    $UI_CONFIG->user_page($UserID, $user_login, "rights");
    BeginHtml ($Title2, $Title3.$Delimeter.$Title7, "http://".$DOC_DOMAIN."/management/users/rights/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, $UserID, 0, 0);
    ShowUserPermissions ($UserID, 11);
    break;

  case 9:
    #      
    $UI_CONFIG->user_page($UserID, $user_login, "rights");
    BeginHtml ($Title2, $Title3.$Delimeter.$Title8.$Delimeter.$Title13, "http://".$DOC_DOMAIN."/management/users/rights/add/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, $UserID, 0, 0);
    AddPermissionForm ($UserID);
    break;

  case 10:
    #   
    BeginHtml ($Title2, $Title3.$Delimeter.$Title7, "http://".$DOC_DOMAIN."/management/users/rights/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, $UserID, 0, 1);
    $UI_CONFIG->user_page($UserID, $user_login, "rights");
    
    $ret_val = AddPermissionComleted ($UserID);
    $array_error = GetArrayWithError_User();
    if ($ret_val) {
      if($ret_val != '1') nc_print_status($array_error[$ret_val], 'error');
    }
    else {
      nc_print_status(CONTROL_USER_RIGHTS_ADDED, 'ok');
    }

    ShowUserPermissions ($UserID, 11);
    break;

  case 11:
    #    
    BeginHtml ($Title2, $Title3.$Delimeter.$Title7, "http://".$DOC_DOMAIN."/management/users/rights/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, $UserID, 0, 1);
    $UI_CONFIG->user_page($UserID, $user_login, "rights");
    UpdatePermission ();
    ShowUserPermissions ($UserID, 11);
    break;

   
  case 12:
    # / 
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_EDIT, $UserID, 0, 1);
    
    ChangeCheckedForUser ($UserID);
    
    unset ($UserID);
    SearchUserResult ();
    break;

  case 13:
    #   
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_DEL, $KillUserID, 0, 1);
    DeleteOneUser ($KillUserID);
    SearchUserResult ();
    break;
  case 14: 
    # 
    BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/management/users/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_DEL, $UserID, 0, 0);
    if (ConfirmDeleteUsers() ) {
      $UI_CONFIG->actionButtons[] = array("id" => "confirm",
                                          "caption" => CONTROL_USER_FUNC_CONFIRM_DEL_OK,
                                          "action" => "mainView.submitIframeForm()");  
    }
    break;
        
  case 20: //  ajax
    $perm->ExitIfNotAccess(NC_PERM_ITEM_USER, NC_PERM_ACTION_RIGHT, -1, 0, 0);

    $getsublist       = intval($_POST['getsublist']);           //    getsublist
    $getclassificator = intval($_POST['getclassificator']);     //  
    $getsubclasslist  = intval($_POST['getsubclasslist']);      //     getsubclasslist

    $res = '';
    
    if ($getsublist) { //   
      $Result = $db->get_results("SELECT `Subdivision_ID` AS value,
                                  CONCAT(Subdivision_ID, '. ', Subdivision_Name) AS description,
                                  `Parent_Sub_ID` AS parent
                                  FROM `Subdivision`
                                  WHERE `Catalogue_ID` = '".$getsublist."'
                                  ORDER BY `Subdivision_ID`", ARRAY_A);
      $res = nc_select_options($Result); 
    }
    else if ($getsubclasslist) { //  cc
      $subclasses = $db->get_results("SELECT CONCAT(`Sub_Class_ID`, '. ', `Sub_Class_Name`) AS descr, `Sub_Class_ID` AS id 
                                      FROM `Sub_Class`
                                      WHERE `Subdivision_ID` = '".$getsubclasslist."' 
                                      ORDER BY `Sub_Class_ID`", ARRAY_A); 
      foreach ( (array)$subclasses as $sc ) {
        $res .= "<option value='".$sc['id']."'>".$sc['descr']."</option>\n"; 
      }

    }

    else if ($getclassificator) { //  
      $classificators = $db->get_results("SELECT `Classificator_ID` AS id, `Classificator_Name` AS name, `System` AS sys
                                         FROM `Classificator`
                                         ORDER BY `Classificator_ID`", ARRAY_A);
      $res .= "<option value='0'>".CONTENT_CLASSIFICATORS_NAMEALL."</option>\n";
      foreach ( (array)$classificators as $cl ) {
        $font_color = $cl['sys'] ? '#FF0000' : '000000'; 
        $res .= "<option value='".$cl['id']."' style='color: ".$font_color."'>".$cl['id']." ".$cl['name']."</option>\n"; 
      }

    }
    
    print $res; exit();
    
  }
EndHtml ();


?>