<?php





function nc_class_wizard_start($class_name = '', $class_group = '', $class_group_new = '') {

	global $db, $UI_CONFIG;

	echo "<form method='post' action='wizard_class.php'>";
	echo WIZARD_CLASS_FORM_START_TEMPLATE_TYPE.":<br><select name='Class_Type'>";
	echo("\t<option value='1'>".WIZARD_CLASS_FORM_START_TEMPLATE_TYPE_SINGLE."</option>\n");
	echo("\t<option value='2'>".WIZARD_CLASS_FORM_START_TEMPLATE_TYPE_LIST."</option>\n");
	echo("\t<option value='3'>".WIZARD_CLASS_FORM_START_TEMPLATE_TYPE_SEARCH."</option>\n");
	echo("\t<option value='4'>".WIZARD_CLASS_FORM_START_TEMPLATE_TYPE_FORM."</option>\n");
	echo "</select><br><br>";

	echo CONTROL_CLASS_CLASS_NAME.":<br><input type='text' name='ClassName' size='50' value='".($class_name?$class_name:CONTROL_CLASS_NEWCLASS)."'><br><br>";
	echo CONTROL_USER_GROUP.":<br><select name='Class_Group'>";

	foreach ($db->get_col("SELECT DISTINCT Class_Group FROM Class") as $Class_Group) {
		if ($class_group == $Class_Group) echo("\t<option value='".$Class_Group."' selected>".$Class_Group."</option>\n");
		else echo("\t<option value='".$Class_Group."'>".$Class_Group."</option>\n");
	}

	echo "</select>";
	echo "&nbsp;".CONTROL_CLASS_NEWGROUP.":&nbsp;<input type='text' name='Class_Group_New' size='8' maxlength='64' value='".$class_group_new."'><br><br>";
	echo "<input type='hidden' name='phase' value='2'>";
	echo "<input type='submit' class='hidden'>";
	echo "</form>";
	
	$UI_CONFIG->actionButtons[] = array("id" => "submit", "caption" => WIZARD_CLASS_BUTTON_NEXT_TO_ADDING_FIELDS, "action" => "mainView.submitIframeForm()");
	
	return true;
}






/**
 * Print hidden filed and show button "FINISH_ADDING_FIELDS"
 *
 * @param int ClassID
 * @param int ClassType
 */
function nc_class_wizard_fields_end ($ClassID, $ClassType) {
  global $UI_CONFIG, $db;
   
  $field_count = $db->get_var("SELECT COUNT(Field_ID) FROM `Field` WHERE Class_ID = '".$ClassID."'"); 
  if ($field_count) {
    echo "<form id='Wizard' method='post' action='wizard_class.php'>";
	
  	if ($ClassType == 1) echo "<input type='hidden' name='phase' value='5'>";
  	else echo "<input type='hidden' name='phase' value='4'>";
  	
  	echo "<input type='hidden' name='Class_Type' value='".$ClassType."'>";
  	echo "<input type='hidden' name='ClassID' value='".$ClassID."'>";
  	//echo "<input type='hidden' name='ClassName' value='".$class_name."'>";
  	//echo "<input type='hidden' name='Class_Group' value='$class_group'>";
  	
  	$UI_CONFIG->actionButtons[] = array("id" => "finish", 
  	                                    "caption" => WIZARD_CLASS_BUTTON_FINISH_ADDING_FIELDS, 
  	                                    "action" => "mainView.submitIframeForm('Wizard')", 
  	                                    "align" => "left");
  	echo "<input type='submit' class='hidden'>";
  	echo "</form>";  
  }
 
  return;
}


function nc_class_wizard_field_template($object, $show_description = true, $fullLink = false){
	$template = '';
	$description = ($show_description ? "<b>".$object['Description'].":</b> " : "");
	$fullLink_prefix = ($fullLink ? "<a href='\$fullLink'>" : "");
	$fullLink_suffix = ($fullLink ? "</a>" : "");

	switch ($object['TypeOfData_ID']) {
	  case 8: #Date 
		  $template .= $description.$fullLink_prefix."\$f_".$object['Field_Name'];
		  if ($object['Format'] == 'event_date')    $template .= "_day.\$f_".$object['Field_Name']."_month.\$f_".$object['Field_Name']."_year".$fullLink_suffix;
		  elseif($object['Format'] == 'event_time') $template .= "_hours:\$f_".$object['Field_Name']."_minutes:\$f_".$object['Field_Name']."_seconds".$fullLink_suffix;
		  $template .= $fullLink_suffix;
	   break;
	 case 6:
	   if (!$fullLink)
		  $template .= $description."<a href='\$f_".$object['Field_Name']."'>\$f_".$object['Field_Name']."_name</a> (\".nc_bytes2size(\$f_".$object['Field_Name']."_size).\")";
	   break;
	 case 10:
	     $template .= $description.$fullLink_prefix."\".nc_array_to_string(\$f_".$object['Field_Name'].", array([element]=>'%ELEMENT', [divider]=>', ').\" ".$fullLink_suffix;
	   break;
	 default :
		$template .= $description.$fullLink_prefix."\$f_".$object['Field_Name'].$fullLink_suffix;
	
	}
	return $template;
}



function nc_class_wizard_settings($class_id, $class_type, $class_name = '', $class_group = '') {
  global $db, $UI_CONFIG;
  
  $fields = $db->get_results("SELECT `Field_ID`, `Field_Name`, `Description` FROM `Field` WHERE `Class_ID` = '".$class_id."' ORDER BY `Field_ID`", ARRAY_A);
  echo "<form method='POST' action='wizard_class.php' name='settings'>";
  switch ($class_type) {
    
    case 1: #one object on page
      nc_print_status(WIZARD_CLASS_FORM_SETTINGS_NO_SETTINGS, 'error');
    break;
    
    case 4: #Web-form
      echo "<fieldset><legend>".WIZARD_CLASS_FORM_SETTINGS_FEEDBACK_FIELDS_SETTINGS."</legend>";
      foreach ($fields as $field) {
        echo "<label for='SettingsFormFields[".$field[Field_ID]."]'><input type='checkbox' name='SettingsFormFields[".$field[Field_ID]."]' id='SettingsFormFields[".$field[Field_ID]."]' value='".$field[Field_ID]."'> ".$field[Field_Name]." (".$field[Description].")</label><br>";
      }
      ?>
      </fieldset><br>
      <?=WIZARD_CLASS_FORM_SETTINGS_FEEDBACK_SENDER_NAME?>:<br>
      <input type='text' name='SettingsSenderName' value=''><br><br>
      <?=WIZARD_CLASS_FORM_SETTINGS_FEEDBACK_SENDER_MAIL?>:<br>
      <input type='text' name='SettingsSenderEmail' value=''><br><br>
      <?=WIZARD_CLASS_FORM_SETTINGS_FEEDBACK_SUBJECT?>:<br>
      <input type='text' name='$SettingsMailSubject' value=''><br><br>
      <?
      break;

    case 3: #Search
     echo "<fieldset><legend><".WIZARD_CLASS_FORM_SETTINGS_FIELDS_FOR_OBJECT_SEARCH."</legend>";
     foreach ($fields as $field) {
      echo "<label for='SettingsSearchFields[".$field[Field_ID]."]'><input type='checkbox' name='SettingsSearchFields[".$field[Field_ID]."]' id='SettingsSearchFields[".$field[Field_ID]."]' value='".$field[Field_ID]."'> ".$field[Field_Name]." (".$field[Description].")</label><br>";
    }

   echo "</fieldset><br>";
 
    // break   -      " "

    case 2: //  
      echo "<fieldset><legend><".WIZARD_CLASS_FORM_SETTINGS_FIELDS_FOR_OBJECT_LIST."</legend>";
      foreach ($fields as $field) {
        echo "<label for='SettingsObjectList[".$field[Field_ID]."]'>
              <input type='checkbox' name='SettingsObjectList[".$field[Field_ID]."]' id='SettingsObjectList[".$field[Field_ID]."]' 
                    value='".$field[Field_ID]."'> ".$field[Field_Name]." (".$field[Description].")</label><br>";
    }
    ?>
      </fieldset>
      <br>
      <fieldset>
  	   <legend><?=WIZARD_CLASS_FORM_SETTINGS_SETTINGS_FOR_LIST_VIEW?></legend>
       <b><?=WIZARD_CLASS_FORM_SETTINGS_OBJECT_NUMBER_ON_THE_PAGE?>:</b><br><input type='text' name='SettingsRecNum' value='20'><br><br>
       <b><?=WIZARD_CLASS_FORM_SETTINGS_SORT_OBJECT_BY_FIELD?>:</b><br>
       <select name='SettingsSort'>
		   <option id='SettingsSort0' value='0'><?=WIZARD_CLASS_DEFAULT?>
    <?

    foreach ($fields as $field) {
      echo "<option value='".$field[Field_Name]."'>".$field[Field_Name]." (".$field[Description].")";
    }

    ?>
      </select><br><br>
      <label for='SettingsSortDirection1'><input type='radio' name='SettingsSortDirection' id='SettingsSortDirection1' value='1' checked> 
        <?=WIZARD_CLASS_FORM_SETTINGS_SORT_ASC?></label><br>
      <label for='SettingsSortDirection2'><input type='radio' name='SettingsSortDirection' id='SettingsSortDirection2' value='2'> 
        <?=WIZARD_CLASS_FORM_SETTINGS_SORT_DESC?></label><br><br>
      <b><?=WIZARD_CLASS_FORM_SETTINGS_PAGE_NAVIGATION?>:</b><br>
      <label for='SettingsNavigation1'><input type='radio' name='SettingsNavigation' id='SettingsNavigation1' value='1' checked> 
        <?=WIZARD_CLASS_FORM_SETTINGS_PAGE_NAVIGATION_BY_NEXT_PREV?></label><br>
      <label for='SettingsNavigation2'><input type='radio' name='SettingsNavigation' id='SettingsNavigation2'value='2'>
        <?=WIZARD_CLASS_FORM_SETTINGS_PAGE_NAVIGATION_BY_PAGE_NUMBER?></label><br>
      <label for='SettingsNavigation3'><input type='radio' name='SettingsNavigation' id='SettingsNavigation3' value='3'> 
        <?=WIZARD_CLASS_FORM_SETTINGS_PAGE_NAVIGATION_BY_BOTH?></label><br>
      <br><b><?=WIZARD_CLASS_FORM_SETTINGS_LOCATION_OF_NAVIGATION?>:</b><br>
      <label for='SettingsNavigationPosition1'><input type='radio' name='SettingsNavigationPosition' id='SettingsNavigationPosition1' value='1' checked> 
        <?=WIZARD_CLASS_FORM_SETTINGS_LOCATION_TOP?></label><br>
      <label for='SettingsNavigationPosition2'><input type='radio' name='SettingsNavigationPosition' id='SettingsNavigationPosition2' value='2'> 
        <?=WIZARD_CLASS_FORM_SETTINGS_LOCATION_BOTTOM?></label><br>
      <label for='SettingsNavigationPosition3'><input type='radio' name='SettingsNavigationPosition' id='SettingsNavigationPosition3' value='3'> 
        <?=WIZARD_CLASS_FORM_SETTINGS_LOCATION_BOTH?></label><br>

      <br><b><?=WIZARD_CLASS_FORM_SETTINGS_LIST_OBJECT_TYPE?>:</b><br>
      <label for='SettingsObjectListType1'><input type='radio' name='SettingsObjectListType' id='SettingsObjectListType1' value='1' checked> 
        <?=WIZARD_CLASS_FORM_SETTINGS_LIST_TYPE?></label><br>
      <label for='SettingsObjectListType2'><input type='radio' name='SettingsObjectListType' id='SettingsObjectListType2' value='2'> 
        <?=WIZARD_CLASS_FORM_SETTINGS_TABLE_TYPE?></label><br>
    </fieldset>
    <br>
    <fieldset id='SettingsObjectListDelimiter'>
      <legend><?=WIZARD_CLASS_FORM_SETTINGS_LIST_TYPE_SETTINGS?></legend>
      <b><?=WIZARD_CLASS_FORM_SETTINGS_LIST_DELIMITER_TYPE?>:</b><br>
      <label for='SettingsObjectListDelimiter1'><input type='radio' name='SettingsObjectListDelimiter' id='SettingsObjectListDelimiter1' value='1' checked> &lt;hr&gt</label><br>
   	  <label for='SettingsObjectListDelimiter2'><input type='radio' name='SettingsObjectListDelimiter' id='SettingsObjectListDelimiter2' value='2'> &lt;br&gt</label><br>
    </fieldset>
    <fieldset id='SettingsObjectTable'>
    	<legend><?=WIZARD_CLASS_FORM_SETTINGS_TABLE_TYPE_SETTINGS?></legend>
    <label for='SettingsObjectTableBackground'><input type='checkbox' name='SettingsObjectTableBackground' id='SettingsObjectTableBackground' value='1'> 
    <?=WIZARD_CLASS_FORM_SETTINGS_TABLE_BACKGROUND?></label><br>
    <label for='SettingsObjectTableBorder'><input type='checkbox' name='SettingsObjectTableBorder' id='SettingsObjectTableBorder' value='1'> 
    <?=WIZARD_CLASS_FORM_SETTINGS_TABLE_BORDER?></label><br>
    </fieldset>
    <br>
    <label for='SettingsIsObjectFull'><input type='checkbox' id='SettingsIsObjectFull' name='SettingsIsObjectFull' value='1'> 
    <?=WIZARD_CLASS_FORM_SETTINGS_FULL_PAGE?></label><br>
    <br>
    <fieldset id='SettingsObjectFullLink' style='display: none;'>
    <legend><?=WIZARD_CLASS_FORM_SETTINGS_FULL_PAGE_LINK_TYPE?></legend>
    <?=WIZARD_CLASS_FORM_SETTINGS_CHECK_FIELDS_TO_FULL_PAGE?><br>
    <?

    foreach ($fields as $field) {
		  echo "<label for='SettingsObjectFullLink[".$field[Field_ID]."]'>
		        <input type='checkbox' name='SettingsObjectFullLink[".$field[Field_ID]."]' id='SettingsObjectFullLink[".$field[Field_ID]."]' value='".$field[Field_ID]."'> ".$field[Field_Name]." (".$field[Description].")</label><br>";
	 }

    ?>
  </fieldset>
  <br>
  <fieldset id='SettingsObjectFull' style='display: none;'>
  	<legend><?=WIZARD_CLASS_FORM_SETTINGS_FIELDS_TO_SHOW_OBJECT?></legend>
    <?

    foreach ($fields as $field) {
      echo "<label for='SettingsObjectFull[".$field[Field_ID]."]'><input type='checkbox' name='SettingsObjectFull[".$field[Field_ID]."]' id='SettingsObjectFull[".$field[Field_ID]."]' value='".$field[Field_ID]."'> ".$field[Field_Name]." (".$field[Description].")</label><br>";
    }

    ?>
  </fieldset>

<script>
  var settingsIsObjectFull = document.getElementById('SettingsIsObjectFull');
  var settingsObjectFullLink = document.getElementById('SettingsObjectFullLink');
  var settingsObjectFull = document.getElementById('SettingsObjectFull');

  var settingsObjectListDelimiter = document.getElementById('SettingsObjectListDelimiter');
  var settingsObjectTable = document.getElementById('SettingsObjectTable');

  settingsObjectListDelimiter.style.display = 'none';
  settingsObjectTable.style.display = 'none';

  settingsIsObjectFull.onclick =  function() {
    if(settingsIsObjectFull.checked) {
      settingsObjectFullLink.style.display = '';
      settingsObjectFull.style.display = '';
    } else {
      settingsObjectFullLink.style.display = 'none';
      settingsObjectFull.style.display = 'none';
    }
    return true;
  }

//  var settingsObjectListDelimiter = document.getElementById('SettingsObjectListDelimiter');

  var radio = document.forms.settings.SettingsObjectListType;

  for (var i = 0; i < radio.length; i++) {
    if (radio[i].checked) {
      if (radio[i].value == 1) {
        settingsObjectListDelimiter.style.display = '';
        settingsObjectTable.style.display = 'none';
      }
      if (radio[i].value == 2) {
        settingsObjectTable.style.display = '';
        settingsObjectListDelimiter.style.display = 'none';
      }
    }
    radio[i].onclick = function() {
      if (this.checked) {
        if (this.value == 1) {
          settingsObjectListDelimiter.style.display = '';
          settingsObjectTable.style.display = 'none';
        }
        if (this.value == 2) {
          settingsObjectTable.style.display = '';
          settingsObjectListDelimiter.style.display = 'none';
        }
      }
    }
  }

</script>
      <?

    break;

   
   

  
    
  }

  echo "<input type='hidden' name='phase' value='5'>";
  echo "<input type='hidden' name='Class_Type' value='$class_type'>";
  echo "<input type='hidden' name='ClassID' value='$class_id'>";
  echo "<input type='hidden' name='ClassName' value='".$class_name."'>";
  echo "<input type='hidden' name='Class_Group' value='$class_group'>";
  echo "<input type='submit' class='hidden'>";
  echo "</form>";
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => WIZARD_CLASS_BUTTON_SAVE_SETTINGS,
                                      "action" => "mainView.submitIframeForm()"
                                     );
}

function nc_class_wizard_select_site($class_id, $class_type, $phase) {
  global $db, $UI_CONFIG;

  //echo " <iframe name='treeIframe' id='treeIframe' src='/netcat/admin/tree_frame.php?mode=wizard_subdivision' height='100%' width='100%' frameborder='0'></iframe>";

  echo "<form action='wizard_class.php' method='POST'>";
  echo " : <select name='CatalogueID'>";
  $sites = $db->get_results("SELECT Catalogue_ID, Catalogue_Name FROM Catalogue ORDER BY Catalogue_ID",ARRAY_A);
  foreach ($sites as $site) {
    echo "<option value=".$site['Catalogue_ID'].">".$site['Catalogue_ID'].": ".$site['Catalogue_Name']."";
  }
  echo "</select><br>";
  echo "<input type='hidden' name='phase' value='".$phase."'>";
  echo "<input type='hidden' name='ClassID' value='".$class_id."'>";
  echo "<input type='hidden' name='Class_Type' value='".$class_type."'>";
  echo "<input type='submit' class='hidden'>";
  echo "</form>";
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => WIZARD_CLASS_BUTTON_NEXT_TO_SUBDIVISION_SELECTION,
                                      "action" => "mainView.submitIframeForm()"
                                     );
}

function nc_class_wizard_select_subdivision($class_id, $catalogue_id, $class_type, $phase) {
  global $db, $UI_CONFIG;

  echo "<form action='wizard_class.php' method='POST'>";
  echo " : <select name='ParentSubID'>";
  $subdivisions = $db->get_results("SELECT Subdivision_ID as value,
                                           CONCAT(Subdivision_ID, '. ', Subdivision_Name) as description,
                                           Parent_Sub_ID as parent
                                      FROM Subdivision
                                     WHERE Catalogue_ID='".$catalogue_id."'
                                  ORDER BY Subdivision_ID", ARRAY_A);
  echo nc_select_options($subdivisions);
  echo "</select><br>";
  echo "<input type='hidden' name='phase' value='".$phase."'>";
  echo "<input type='hidden' name='ClassID' value='".$class_id."'>";
  echo "<input type='hidden' name='Class_Type' value='".$class_type."'>";
  echo "<input type='hidden' name='CatalogueID' value='".$catalogue_id."'>";
  echo "<input type='submit' class='hidden'>";
  echo "</form>";
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => WIZARD_CLASS_BUTTON_CREATE_SUBDIVISION_WITH_NEW_TEMPLATE,
                                      "action" => "mainView.submitIframeForm()"
                                     );
}

function nc_class_wizard_select_action($class_id, $class_type) {
  global $db, $UI_CONFIG, $ADMIN_PATH;

  echo "<div>".WIZARD_CLASS_TAB_SUBSEQUENT_ACTION.":</div>";
  echo "<ul>";
  echo "<li><a href='".$ADMIN_PATH."class/index.php?phase=4&ClassID=$class_id'>".WIZARD_CLASS_LINKS_VIEW_TEMPLATE_CODE."</a>";
  echo "<li><a href='wizard_class.php?phase=6&Class_Type=$class_type&ClassID=$class_id'>".WIZARD_CLASS_LINKS_CREATE_SUBDIVISION_WITH_NEW_TEMPLATE."</a>";
  echo "<li><a href='wizard_class.php?phase=8&Class_Type=$class_type&ClassID=$class_id'>".WIZARD_CLASS_LINKS_ADD_TEMPLATE_TO_EXISTENT_SUBDIVISION."</a>";
  echo "<li><a href='wizard_class.php'>".WIZARD_CLASS_LINKS_CREATE_NEW_TEMPLATE."</a>";
  echo "</ul>";

  $UI_CONFIG->actionButtons = '';
}


function nc_class_wizard_subdivision_form($class_id) {
  global $UI_CONFIG, $ADMIN_PATH;
  global $Subdivision_Name, $EnglishName, $Checked, $ParentSubID, $CatalogueID;

  echo "<form id='Subdivision' enctype='multipart/form-data' method='post' action='wizard_class.php'>\n";
  echo "<fieldset>\n";
  echo "<legend>".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA."</legend>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_NAME.":<br>\n";
  echo "<input type='text' name='Subdivision_Name' size='50' maxlength='255' value='".$Subdivision_Name."'><br><br>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_KEYWORD.":<br>\n";
  echo "<input type='text' name='EnglishName' size='50' maxlength='255' value='".$EnglishName."'><br><br>\n";
  echo WIZARD_CLASS_FORM_SUBDIVISION_PARENTSUB.":<br>\n";
  echo "<input id='SelectedSub' type='text' name='ParentSubID' value='".$ParentSubID."' readonly>\n";
  echo "&nbsp;&nbsp;&nbsp;<a href='#' onclick=\"window.open('".$ADMIN_PATH."wizard/select_parentsub.php', 'nc_popup_map', 'width=350,height=500,menubar=no,resizable=no,scrollbars=no,toolbar=no,resizable=yes'); return false;\">".WIZARD_CLASS_FORM_SUBDIVISION_SELECT_PARENTSUB."</a><br><br>\n";
//  echo "&nbsp;&nbsp;&nbsp;<a href='#' onclick=\"document.getElementById('SelectedSub').value='';document.getElementById('SelectedCat').value='';return false;\">".WIZARD_CLASS_FORM_SUBDIVISION_DELETE."</a><br><br>\n";
  echo "<input id='turnon' type='checkbox' name='Checked' value='1' ".(isset($Checked)?($Checked?"checked":""):"checked")."> <label for='turnon'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_TURNON."</label>\n";
  echo "</fieldset>\n";
  echo "<input type='hidden' name='TemplateID' value='0'>\n<input type='hidden' name='ReadAccessID' value='0'>\n<input type='hidden' name='WriteAccessID' value='0'>\n<input type='hidden' name='EditAccessID' value='0'>\n<input type='hidden' name='SubscribeAccessID' value='0'>\n<input type='hidden' name='ModerationID' value='0'>\n<input type='hidden' name='Priority' value='0'>\n<input type='hidden' name='Favorite' value='0'>\n<input type='hidden' name='posting' value='1'>\n<input type='hidden' name='type' value='1'>\n<input type='hidden' name='phase' value='7'>\n<input id='SelectedCat' type='hidden' name='CatalogueID' value='".$CatalogueID."'>\n<input type='hidden' name='SubdivisionID' value=''>\n<input type='hidden' name='ClassID' value='".$class_id."'>\n\n";
  echo "<input type='submit' class='hidden'>";
  echo "</form>\n";

  $UI_CONFIG->actionButtons = array(
                                 array("id" => "submit",
                                       "caption" => WIZARD_CLASS_BUTTON_ADDING_SUBDIVISION_WITH_NEW_TEMPLATE,
                                       "action" => "mainView.submitIframeForm()"));
}

function nc_class_wizard_class_form($class_id, $class_type) {
  global $db, $UI_CONFIG, $ADMIN_PATH;
  global $EnglishName, $SubClassName, $Checked, $SubdivisionID, $CatalogueID;

//  if (!$EnglishName && !$SubClassName) $class_name = $db->get_var("SELECT Class_Name FROM Class WHERE Class_ID = '".$class_id."'");

  echo "<form method='post' action='wizard_class.php'>\n";
  echo "<fieldset>\n";
  echo "<legend>".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_MAININFO."</legend>\n";
  printf(CONTROL_CONTENT_SUBCLASS_CLASSNAME, ($CatalogueID?CONTROL_CONTENT_SUBCLASS_ONSITE:CONTROL_CONTENT_SUBCLASS_ONSECTION));
  echo ":<br><input id='SubClassName' type='text' name='SubClassName' size='50' maxlength='255' value='".($class_name?$class_name:htmlspecialchars($SubClassName))."'><br><br>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_KEYWORD.":<br><input id='EnglishName' type='text' name='EnglishName' size='50' maxlength='255' value='".htmlspecialchars($EnglishName)."'><br><br>\n";
  echo WIZARD_CLASS_FORM_SUBDIVISION_PARENTSUB.":<br>\n";
  echo "<input id='SelectedSub' type='text' name='SubdivisionID' value='".$SubdivisionID."' readonly>\n";
  echo "&nbsp;&nbsp;&nbsp;<a href='#' onclick=\"window.open('".$ADMIN_PATH."wizard/select_subdivision.php', 'nc_popup_map', 'width=350,height=500,menubar=no,resizable=no,scrollbars=no,toolbar=no,resizable=yes'); return false;\">".WIZARD_CLASS_FORM_SUBDIVISION_SELECT_SUBDIVISION."</a><br><br>\n";
//  echo "&nbsp;&nbsp;&nbsp;<a href='#' onclick=\"document.getElementById('SelectedSub').value='';document.getElementById('SelectedCat').value='';return false;\">".WIZARD_CLASS_FORM_SUBDIVISION_DELETE."</a><br><br>\n";
  echo "<input id='turnon' type='checkbox' name='Checked' value='1' ".(isset($Checked)?($Checked?"checked":""):"checked")."> <label for='turnon'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_TURNON."</label><br><br>\n";
  switch ($class_type) {
    case 1:
      $default_action = 'index';
    break;

    case 2:
      $default_action = 'index';
    break;

    case 3:
      $default_action = 'search';
    break;

    case 4:
      $default_action = 'add';
    break;
  }

  echo "<input type='hidden' name='DefaultAction' value='".$default_action."'>\n";
  echo "<input type='hidden' name='ReadAccessID' value='0'>\n";
  echo "<input type='hidden' name='WriteAccessID' value='0'>\n";
  echo "<input type='hidden' name='EditAccessID' value='0'>\n";
  echo "<input type='hidden' name='SubscribeAccessID' value='0'>\n";
  echo "<input type='hidden' name='ModerationID' value='0'>\n";
  echo "<input type='hidden' name='Priority' value='0'>\n";
  echo "<input type='hidden' name='AllowTags' value='-1'>\n";
  echo "<input type='hidden' name='NL2BR' value='-1'>\n";
  echo "<input type='hidden' name='UseCaptcha' value='-1'>\n";
  echo "<input type='hidden' name='RecordsPerPage' value=''>\n";
  echo "<input type='hidden' name='SortBy' value=''>\n";
  echo "<input type='hidden' name='ClassID' value='".$class_id."'>\n";
  echo "<input type='hidden' name='phase' value='9'>\n";
  echo "<input type='hidden' name='SubClassID' value='0'>\n";
  echo "<input id='SelectedCat' type='hidden' name='CatalogueID' value='".$CatalogueID."'>\n";;
  echo "<input type='submit' class='hidden'>";
  echo "</form>\n";

  $UI_CONFIG->actionButtons = array(
                                 array("id" => "submit",
                                       "caption" => ' ',
                                       "action" => "mainView.submitIframeForm()"));
}

/*
 *
 */
function nc_site_wizard_main_sub_form($phase, $site_id) {
  global $db, $UI_CONFIG;

  $site = $db->get_row("SELECT Title_Sub_ID,
  		                       E404_Sub_ID,
  		                       Template_ID
  		                  FROM Catalogue
  		                 WHERE Catalogue_ID = '".$site_id."'", ARRAY_A);

  $subs = $db->get_results("SELECT Subdivision_ID as value,
  		                           CONCAT(Subdivision_ID, '. ', Subdivision_Name) as description
  		                      FROM Subdivision
  		                     WHERE Parent_Sub_ID = '0' AND
  		                           Catalogue_ID = '$CatalogueID'
  		                  ORDER BY Subdivision_ID", ARRAY_A);

  $templates = $db->get_results("SELECT Template_ID as value,
                                        CONCAT(Template_ID, '. ', Description) as description,
                                        Parent_Template_ID as parent
                                   FROM Template
                               ORDER BY Template_ID", ARRAY_A);

  $inherit_template = $db->get_row("SELECT a.Template_ID,
  		                                   b.Description as TemplateName
  		                              FROM Catalogue as a,
  		                                   Template as b
  		                             WHERE Catalogue_ID = '".$site_id."' AND
  		                                   b.Template_ID = a.Template_ID", ARRAY_A);

  echo "<form method='post' action='wizard_site.php'>\n";

  echo "<fieldset>\n";
  echo "<legend><b>".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_TITLEPAGE."</b></legend>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_NAME.":<br>\n";
  echo "<input type='text' name='TitleSubIDName' value=' '><br><br>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_KEYWORD.":<br>\n";
  echo "<input type='text' name='TitleSubIDKeyword' value='index'><br><br>\n";
/*
  echo "<select name='TitleSubID'>\n";
  echo nc_select_options($subs, $site['Title_Sub_ID']);
  echo "</select><br><br>\n";
*/

  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_DTEMPLATE.":<br>\n";
  echo "<select name='TitleTemplateID'>\n";
  echo "<option ".($site['Template_ID'] ? "" : "selected ")."value='0'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_DTEMPLATE_N." [".$inherit_template['Template_ID'].". ".$inherit_template['TemplateName']."]</option>";
  echo nc_select_options($templates, $site['Title_Sub_ID']);
  echo "</select><br>\n";
  echo "</fieldset><br><br>\n";

  echo "<fieldset>\n";
  echo "<legend><b>".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_NOTFOUND."</b></legend>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_NAME.":<br>\n";
  echo "<input type='text' name='E404SubIDName' value='  '><br><br>\n";
  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_KEYWORD.":<br>\n";
  echo "<input type='text' name='E404SubIDKeyword' value='404'><br><br>\n";
/*
  echo "<select name='E404SubID'>\n";
  echo nc_select_options($subs, $site['E404_Sub_ID']);
  echo "</select><br><br>\n";
*/

  echo CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_DTEMPLATE.":<br>\n";
  echo "<select name='E404TemplateID'>\n";
  echo "<option ".($site['Template_ID'] ? "" : "selected ")."value='0'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_DTEMPLATE_N." [".$inherit_template['Template_ID'].". ".$inherit_template['TemplateName']."]</option>";
  echo nc_select_options($templates, $site['Title_Sub_ID']);
  echo "</select><br>\n";
  echo "</fieldset><br><br>\n";

  //    
/*
  $modules = $db->get_results("SELECT Keyword,
  		                              Module_Name
  		                         FROM Module
  		                     ORDER BY Keyword", ARRAY_A);

  if ($modules) {
    echo "<fieldset>\n";
    echo "<legend><b>".WIZARD_SITE_FORM_WHICH_MODULES."</b></legend>\n";
    foreach ($modules as $module) {
      echo "<input type='checkbox' name='modules[".$module['Keyword']."]' value='1'>&nbsp;".constant($module['Module_Name'])."<br>\n";
    }
    echo "</fieldset><br><br>\n";
  }
*/
  echo "<input type='hidden' name='posting' value='1'>";
  echo "<input type='hidden' name='phase' value='".$phase."'>";
  echo "<input type='hidden' name='CatalogueID' value='".$site_id."'>";
  echo "<input type='submit' class='hidden'>";
  echo "</form>\n";

  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => WIZARD_SITE_BUTTON_ADD_SUBS,
                                      "action" => "mainView.submitIframeForm()");
}


/*
 *
 */
function nc_site_wizard_main_sub_add($phase, $site_id, $title_name, $title_keyword, $title_template_id, $e404_name, $e404_keyword, $e404_template_id, $modules) {
  global $db, $UI_CONFIG;

  //   
  if (!$title_name || !$e404_name) {
    $UI_CONFIG = new ui_config_wizard_site(2, $site_id);
    nc_print_status(CONTROL_CONTENT_SUBDIVISION_INDEX_ERROR_THREE_NAME, 'error');
    nc_site_wizard_main_sub_form(3, $site_id);
    return false;
  }

  //       
  if (!IsAllowedSubdivisionEnglishName($title_keyword, 0, 0, $site_id) || !IsAllowedSubdivisionEnglishName($e404_keyword, 0, 0, $site_id)) {
    $UI_CONFIG = new ui_config_wizard_site(2, $site_id);
    nc_print_status(CONTROL_CONTENT_SUBDIVISION_INDEX_ERROR_THREE_KEYWORD, 'error');
    nc_site_wizard_main_sub_form(3, $site_id);
    return false;
  }

  //      (            )
  if (strspn(strtolower($title_keyword), "abcdefghijklmnopqrstuvwxyz0123456789-") != strlen($title_keyword) || strspn(strtolower($e404_keyword), "abcdefghijklmnopqrstuvwxyz0123456789-") != strlen($e404_keyword)) {
    $UI_CONFIG = new ui_config_wizard_site(2, $site_id);
    nc_print_status(CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD_INVALID, 'error');
    nc_site_wizard_main_sub_form(3, $site_id);
    return false;
  }

  //     
  $db->query("INSERT INTO Subdivision
  		             SET Catalogue_ID=$site_id,
                         Parent_Sub_ID=0,
                         Subdivision_Name = '".mysql_escape_string($title_name)."',
                         Checked=0,
                         EnglishName='".$title_keyword."',
                         Hidden_URL='/".$title_keyword."/',
                         Priority='".$db->get_var("SELECT MAX(Priority)+1 FROM Subdivision where Parent_Sub_ID=0 AND Catalogue_ID='$site_id'")."'");
  $title_sub_id = $db->insert_id;

  $UI_CONFIG = new ui_config_wizard_site(3, $site_id);

  $buttons[] = array("image" => "i_folder_add.gif",
                     "label" => CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION,
                     "href" => "subdivision.add(".$title_sub_id.")");

  $buttons[] = array("image" => "i_folder_delete.gif",
                     "label" => CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_KILL,
                     "href" => "subdivision.delete(".$title_sub_id.")");

  $UI_CONFIG->treeChanges['addNode'][] = array("nodeId" => "sub-$title_sub_id",
                                               "parentNodeId" => "site-$site_id",
                                               "name" => $title_sub_id.". ".$title_name,
                                               "href" => "#subclass.add($title_sub_id)",
                                               "image" => $tree_image = "i_folder_disabled.gif",
                                               "hasChildren" => false,
                                               "dragEnabled" => true,
                                               "buttons" => $buttons,
                                               "acceptDropFn" => "treeSitemapAcceptDrop",
                                               "onDropFn" => "treeSitemapOnDrop",
                                               "className" => "disabled",
                                               "subclasses" => array()
                                              );

  //    404
  $db->query("INSERT INTO Subdivision
  		             SET Catalogue_ID=$site_id,
                         Parent_Sub_ID=0,
                         Subdivision_Name = '".mysql_escape_string($e404_name)."',
                         Checked=0,
                         EnglishName='".$e404_keyword."',
                         Hidden_URL='/".$e404_keyword."/',
                         Priority='".$db->get_var("SELECT MAX(Priority)+1 FROM Subdivision where Parent_Sub_ID=0 AND Catalogue_ID='$site_id'")."'");
  $e404_sub_id = $db->insert_id;

  $buttons[] = array("image" => "i_folder_add.gif",
                     "label" => CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION,
                     "href" => "subdivision.add(".$title_sub_id.")");

  $buttons[] = array("image" => "i_folder_delete.gif",
                     "label" => CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_KILL,
                     "href" => "subdivision.delete(".$title_sub_id.")");

  $UI_CONFIG->treeChanges['addNode'][] = array("nodeId" => "sub-$e404_sub_id",
                                               "parentNodeId" => "site-$site_id",
                                               "name" => $e404_sub_id.". ".$e404_name,
                                               "href" => "#subclass.add($e404_sub_id)",
                                               "image" => $tree_image = "i_folder_disabled.gif",
                                               "hasChildren" => false,
                                               "dragEnabled" => true,
                                               "buttons" => $buttons,
                                               "acceptDropFn" => "treeSitemapAcceptDrop",
                                               "onDropFn" => "treeSitemapOnDrop",
                                               "className" => "disabled",
                                               "subclasses" => array()
                                              );

  $db->query("UPDATE Catalogue
  		         SET Title_Sub_ID = '".$title_sub_id."',
  		             E404_Sub_ID = '".$e404_sub_id."'
  		       WHERE Catalogue_ID = '".$site_id."'");

  if ($title_sub_id && $e404_sub_id && $db->rows_affected) {
    return true;
  } else {
    return false;
  }

}


function nc_site_wizard_map() {
    global $db;
    global $HTTP_DOMAIN, $HTTP_HOST, $DOMAIN_NAME, $EDIT_DOMAIN, $HTTP_ROOT_PATH, $CatalogueID;
    global $AUTHORIZATION_TYPE, $first, $perm;
    global $UI_CONFIG, $ADMIN_PATH, $ADMIN_TEMPLATE;

    $is_supervisor = ($perm->isSupervisor());
    if ($is_supervisor) {
      $select = "select Catalogue_ID, Catalogue_Name, Domain, Title_Sub_ID, Checked from Catalogue where Catalogue_ID=".$CatalogueID;
      $Array = $db->get_row($select, ARRAY_N);
      if (!$db->num_rows) {
        nc_print_status(CONTROL_CONTENT_SUBDIVISION_FUNCS_LINEADD_ERR_NOONESITE, 'error');
        return;
      }

      echo "<form name='siteMapForm' id='siteMapForm' method='get' action='index.php'>";
//    echo "<input type='hidden' name='phase' value='7'>";

      echo "<table border=0 cellpadding=0 cellspacing=0 id='siteMap'>";
      echo "<tr id='site_tr-".$CatalogueID."'>";
      echo "<td id='siteTitle' class='name ".($Array[4]?"active":"unactive")."'><span>".$Array[0].". </span><a href='".$ADMIN_PATH."catalogue/?phase=6&CatalogueID=".$Array[0]."'>".$Array[1]."</a></td>";
      echo "<td class='button'><a href='#' onclick='loadSubdivisionAddForm($CatalogueID, 0)'><img src='".$ADMIN_TEMPLATE."img/i_folder_add.gif' alt='".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION."' title='".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION."'></a></td>";
      echo "</tr>";

      echo "<tr><td colspan='2' style='padding: 0; background: #FFFFFF;'><div id='site-".$CatalogueID."'></div></td></tr>";

      $count = 1;
      echo nc_site_wizard_map_write_sub(0, $Array[0]);

      echo "</table>";
      echo "</form>\n";
    }

    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => WIZARD_SITE_BUTTON_FINISH_ADD_SUBS,
                                        "location" => "site.map(".$CatalogueID.")"
                                       );
/*
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => NETCAT_ADMIN_DELETE_SELECTED,
                                        "action" => "mainView.submitIframeForm('siteMapForm')"
                                       );
*/
}


function nc_site_wizard_map_write_sub($ParentSubID, $CatalogueID, $count=1) {
  global $db;
  global $DOMAIN_NAME, $HTTP_ROOT_PATH, $EDIT_DOMAIN, $DOMAIN_NAME;
  global $perm, $ADMIN_PATH, $ADMIN_TEMPLATE;

  $select = "SELECT a.Subdivision_ID, a.Subdivision_Name,a.Priority,a.Checked,a.Hidden_URL,b.Domain,a.Catalogue_ID,a.ExternalURL, a.Parent_Sub_ID FROM Subdivision AS a, Catalogue AS b";
  $select .= " where a.Catalogue_ID=b.Catalogue_ID AND a.Catalogue_ID=".$CatalogueID;
  $select .= " AND a.Parent_Sub_ID=".$ParentSubID." ORDER BY a.Priority";


  if ($Result = $db->get_results($select, ARRAY_N)) {

    foreach ($Result as $Array) {
      $hidden_host = "http://".($Array[5]?(strchr($Array[5],".")?$Array[5]:$Array[5].".".$DOMAIN_NAME):$DOMAIN_NAME);

      $result .= "<tr id='tr-".$Array[0]."' parentSub='".$Array[8]."'>";
  	  $result .= "<td class='name ".($Array[3]?"active":"unactive")."' style='padding-left: ".($count+15)."px;'><img src='".$ADMIN_PATH."images/arrow_sec.gif' width='14' height='10' alt='' title=''><span>".$Array[0].". </span><a href='../subdivision/index.php?phase=4&SubdivisionID=".$Array[0]."'>".$Array[1]."</a></td>";
      $result .= "<td class='button'><a href='#' onclick='loadSubdivisionAddForm($CatalogueID, ".$Array[0].")'><img src='".$ADMIN_TEMPLATE."img/i_folder_add.gif' alt='".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION."' title='".CONTROL_CONTENT_SUBDIVISION_FUNCS_MAINDATA_A_ADDSUBSECTION."'></a></td>";
      $result .= "</tr>";

      $result .= "<tr><td colspan='2' style='padding: 0 0 0 ".($count+15)."px; background: #FFFFFF;'><div id='sub-".$Array[0]."'></div></td></tr>";

      $result .= nc_site_wizard_map_write_sub($Array[0], $CatalogueID, $count+20);
    }

  }
  return $result;
}


/**
  *  
  */
class ui_config_wizard_class extends ui_config {

  function ui_config_wizard_class($phase, $class_type, $class_id) {

    global $db;

    $this->headerImage = 'i_class_wizard_big.gif';
    $this->headerText = SECTION_INDEX_WIZARD_SUBMENU_CLASS;
    $this->treeMode = 'developer';

    $this->tabs = array(
                     array('id' => 'step1',
	                       'caption' => ($phase == 1?WIZARD_CLASS_TAB_SELECT_TEMPLATE_TYPE:WIZARD_CLASS_STEP." 1 ".WIZARD_CLASS_STEP_FROM." 5"),
	                       'location' => "dataclass.wizard($phase,$class_type,$class_id)",
	                       'unactive' => true),
	                 array('id' => 'step2',
	                       'caption' => ($phase == 2?WIZARD_CLASS_TAB_ADDING_TEMPLATE_FIELDS:WIZARD_CLASS_STEP." 2 ".WIZARD_CLASS_STEP_FROM." 5"),
	                       'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                           'unactive' => true),
	                 array('id' => 'step3',
	                       'caption' => ($phase == 3?WIZARD_CLASS_TAB_TEMPLATE_SETTINGS:WIZARD_CLASS_STEP." 3 ".WIZARD_CLASS_STEP_FROM." 5"),
	                       'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                           'unactive' => true),
	                 array('id' => 'step4',
	                       'caption' => ($phase == 4?WIZARD_CLASS_TAB_SUBSEQUENT_ACTION:WIZARD_CLASS_STEP." 4 ".WIZARD_CLASS_STEP_FROM." 5"),
	                       'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                           'unactive' => true)
                       );
    if (!in_array($phase, array(6,7,8))) {
      $this->tabs[] = array('id' => 'step5',
	                        'caption' => WIZARD_CLASS_STEP." 5 ".WIZARD_CLASS_STEP_FROM." 5",
	                        'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                            'unactive' => true);
    }
    if ($phase == 6) {
      $this->tabs[] = array('id' => 'step6',
	                        'caption' => ($phase == 6?WIZARD_CLASS_TAB_CREATION_SUBDIVISION_WITH_NEW_TEMPLATE:WIZARD_CLASS_STEP." 5 ".WIZARD_CLASS_STEP_FROM." 5"),
	                        'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                            'unactive' => true);
    }
    if ($phase == 7) {
      $this->tabs[] = array('id' => 'step7',
	                        'caption' => ($phase == 7?WIZARD_CLASS_TAB_CREATION_SUBDIVISION_WITH_NEW_TEMPLATE:WIZARD_CLASS_STEP." 5 ".WIZARD_CLASS_STEP_FROM." 5"),
	                        'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                            'unactive' => true);
    }
    if ($phase == 8) {
      $this->tabs[] = array('id' => 'step8',
	                        'caption' => ($phase == 8?WIZARD_CLASS_TAB_ADDING_TEMPLATE_TO_EXISTENT_SUBDIVISION:WIZARD_CLASS_STEP." 5 ".WIZARD_CLASS_STEP_FROM." 5"),
	                        'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                            'unactive' => true);
    }
    if ($phase == 9) {
      $this->tabs[] = array('id' => 'step9',
	                        'caption' => ($phase == 9?WIZARD_CLASS_TAB_ADDING_TEMPLATE_TO_EXISTENT_SUBDIVISION:WIZARD_CLASS_STEP." 5 ".WIZARD_CLASS_STEP_FROM." 5"),
	                        'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                            'unactive' => true);
    }

    $this->activeTab = "step".$phase;
    if ($class_id) {
      $this->treeSelectedNode = "dataclass-".$class_id;
    } else {
      $this->treeSelectedNode = "dataclass.list";
    }
    $this->locationHash = "dataclass.wizard($phase,$class_type,$class_id)";
  }
}


/**
  *  
  */
class ui_config_wizard_site extends ui_config {

  function ui_config_wizard_site($phase, $site_id) {

    global $db;

    $this->headerImage = 'i_site_wizard_big.gif';
    $this->headerText = SECTION_INDEX_WIZARD_SUBMENU_SITE;
    $this->treeMode = 'sitemap';

    $this->tabs = array(
                     array('id' => 'step1',
	                       'caption' => ($phase == 1?WIZARD_SITE_TAB_NEW_SITE_CREATION:WIZARD_SITE_STEP." 1 ".WIZARD_SITE_STEP_FROM." 2"),
	                       'location' => "dataclass.wizard($phase,$class_type,$class_id)",
	                       'unactive' => true),
	                 array('id' => 'step2',
	                       'caption' => ($phase == 2?WIZARD_SITE_TAB_NEW_SITE_ADD_SUB:WIZARD_SITE_STEP." 2 ".WIZARD_SITE_STEP_FROM." 2"),
	                       'location' => "dataclass.wizard($phase,$class_type,$class_id)",
                           'unactive' => true)
                       );

    $this->activeTab = "step".$phase;
    if ($phase != 1) $this->treeSelectedNode = "site-$site_id";
    $this->locationHash = "site.wizard($phase,$site_id)";
  }
}

?>