<?php
/* $Id: index.php 2350 2008-11-06 14:13:35Z vadim $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require_once ($ROOT_FOLDER.'connect_io.php');

$catalogue += 0;
$sub += 0;
$cc += 0;
$classID += 0;
$message += 0;
$template += 0;
$is_there_any_files = 0;

require_once ($INCLUDE_FOLDER.'s_loadenv.inc.php');
require_once ($INCLUDE_FOLDER.'s_e404.inc.php');
require_once ($INCLUDE_FOLDER.'s_auth.inc.php');
require_once ($INCLUDE_FOLDER.'s_browse.inc.php');
require_once ($INCLUDE_FOLDER.'s_list.inc.php');
require_once ($INCLUDE_FOLDER.'s_class.inc.php');
require_once ($ADMIN_FOLDER.'CheckUserFunctions.inc.php');

if ($PHP_AUTH_LANG==false && $AUTHORIZATION_TYPE=='session') session_start();

list($uri_path,$uri_params) = explode("?",$REQUEST_URI);
if (strstr($uri_path,$SUB_FOLDER.$HTTP_ROOT_PATH."modules/")) $posting = true;

//  netcat-admin:  
$inside_admin = (!$passed_thru_404 && ($_GET['inside_admin'] || $_POST['inside_admin']));
if ($inside_admin) {
  //   netcat-admin ( )   $cc
  if ($cc && (!$sub || $catalogue)) {
    list($catalogue, $sub) = $db->get_row(
            "SELECT Catalogue_ID, Subdivision_ID
               FROM Sub_Class
              WHERE Sub_Class_ID=$cc", ARRAY_N);
  }
  //      classID, message
  if (!$cc && $classID && $message) {
    list($catalogue, $sub, $cc) = $db->get_row(
            "SELECT s.Catalogue_ID, m.Subdivision_ID, m.Sub_Class_ID
               FROM Message$classID as m, Subdivision as s
              WHERE m.Message_ID=$message
                AND m.Subdivision_ID = s.Subdivision_ID", ARRAY_N);
  }
}

if (!$passed_thru_404 && !$posting) $admin_mode = true;
elseif ($passed_thru_404) $admin_mode = false;

if (!$current_catalogue)
{
   if (!$catalogue) // not admin mode
   {
      $current_catalogue = GetCatalogueByHostName($HTTP_HOST);
      $catalogue = $current_catalogue["Catalogue_ID"];
   }
   else
   {
      $res = $db->get_results("SELECT * FROM Catalogue WHERE Catalogue_ID=$catalogue", ARRAY_A);
      $current_catalogue = $res[0];
   }

   // was the system installed properly?
   if (!$current_catalogue)
   {
      $count_tables = $db->get_var("SHOW TABLES LIKE 'Settings'");
      if (!$count_tables)
      {
          if (file_exists($DOCUMENT_ROOT.$SUB_FOLDER."/install/index.php"))
               { header("Location: $SUB_FOLDER/install/"); }
          else { print "<p><b>Cannot connect to database</b></p>"; }

          die();
      }
   }
}

$admin_url_prefix = $SUB_FOLDER.$HTTP_ROOT_PATH;
if (!isset($catalogue) || $catalogue == 0)
{
   $catalogue = GetCatalogueID($HTTP_HOST);
   $catalogue = 0;

}

if (!$MODULE_VARS) LoadModuleEnv();

LoadEnv();

if (!$template) $template = $current_sub["Template_ID"];

if ($cc) {
   $moderationID = $current_cc["Moderation_ID"];
   $allowTags = $current_cc["AllowTags"];
   $classID = $current_cc["Class_ID"];
   $daysToHold = $current_cc["DaysToHold"];

   $titleTemplate = $current_cc["TitleTemplate"];

   $addTemplate = $current_cc["AddTemplate"];
   $addCond = $current_cc["AddCond"];
   $addActionTemplate = $current_cc["AddActionTemplate"];

   $editTemplate = $current_cc["EditTemplate"];
   $editCond = $current_cc["EditCond"];
   $editActionTemplate = $current_cc["EditActionTemplate"];
   $CheckActionTemplate = $current_cc["CheckActionTemplate"];
   $DeleteActionTemplate = $current_cc["DeleteActionTemplate"];

   $searchTemplate = $current_cc["SearchTemplate"];

   $subscribeCond = $current_cc["SubscribeCond"];
   $subscribeTemplate = $current_cc["SubscribeTemplate"];
}

if ($user_table_mode) {
   $systemTableID = $user_table_env["System_Table_ID"];

   $allowTags = $user_table_env["AllowTags"];
   $daysToHold = $user_table_env["DaysToHold"];

   $titleTemplate = $user_table_env["TitleTemplate"];

   $addTemplate = $user_table_env["AddTemplate"];
   $addCond = $user_table_env["AddCond"];
   $addActionTemplate = $user_table_env["AddActionTemplate"];

   $editTemplate = $user_table_env["EditTemplate"];
   $editCond = $user_table_env["EditCond"];
   $editActionTemplate = $user_table_env["EditActionTemplate"];
   $CheckActionTemplate = $user_table_env["CheckActionTemplate"];
   $DeleteActionTemplate = $user_table_env["DeleteActionTemplate"];

   $searchTemplate = $user_table_env["SearchTemplate"];

   $subscribeCond = $user_table_env["SubscribeCond"];
   $subscribeTemplate = $user_table_env["SubscribeTemplate"];
}

$check_auth = s_auth($current_cc,$action,$posting);

$AUTH_USER_ID += 0;
$AUTH_USER_GROUP += 0;

if ($MODULE_VARS['auth']) { AttemptToAuthorize(); }
  elseif ($PHP_AUTH_USER) { Authorize(); }

if ($AUTH_USER_ID)
{
   if (!$current_user)
   {
      $current_user=$db->get_row("SELECT Language FROM User WHERE User_ID='".$AUTH_USER_ID."'",ARRAY_A);
   }

   $PHP_AUTH_LANG = $current_user["Language"];
   $AUTH_LANG = $current_user["Language"];

   $cookie_domain = ($MODULE_VARS['auth']['COOKIES_WITH_SUBDOMAIN'] ? str_replace("www.", "", $HTTP_HOST) : NULL);
   setcookie ("PHP_AUTH_LANG", $PHP_AUTH_LANG, ($ADMIN_AUTHTIME?time()+$ADMIN_AUTHTIME:time()+24*3600), "/", $cookie_domain);
}


if(isset($MODULE_VARS['netshop'])) {
// ------------------------------------------------------------------------
  //   
  $netshop_sid = session_name();
  if ($GLOBALS[$netshop_sid]) session_id($GLOBALS[$netshop_sid]);
  @session_start(); // if session was started already  - generates a notice
  
  if ($GLOBALS["MODULE_VARS"]["netshop"]) { $GLOBALS["shop"] = new NetShop(); }
} 


#   
#      
if ($current_catalogue["Language"]) {
	$SITE_LANG = NetCat_language_detect($current_catalogue["Language"]);
}
#  
if ($SITE_LANG) {
	if($admin_mode==true) $LANG_NAME = $ADMIN_LANGUAGE;
	else $LANG_NAME = $SITE_LANG;
}
elseif ($AUTH_LANG) {
	$LANG_NAME = $AUTH_LANG;
} elseif($PHP_AUTH_LANG) {
	$LANG_NAME = $PHP_AUTH_LANG;
} elseif($_SESSION['User']['PHP_AUTH_LANG']) {
	$LANG_NAME = $_SESSION['User']['PHP_AUTH_LANG'];
} else {
	if (!$PHP_AUTH_LANG) $PHP_AUTH_LANG=NetCat_language_detect();
	if ($PHP_AUTH_LANG) {
		$LANG_NAME = $PHP_AUTH_LANG;
	} else {
		$LANG_NAME = $ADMIN_LANGUAGE;
	}
}
#    
if ( preg_match("/^\w+$/i", $LANG_NAME) && file_exists($ADMIN_FOLDER."lang/".$LANG_NAME.".php") ) {
	require_once($ADMIN_FOLDER."lang/".$LANG_NAME.".php");
}
else {
	#       -
	if( $LANG_FOLDER=@opendir($ADMIN_FOLDER."lang/") ) {
		while( ($LANG_FOLDER_FILE=readdir($LANG_FOLDER))!==false ) {
			if( substr($LANG_FOLDER_FILE, -3, 3)=="php" ) {
				require_once($ADMIN_FOLDER."lang/".$LANG_FOLDER_FILE);
			break;
			}
		}
	} else die("Language folder is damaged!");
}

if ($MODULE_VARS['stats']) stats_Log();

if ($inside_admin) {

  if ($system_env['EditDesignTemplateID'] && !$current_sub['UseEditDesignTemplate']) {
    $template = $system_env['EditDesignTemplateID'];
  }
  require_once($ADMIN_FOLDER."admin.inc.php");
  ob_start("nc_postprocess_admin_page");

}

$template_settings = array();

if (!$isNaked) {

   $template_env = InheritTemplateEnv($template);
   $template_header = $template_env["Header"];
   $template_footer = $template_env["Footer"];
   eval($template_env["Settings"]);

   if ($template_env["CustomSettings"] && $current_sub['Template_ID']==$template) {
     require_once($ADMIN_FOLDER . "array_to_form.inc.php");
     $nc_a2f = new nc_a2f($template_env["CustomSettings"], $current_sub["TemplateSettings"]);
     $template_settings = $nc_a2f->get_values_as_array();
   }

   if ($inside_admin) {
     // output interface settings (add 'em to the footer before </body>)
     $UI_CONFIG = new ui_config_objects($cc);
     $js_code = '" . $UI_CONFIG->to_json() . "';
     if (preg_match("!(</body>)!i", $template_footer, $regs)) {
       $template_footer = str_replace($regs[1], $js_code.$regs[1], $template_footer);
     }
     else {
       $template_footer .= $js_code;
     }
   }
}
else {
  $template_env = array();
  $template_header = "";
  $template_footer = "";
}


if ($current_sub["Subdivision_ID"]==$current_catalogue["Title_Sub_ID"])
$f_title = $current_catalogue["Catalogue_Name"];
else
$f_title = $current_sub["Subdivision_Name"];

if ($current_cc["Sub_Class_ID"]!=$cc_array[0] && $current_cc["Checked"])
$f_title = $current_cc["Sub_Class_Name"];


if (!$check_auth && NC_AUTH_IN_PROGRESS!==1) {
   eval("echo \"".$template_header."\";");

   if ($AUTH_USER_ID || (!$AUTH_USER_ID && !$MODULE_VARS['auth'])) {
     if ($inside_admin) {
       nc_print_status(NETCAT_MODERATION_ERROR_NORIGHTS, 'error');
     }
     else {
       print NETCAT_MODERATION_ERROR_NORIGHTS;
     }
   }
   elseif (!$AUTH_USER_ID && $MODULE_VARS['auth']) {
     UserLoginForm();
   }

   eval("echo \"".$template_footer."\";");
   exit;
}
if ($AUTH_USER_ID) LoadUserEnv();
if (!$message && $action=="full") exit;

?>