<?php
/* $Id: admin.php 2418 2008-11-24 09:42:51Z denis $ */

$main_section = "settings";
#  
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($MODULE_FOLDER."calendar/admin.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
# UI
require ($ADMIN_FOLDER."modules/ui.php");
$UI_CONFIG = new ui_config_module('calendar');

#  
if ( is_file($MODULE_FOLDER.'calendar/'.MAIN_LANG.'.lang.php') ) {
	require_once($MODULE_FOLDER.'calendar/'.MAIN_LANG.'.lang.php');
}
else { 
	require_once($MODULE_FOLDER.'calendar/en.lang.php');
}

if ( (int)$_POST['ID'] ) {
	$calendarSettingBackLink = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/calendar/admin.php"."?CalendarTheme=".(int)$_POST['ID'];
}

#  
$Title1    = NETCAT_MODULES;
$Title2    = NETCAT_MODULE_CALENDAR;


if (!isset($phase)) $phase=1;

switch ($phase) {

	case 1:
	//   
	BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/calendar/");
  $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 0);
	CalendarShowSettings();

	break;

	case 2:
	//       default
	BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/calendar/");
	$perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
	
	//   
	for($i=1; $i<=7; $i++) {
		$DayName[] = $_POST["DayName$i"];
	}
	$DaysName = join(",", $DayName);
	
	$ThemeNameCorrect = false;
	if( isset($_POST['ThemeName']) && preg_match("/^[[:alnum:]\s-_]+$/is", $_POST['ThemeName']) ) $ThemeNameCorrect = true;
	
	if( isset($_POST['ThemeName']) && $ThemeNameCorrect ) {
		$POST_settings = array("ID" => $_POST['ID'],
			"SetDefault" => ($_POST['SetDefault'] ? 1 : 0),
			"ThemeName" => $_POST['ThemeName'],
			"CalendarPrefix" => $_POST['CalendarPrefix'],
			"CalendarHeader" => $_POST['CalendarHeader'],
			"dayTemplatePrefix" => $_POST['dayTemplatePrefix'],
		    "dayTemplateBegin" => $_POST['dayTemplateBegin'],
			"dayTemplateHeader" => $_POST['dayTemplateHeader'],
			"daySETTemplateHeader" => $_POST['daySETTemplateHeader'],
			"daySUNTemplateHeader" => $_POST['daySUNTemplateHeader'],
			"dayTemplate" => $_POST['dayTemplate'],
			"dayCurTemplate" => $_POST['dayCurTemplate'],
			"daySETTemplate" => $_POST['daySETTemplate'],
			"daySUNTemplate" => $_POST['daySUNTemplate'],
			"nodayTemplate" => $_POST['nodayTemplate'],
			"nodaySETTemplate" => $_POST['nodaySETTemplate'],
			"nodaySUNTemplate" => $_POST['nodaySUNTemplate'],
			"dayTemplateEnd" => $_POST['dayTemplateEnd'],
			"dayTemplateSuffix" => $_POST['dayTemplateSuffix'],
			"CalendarSuffix" => $_POST['CalendarSuffix'],
			"DaysName" => $DaysName,
			"CalendarCSS" => $_POST['CalendarCSS'],
			"StatusImage" => $_POST['StatusImage'],
			"PrevImage" => $_POST['PrevImage'],
			"NextImage" => $_POST['NextImage']);
										
		/*if(!get_magic_quotes_gpc()) {
			$temp = $POST_settings;
			unset($settings);
			$POST_settings = array_map("mysql_escape_string", $temp);
		}*/
		
		SaveFunctional($POST_settings);
		echo ($_POST['ID']=="new" ? NETCAT_MODULE_CALENDAR_THEME_CREATED : NETCAT_MODULE_CALENDAR_THEME_UPDATED)."<br><br><a href='".$calendarSettingBackLink."'>".NETCAT_MODULE_CALENDAR_ADMIN_GOBACK."</a>";
	}
	elseif (!$ThemeNameCorrect) {
		echo NETCAT_MODULE_CALENDAR_THEME_NAME_NOTICE."<br><br><a href='".$calendarSettingBackLink."'>".NETCAT_MODULE_CALENDAR_ADMIN_GOBACK."</a>";
	}
	else {
		echo NETCAT_MODULE_CALENDAR_THEME_NAME_EMPTY."<br><br><a href='".$calendarSettingBackLink."'>".NETCAT_MODULE_CALENDAR_ADMIN_GOBACK."</a>";
	}
	
	break;
	
	case 3:
	//       default
	BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/calendar/");
	$perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
	
		echo "<form method='post' action='admin.php' style='padding:0; margin:0;'>
				<fieldset>
				<legend>
					<b><font color='gray'>  \"".$_POST['ThemeName']."\"?</font></b>
				</legend>
					<div style='margin:20px 0; text-align:center'>
					<input type='submit' name='YesDelete' value='".NETCAT_MODULE_CALENDAR_YES."' style='width:70px; margin-right:20px'>
					<input type='button' name='NoDelete' value='".NETCAT_MODULE_CALENDAR_NO."' style='width:70px' onClick='location.href=\"".$calendarSettingBackLink."\"'>
					</div>
				</fieldset>
				<input type='hidden' name='phase' value='4'>
				<input type='hidden' name='ID' value='".$_POST['ID']."'>
				</form>";
	
	break;
	
	case 4:
	//   
	BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/calendar/");
	
	if($_POST['YesDelete']) {
		DeleteFunctional($_POST['ID']);
		echo NETCAT_MODULE_CALENDAR_THEME_NAME_DELETED."<br><br><a href='".$calendarSettingBackLink."'>".NETCAT_MODULE_CALENDAR_ADMIN_GOBACK."</a>";
	}

	break;

}

EndHtml();
?>