<?php
/* $Id: function.inc.php 2299 2008-10-03 14:19:03Z vadim $ */

##############################################
#        
##############################################
function InsertFieldsFromBaseClass($BaseClassID,$NewClassID){
	global $db;

    $db->query("INSERT INTO Field (Class_ID, Field_Name, Description, TypeOfData_ID, Format, NotNull, Priority, DoSearch, DefaultState, Inheritance, System_Table_ID, TypeOfEdit_ID) SELECT $NewClassID, Field_Name, Description, TypeOfData_ID, Format, NotNull, Priority, DoSearch, DefaultState, Inheritance, System_Table_ID, TypeOfEdit_ID FROM Field WHERE Class_ID=$BaseClassID");

    if ($Result = $db->get_results("SELECT Field_ID FROM Field WHERE Class_ID='$NewClassID'"))
    {
    	foreach( $Result as $Array )
    	{
    		ColumnInMessage($Array->Field_ID,1,$db);
    	}
    }
}

##############################################
#         
##############################################
function InsertActionsFromBaseClass($BaseClassID,$NewClassID){
	global $db;

	$ret=false;
	if ($Result = $db->get_results("SELECT AddTemplate, EditTemplate, AddActionTemplate, EditActionTemplate, SearchTemplate, FullSearchTemplate, SubscribeTemplate, AddCond, EditCond, SubscribeCond, CheckActionTemplate, DeleteActionTemplate FROM Class WHERE Class_ID='$BaseClassID'", ARRAY_A))
	{
		foreach( $Result as $Array )
		{
			foreach ( $Array as $key => $val )
			{
				if($val!="") {
    				$q.=$key."=\"".addslashes($val)."\" ,";
    				$ret=true;
				}
			}
		}
	}

    $q=substr($q,0,strlen($q)-1);
    if ($ret)
    	$db->query("UPDATE Class SET ".$q. " where Class_ID='$NewClassID';");
}

##############################################
#    
##############################################
function ClassGroupList()
{
	global $db;

	if ( $Result = $db->get_results("SELECT DISTINCT Class_Group FROM Class WHERE System_Table_ID=0 ORDER BY Class_Group ASC") )
	{
		?>
 		<form method=post action=index.php>
		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

		<table border=0 cellpadding=4 cellspacing=1 width=100%>
		<tr>
		<td bgcolor=eeeeee><font size=-2><b><?=CONTROL_CLASS_CLASS_GROUPS?></b></td>
		</tr>
		<?

		foreach( $Result as $Array )
		{
			print "<tr>";
			print "<td bgcolor=white><a href=\"index.php?phase=1&ClassGroup=".urlencode($Array->Class_Group)."\">".$Array->Class_Group."</a></td>";
			print "</tr>";
		}
		?>
		</table>
		</td></tr></table><br>
		<?
	}
	else
	{
		nc_print_status(CONTROL_CLASS_NONE, 'info');
	}
	?>
	<a href=index.php?phase=10><b><?=CONTROL_CLASS_ADD?></a>
	<?
}


##############################################
#   
##############################################
function ClassList($Class_Group = false)
{
	global $db, $ADMIN_PATH, $ADMIN_TEMPLATE, $UI_CONFIG;

	if ($Class_Group)
	{
		$select = "SELECT Class_ID, Class_Name, IF(AddTemplate<>'' OR AddCond<>'' OR AddActionTemplate<>'',1,0) AS IsAdd, IF(EditTemplate<>'' OR EditCond<>'' OR EditActionTemplate<>'' OR CheckActionTemplate<>'' OR DeleteActionTemplate<>'',1,0) AS IsEdit, IF(SearchTemplate<>'' OR FullSearchTemplate<>'',1,0) AS IsSearch, IF(SubscribeTemplate<>'' OR SubscribeCond<>'',1,0) AS IsSubscribe from Class where md5(Class_Group)='".$Class_Group."' AND System_Table_ID=0 order by Class_ID";
	}
	else
	{
		$select = "SELECT Class_ID, Class_Name, IF(AddTemplate<>'' OR AddCond<>'' OR AddActionTemplate<>'',1,0) AS IsAdd, IF(EditTemplate<>'' OR EditCond<>'' OR EditActionTemplate<>'' OR CheckActionTemplate<>'' OR DeleteActionTemplate<>'',1,0) AS IsEdit, IF(SearchTemplate<>'' OR FullSearchTemplate<>'',1,0) AS IsSearch, IF(SubscribeTemplate<>'' OR SubscribeCond<>'',1,0) AS IsSubscribe, Class_Group from Class where System_Table_ID=0 order by Class_ID";
	}

	if ( $Result = $db->get_results($select) )
	{
		?>
		<form method=post action=index.php>
 		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>

 		<table border=0 cellpadding=4 cellspacing=1 width=100%>
 		<tr>
 		<td bgcolor=eeeeee><font size=-2><b>ID</td>
 		<td bgcolor=eeeeee width=45%><font size=-2><b><?=CONTROL_CLASS_CLASS?></b></td>
 		<? if(!$Class_Group) echo("<td bgcolor=eeeeee width=45%><font size=-2><b>".CONTROL_USER_GROUP."</b></td>"); ?>
 		<td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_CLASS_ACTIONS?></b></td>
 		<td bgcolor=eeeeee align=center><font size=-2><b><?=CONTROL_CLASS_FIELDS?></b></td>

 		<td bgcolor=eeeeee align=center><img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CLASS_DELETE?>'></td>
 		</tr>
 		<?
 		foreach( $Result as $Array )
		{
			print "<tr>";
			print "<td bgcolor=white><font size=-2><b>".$Array->Class_ID."</td>";
			print "<td bgcolor=white><a href=\"index.php?phase=4&ClassID=".$Array->Class_ID.($Class_Group?'&ClassGroup='.md5($Class_Group):'')."\">".$Array->Class_Name."</a></td>";
			if(!$Class_Group) print "<td width='1%' bgcolor=white><font size=-2><a href=\"index.php?phase=1&ClassGroup=".md5($Array->Class_Group)."\">".$Array->Class_Group."</a></td>";
			print "<td bgcolor=white align=center><font size=-2><a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=1".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsAdd?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_ADD."</a>&nbsp;&nbsp;<a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=2".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsEdit?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_EDIT."</a>&nbsp;&nbsp;<a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=3".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsSearch?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_SEARCH."</a>&nbsp;&nbsp;<a href=\"index.php?phase=8&ClassID=".$Array->Class_ID."&myaction=4".($Class_Group?'&ClassGroup='.urlencode($Class_Group):'')."\">".(!$Array->IsSubscribe?"<font color=gray>":"")."".CONTROL_CLASS_ACTIONS_MAIL."</a></td>";
			print "<td bgcolor=white align=center><font size=-2><a href=\"".$ADMIN_PATH."field/?ClassID=".$Array->Class_ID."\"><img border=0 width=16 height=16 alt='".CONTROL_CLASS_FIELDSLIST."' src=".$ADMIN_PATH."images/list.gif></a></td>";
			print "<td bgcolor=white align=center><INPUT TYPE=CHECKBOX NAME=\"Delete".$Array->Class_ID."\" VALUE=".$Array->Class_ID."></td>";
			print "</tr>";
		}
		?>
		</table>
		</td></tr></table><br>
		<?
	}
	else
	{
		nc_print_status(CONTROL_CLASS_NONE, 'info');
	}
/*
	?>
	<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><a href=index.php?phase=10><b><?=CONTROL_CLASS_ADD?></a></td>
	<?
*/
	if ($Array)
	{
       $UI_CONFIG->actionButtons[] = array("id" => "addClass",
                                           "caption" => CONTROL_CLASS_FUNCS_SHOWCLASSLIST_ADDCLASS,
                                           "action" => "urlDispatcher.load('dataclass.add($Class_Group)')",
                                           "align" => "left");
       $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                           "caption" => NETCAT_ADMIN_DELETE_SELECTED,
                                           "action" => "mainView.submitIframeForm()");
/*
		?>
		<td align=right><input class=s type=reset value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>'> <input type=submit class=s value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>'></td>
		<?
*/
	}
/*
	?>
	</tr></table>
	<?
*/
	if ($Array)
	{
		if ($Class_Group) print "<input type='hidden' name='ClassGroup' value='$Class_Group'>";
		?>
 		<input type=hidden name=phase VALUE=6>
		<input type='submit' class='hidden'>
 		</form>
 		<?
 	}
}

##############################################
#  / 
##############################################
function ClassForm ($ClassID, $action, $phase, $type, $BaseClassID )
{
	# type = 1 -  insert
	# type = 2 -  update
	# type = 3 -  update  System_Table,
	#  type = 3 ClassID   SystemTableID
	global $db, $ROOT_FOLDER, $ClassGroup, $ADMIN_PATH, $UI_CONFIG;

	$select = "SELECT Class_Name, DaysToHold, AllowTags, NL2BR, ";
	$select .= "FormPrefix, FormSuffix, RecordTemplate, RecordsPerPage,";
	$select .= "SortBy, RecordTemplateFull, TitleTemplate, Settings, Class_Group, UseCaptcha, CustomSettingsTemplate, ClassDescription";
	$select .= " FROM Class WHERE ";

	if($BaseClassID)
	{
		$type=2;
		$ClassID=$BaseClassID;
	}
	?>
	<font color=gray><?=CONTROL_CLASS_INFO_ADDSLASHES?></font>
	<form method=post id='ClassForm' action=<?= $action ?>>

 	<?
	if ($type == 1)	{
	  if (!$_POST) {
	    if (!$Array->Class_Name) $Array->Class_Name = CONTROL_CLASS_NEWCLASS;
	    if (!$Array->FormPrefix) $Array->FormPrefix = "\$f_AdminCommon";
	    if (!$Array->RecordTemplate) $Array->RecordTemplate = "\$f_AdminButtons";
	    if (!$Array->RecordsPerPage) $Array->RecordsPerPage = "20";
	    if (!$Array->Class_Group) $Array->Class_Group = $db->get_var("SELECT Class_Group FROM Class WHERE md5(Class_Group) = '".$ClassGroup."'");
	  } else {
	    $Array->Class_Name = $_POST['Class_Name'];
	    $Array->Class_Group = $_POST['Class_Group'];
	    $Array->Class_Group_New = $_POST['Class_Group_New'];
	    $Array->FormPrefix = $_POST['FormPrefix'];
	    $Array->FormSuffix = $_POST['FormSuffix'];
	    $Array->RecordTemplate = $_POST['RecordTemplate'];
	    $Array->RecordsPerPage = $_POST['RecordsPerPage'];
	    $Array->SortBy = $_POST['SortBy'];
	    $Array->AllowTags = $_POST['AllowTags'];
	    $Array->NL2BR = $_POST['NL2BR'];
	    $Array->RecordTemplateFull = $_POST['RecordTemplateFull'];
	    $Array->TitleTemplate = $_POST['TitleTemplate'];
	    $Array->Settings = $_POST['Settings'];
	    $Array->UseCaptcha = $_POST['UseCaptcha'];
	    $Array->CustomSettingsTemplate = $_POST['CustomSettingsTemplate'];
	    $Array->ClassDescription = $_POST['ClassDescription'];
	  }
	} elseif ($type == 2) {
		$select .= " Class_ID=".$ClassID;
		$Array = $db->get_row($select) ;
		if ($ClassGroup) {
			$Array->Class_Group = $db->get_var("SELECT Class_Group FROM Class WHERE md5(Class_Group) = '".$ClassGroup."'");
		}
		if ($phase == 5) {
			if ($ClassGroup) $Array->Class_Group = $ClassGroup;
		}
		if (!$Array) nc_print_status(CONTROL_CLASS_ERRORS_DB, 'error');
	} elseif ($type == 3) {
		$select .= " System_Table_ID=".$ClassID;
		$Array = $db->get_row($select);
		if (!$Array) nc_print_status(CONTROL_CLASS_ERRORS_DB, 'error');
	}

	if ( ($type == 1) or ($type == 2) )
	{
    	print "<font color=gray>".CONTROL_CLASS_CLASS_NAME.":<br><INPUT TYPE=TEXT NAME=ClassName SIZE=50 VALUE=\"".htmlspecialchars($Array->Class_Name)."\"><br><br>";
	}

	if ($type==1 or $type==2)
	{
		print(CONTROL_USER_GROUP.":<br><select name='Class_Group' style='width: auto;'>\n");

		foreach ( $db->get_col("SELECT DISTINCT Class_Group FROM Class") as $Class_Group)
		{
			if ($Array->Class_Group == $Class_Group)
				echo("\t<option value='".$Class_Group."' selected='selected'>".$Class_Group."</option>\n");
 			else
 				echo("\t<option value='".$Class_Group."'>".$Class_Group."</option>\n");
		}

		unset($grs);
		print("</select>&nbsp;&nbsp;&nbsp;".CONTROL_CLASS_NEWGROUP.":&nbsp;<INPUT TYPE=TEXT NAME=Class_Group_New SIZE=8 MAXLENGTH=64 value='".htmlspecialchars($Array->Class_Group_New)."'><br><br>");
	}
 	print "<table border='0' cellpadding='6' cellspacing='0' width='100%' bgcolor='#F3F3F3'><tr><td colspan='2'>
 	  <div id='classDescriptionOff' style='cursor: pointer;' onclick='this.style.display=\"none\";document.getElementById(\"classDescriptionOn\").style.display=\"\";'>
 	    <font color='gray'> &#x25BA; ". CONTROL_CLASS_CLASS_DESCRIPTION. "</font>
 	  </div>
 	  <div id='classDescriptionOn' style='display: none'>
	    <font color='gray' style='cursor: pointer;' onclick='document.getElementById(\"classDescriptionOn\").style.display=\"none\";document.getElementById(\"classDescriptionOff\").style.display=\"\";'> &#x25BC; ". CONTROL_CLASS_CLASS_DESCRIPTION. ":</font>
	    <br><TEXTAREA id='CustomSettings' WRAP='OFF' ROWS='8' COLS='60' NAME='ClassDescription'>".
   	   htmlspecialchars($Array->ClassDescription).
   	 "</TEXTAREA></div></td></tr></table><br>";
	?>

  <b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<tr><td><a name='ListPrefix' href='#ListPrefix' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=ListPrefix<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_PREFIX?>:<br>
    <TEXTAREA id='ListPrefix' WRAP=OFF ROWS=10 COLS=60 NAME=FormPrefix ><?=htmlspecialchars($Array->FormPrefix)?></TEXTAREA></td></tr>
	<TR><TD><a name='ListBody' href='#ListBody' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=ListBody<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_BODY?>:<br><TEXTAREA id='ListBody' WRAP=OFF ROWS=10 COLS=60 NAME=RecordTemplate><?=htmlspecialchars($Array->RecordTemplate)?></TEXTAREA></TD></TR>
	<TR><TD><a name='ListSuffix' href='#ListSuffix' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=ListSuffix<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SUFFIX?>:<br><TEXTAREA id='ListSuffix' WRAP=OFF ROWS=10 COLS=60 NAME=FormSuffix><?=htmlspecialchars($Array->FormSuffix)?></TEXTAREA></TD></TR>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOW?> <INPUT TYPE=TEXT NAME=RecordsPerPage SIZE=4 MAXLENGTH=255 VALUE="<?=htmlspecialchars($Array->RecordsPerPage)?>"> <?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ?></td></tr>
	<tr><td><font color=gray><a name='SortBy' href='#SortBy' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=classinput&window=opener&form=ClassForm&textarea=SortBy<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_LIST?></a><br><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SORT?>*:<br><INPUT id='SortBy' TYPE=TEXT NAME=SortBy SIZE=50 MAXLENGTH=255 VALUE="<?=htmlspecialchars($Array->SortBy)?>"><br>
	* <?=CONTROL_CLASS_CLASS_OBJECTSLIST_SORTNOTE?></td></tr>
	</table><br>

	<b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTVIEW?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<tr><td><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_PAGETITLE?>:<br><INPUT TYPE=TEXT NAME=TitleTemplate SIZE=50 MAXLENGTH=255 VALUE="<?=htmlspecialchars($Array->TitleTemplate)?>"></td></tr>
	<tr><td><a name='PageBody' href='#PageBody' onclick="window.open('<?=$ADMIN_PATH?>class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=PageBody<?=(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")?>','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')"><?=CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST?></a><br><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_PAGEBODY?>:<br><TEXTAREA id='PageBody' WRAP=OFF ROWS=10 COLS=60 NAME=RecordTemplateFull><?=htmlspecialchars($Array->RecordTemplateFull)?></TEXTAREA></td></tr>
	</table><br>

	<b><font color=gray><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_DOPL?></font></b>
	<table border=0 cellpadding=6 cellspacing=0 width=100% bgcolor=#F3F3F3>
	<?
	print "<tr><td colspan=2><font color=gray><input type=checkbox id=tags name=AllowTags ".($Array->AllowTags?"checked":"")." value=1> <label for=tags>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_HTML."</label></td></tr>";
	print "<tr><td colspan=2><font color=gray><input type=checkbox id=br name=NL2BR ".($Array->NL2BR?"checked":"")." value=1> <label for=br>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_BR."</label></td></tr>";
	print "<tr><td colspan=2><font color=gray><input type=checkbox id=captcha name=UseCaptcha ".($Array->UseCaptcha?"checked":"")." value=1> <label for=captcha>".CONTROL_CLASS_USE_CAPTCHA."</label></td></tr>";
 	print "<tr><td colspan=2><a name='Settings' href='#Settings' onclick=\"window.open('".$ADMIN_PATH."class/index.php?phase=12&formtype=class&window=opener&form=ClassForm&textarea=Settings".(($type != 3)?"&classid=$ClassID&systemclassid=0":"&classid=0&systemclassid=$ClassID")."','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400'); return false;\">".CONTROL_CLASS_CLASS_SHOW_VAR_FUNC_LIST."</a><br><font color=gray>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_SYSTEM.":<br><TEXTAREA id='Settings' WRAP=OFF ROWS=8 COLS=60 NAME=Settings>".htmlspecialchars($Array->Settings)."</TEXTAREA></td></tr>";

 	print "<tr><td colspan='2'>
 	  <div id='cstOff' style='cursor: pointer;' onclick='this.style.display=\"none\";document.getElementById(\"cstOn\").style.display=\"\";'>
 	    <font color='gray'> &#x25BA; ". CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE. "</font>
 	  </div>
 	  <div id='cstOn' style='display: none'>
	    <font color='gray' style='cursor: pointer;' onclick='document.getElementById(\"cstOn\").style.display=\"none\";document.getElementById(\"cstOff\").style.display=\"\";'> &#x25BC; ". CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE. ":</font>
	    <br><TEXTAREA id='CustomSettings' WRAP='OFF' ROWS='8' COLS='60' NAME='CustomSettingsTemplate'>".
   	   htmlspecialchars($Array->CustomSettingsTemplate).
   	 "</TEXTAREA></div></td></tr>";

 	print "<tr><td colspan=2><INPUT TYPE=hidden NAME=DaysToHold SIZE=4 VALUE=\"".htmlspecialchars($Array->DaysToHold)."\"></td></tr>";
 	if ($type == 2 && !$BaseClassID) print "<tr><td colspan=2><font color=gray><a href='ExportToFile.php?ClassID=".$ClassID."'>".CONTROL_CLASS_EXPORT."</a></td></tr>";
	?>
	</table>
	<br>

	<div align=right>
	<?
	if($type==1 || $BaseClassID)
	{
       $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                           "caption" => CONTROL_CLASS_ADD,
                                           "action" => "mainView.submitIframeForm()");
/*
		?>
		<input class=s type=submit value='<?=CONTROL_CLASS_ADD?>'>
		<?
*/
	}
	elseif ($type>1)
	{
       $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                           "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                           "action" => "mainView.submitIframeForm()"
                                          );
/*
		?>
		<input class=s type=reset value="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>"> <input class=s type=submit value="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>">
		<?
*/
	}
	?>
	</div>
	<?
	//     
	global $Class_Type;
	echo "<input type='hidden' name='Class_Type' value='".$Class_Type."'>\n";
	if($BaseClassID)
		print "<INPUT TYPE=HIDDEN NAME=BaseClassID VALUE=".$BaseClassID.">\n";
	else
		print "<INPUT TYPE=HIDDEN NAME=ClassID VALUE=".$ClassID.">\n";
 	?>

	<input type=hidden name=ClassGroup value='<?=$ClassGroup?>'>
	<input type=hidden name=phase value=<?=$phase?>>
	<input type=hidden name=type value=<?
	if($BaseClassID) $type=1;
	print $type;
	?>>
	<input type='submit' class='hidden'>
	</form>
  <!--  START   REMIND_SAVE -->
<script type='text/javascript'>remind_redaction(); </script>
<!-- END REMIND_SAVE -->
	<?
} 


##############################################
# / 
##############################################
function ActionClassComleted ($type) {
	global $db, $ROOT_FOLDER;
	global $perm;

	foreach ($_POST as $key => $val) {
    eval("global \$".$key.";");
  }

	$AllowTags += 0;
	$NL2BR += 0;
	$DaysToHold += 0;
	$RecordsPerPage += 0;
	$UseCaptcha = (int)$UseCaptcha;
  
  if ( nc_module_check_by_keyword("cache") ) {
    include_once ($GLOBALS['MODULE_FOLDER']."cache/function.inc.php");
    // init listener
    $nc_cache_listener = nc_cache_listener::getObject();
  }
  
	if ($type == 1) {
    $insert = "INSERT INTO `Class` (`Class_Name`, `Class_Group`, `DaysToHold`, `AllowTags`, `NL2BR`, `FormPrefix`, `FormSuffix`, `RecordTemplate`, `RecordTemplateFull`, `RecordsPerPage`, `SortBy`, `TitleTemplate`, `Settings`, `UseCaptcha`, `CustomSettingsTemplate`, `ClassDescription`) ";
    $insert.= "VALUES ('".$ClassName."',";
    if ($Class_Group_New) {
      $insert.= "'".$Class_Group_New."',";
    }
    elseif ($Class_Group) {
      $insert.= "'".$Class_Group."',";
    }

    $insert.= "'".$DaysToHold."',";
    $insert.= "'".$AllowTags."',";
    $insert.= "'".$NL2BR."',";
    $insert.= "'".$FormPrefix."',";
    $insert.= "'".$FormSuffix."',";
    $insert.= "'".$RecordTemplate."',";
    $insert.= "'".$RecordTemplateFull."',";
    $insert.= "'".$RecordsPerPage."',";
    $insert.= "'".$SortBy."',";
    $insert.= "'".$TitleTemplate."',";
    $insert.= "'".$Settings."',";
    $insert.= "'".$UseCaptcha."',";
    $insert.= "'".$CustomSettingsTemplate."',";
    $insert.= "'".$ClassDescription."')";


    $db->query($insert);
    $classInsertedID = $db->insert_id;
    
    CreateMessageTable($classInsertedID, $db);
    
		return $classInsertedID;
 	}


	if ($type==2 || $type==3) {
  
    $suffix_where = " WHERE `".($type==2 ? "Class_ID" : "System_Table_ID")."` = '".(int)$ClassID."'";
    
    if ( nc_module_check_by_keyword("cache") ) {
      // clear cache
      $cache_to_delete = $db->get_results("SELECT `Catalogue_ID`, `Subdivision_ID`, `Sub_Class_ID` FROM `Sub_Class` ".$suffix_where, ARRAY_A);
      // delete cache files
      if ( !empty($cache_to_delete) ) {
        foreach ($cache_to_delete AS $cache_to_delete_row) {
          // delete cache
          $nc_cache_listener->event("dropSubClass", $cache_to_delete_row['Catalogue_ID'], $cache_to_delete_row['Subdivision_ID'], $cache_to_delete_row['Sub_Class_ID']);
        }
      }
      // delete cache
      $nc_cache_listener->event("dropClass", $ClassID);
    }
  
    $update = "UPDATE `Class` SET ";
    if ($type==2) {
      $update.= "`Class_Name` = '".$ClassName."',";
      if ($Class_Group_New) {
        $update.= "`Class_Group` = '".$Class_Group_New."',";
      }
      else {
        $update.= "`Class_Group` = '".$Class_Group."',";
      }
    }
    $update.= "`DaysToHold` = '".$DaysToHold."',";
    $update.= "`AllowTags` = '".$AllowTags."',";
    $update.= "`NL2BR` = '".$NL2BR."',";
    $update.= "`FormPrefix` = '".$FormPrefix."',";
    $update.= "`FormSuffix` = '".$FormSuffix."',";
    $update.= "`RecordTemplate` = '".$RecordTemplate."',";
    $update.= "`RecordTemplateFull` = '".$RecordTemplateFull."',";
    $update.= "`RecordsPerPage` = '".$RecordsPerPage."',";
    $update.= "`SortBy` = '".$SortBy."',";
    $update.= "`TitleTemplate` = '".$TitleTemplate."',";
    $update.= "`Settings` = '".$Settings."',";
    $update.= "`UseCaptcha` = '".$UseCaptcha."',";
    $update.= "`CustomSettingsTemplate` = '".$CustomSettingsTemplate."', ";
    $update.= "`ClassDescription` = '".$ClassDescription."'";
    // where string for Class or SystemTable
    $update.= $suffix_where;
    
    return $db->query($update);
	}
}


##############################################
#      
##############################################
function addNewTemplate($Class_Group = '') {
global $db, $UI_CONFIG, $ADMIN_PATH;

	$classes = $db->get_results("SELECT `Class_ID` AS value,
		CONCAT(`Class_ID`, '. ', `Class_Name`) AS description,
		`Class_Group` AS optgroup
		FROM `Class`
		ORDER BY `Class_Group`, `Class_ID`", ARRAY_A);

	?>
	<fieldset>
	<legend>
	<b><font color='gray'><?=CONTROL_CLASS_CLASS_CREATENEW_BASICOLD?></font></b>
	</legend>
	<form method='get' style='padding:15px 20px 10px'>
	<table border='0' cellpadding='0' cellspacing='0'>
	<tr>
	<td width='80%'>
	<?
	echo "<select name='BaseClassID'>";
	echo "<option value='0'>".CONTROL_CLASS_CLASS_CREATENEW_CLEARNEW."</option>";
	echo nc_select_options($classes);
	echo "</select>";
	?>
	</td>
	<td>&nbsp;</td>
	</tr>
	</table>
	<?
	$UI_CONFIG->actionButtons[] = array("id" => "submit",
		"caption" => CONTROL_CLASS_CONTINUE,
		"action" => "mainView.submitIframeForm()");
	if ($Class_Group) {
		print "<input type='hidden' name='ClassGroup' value='".$Class_Group."'>";
	}
	?>
	<input type='hidden' name='phase' value='2'>
	<input type='submit' class='hidden'>
	</form>
	</fieldset>
	<?
}


##############################################
#  
##############################################
function ConfirmDeletion ($Class_Group = '')
{
	global $db;
	global $UI_CONFIG;
	$ask = false;
	
  $class_id_array = array();
	print "<form method=post action=index.php>";
	
	foreach(array_merge($_POST, $_GET) as $key => $val) {
		if (substr($key,0,6)=="Delete" && $val) {
			$ask = true;

			$class_id = substr($key,6,strlen($key)-6)+0;
			$class_id_array[] = $class_id;

			$SelectArray = $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID`='".$class_id."'") ;
			
			print "<input type='hidden' name='".$key."' value='".$val."'>";
			$class_counter++;
		}
	}

	if (!$ask) return false;

	if ($class_counter>1)
	{
		$UI_CONFIG = new ui_config_class('delete', '', $ClassGroup);
		$post_f1 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_I;
		$post_f2 = CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_WARNING_SITEDELETE_U;
	} else {
		print "<input type='hidden' name='ClassGroup' value='".$db->get_var("SELECT md5(Class_Group) FROM Class WHERE Class_ID = '$class_id' GROUP BY Class_Group")."'>";
		$UI_CONFIG = new ui_config_class('delete', $class_id, $ClassGroup);
	}
	nc_print_status(CONTROL_CLASS_CLASS_DELETE_WARNING, 'info', array($post_f1, $post_f2));
	?>
	<input type=hidden name=phase value=7>
	</form>
	<?
	nc_list_class_use($class_id_array, 0, 0);
	$UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CONFIRMDELETE,
                                        "action" => "mainView.submitIframeForm()");
	return true;
}


##############################################
#  
##############################################
function CascadeDeleteClass ($ClassID)
{
	global $db;
	global $UI_CONFIG;

	$ClassGroup = $db->get_var("SELECT Class_Group FROM Class WHERE Class_ID = '".$ClassID."'");
	$isMoreClasses = $db->get_var("SELECT COUNT(*)-1 FROM Class WHERE Class_Group = '".$ClassGroup."'");

	$LockTables = "LOCK TABLES Class WRITE, Field WRITE,";
	$LockTables .= "Message".$ClassID." WRITE,";
	$LockTables .= "Sub_Class WRITE";

	$LockResult = $db->query($LockTables.$AddLockTables);

	$DeleteClass = "DELETE FROM Class WHERE Class_ID=".$ClassID;
	$DeleteField = "DELETE FROM Field WHERE Class_ID=".$ClassID;
	$DeleteSubClass = "DELETE FROM Sub_Class WHERE Class_ID=".$ClassID;
	$DropMessage = "DROP TABLE Message".$ClassID;

	$db->query($DropMessage);
	$db->query($DeleteSubClass);
	$db->query($DeleteField);
	$db->query($DeleteClass);

	$UnlockResult = $db->query("UNLOCK TABLES");

	if (!$isMoreClasses) {
		$UI_CONFIG->treeChanges['deleteNode'][] = "group-".md5($ClassGroup);
	} else {
		$UI_CONFIG->treeChanges['deleteNode'][] = "dataclass-{$ClassID}";
	}
	return $isMoreClasses;
}

##############################################
#   
##############################################
function ClassActionForm ($ClassID, $action, $phase, $type, $myaction)
{
	global $db, $ClassGroup, $SystemTableID, $user_table_mode;
	global $UI_CONFIG;

	# type=1 -  
	# type=2 -   
	#  type=2 ClassID -     SystemTableID

	if (!$ClassID) {
		print nc_print_status(CONTROL_CLASS_ERRORS_DB, 'error');
		return;
	}

	?>
	<form method=post action="<?= $action ?>">
	<font color=gray>
	<?

	$select = "SELECT AddTemplate, AddCond, AddActionTemplate, EditTemplate, EditCond, EditActionTemplate, CheckActionTemplate, DeleteActionTemplate, ";
	$select .= "SearchTemplate, FullSearchTemplate, SubscribeTemplate, SubscribeCond";

	if ($type == 1) $select .= " FROM Class WHERE Class_ID=";
	if ($type == 2)	$select .= " FROM Class WHERE System_Table_ID=";
	$select .= $ClassID;

	if (!$Array = $db->get_row($select))
		print nc_print_status(CONTROL_CLASS_ERRORS_DB, "error");

 	$show_generate_link = false;
	if (!$SystemTableID || $SystemTableID==3) {
		$show_generate_link = true;
		if ($SystemTableID) {
			$sysTable = $SystemTableID;
		}
		else {
			$sysTable = 0;
		}
	}
	
	switch ($myaction) {
        case 1: {
                if ($type == 1) $UI_CONFIG = new ui_config_class('customadd', $ClassID);
                if ($type == 2) $UI_CONFIG = new ui_config_system_class('customadd', $SystemTableID);
                print CONTROL_CLASS_CLASS_FORMS_ADDFORM.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'AddTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_ADDFORM_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='AddTemplate' id='AddTemplate'>".htmlspecialchars($Array->AddTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ADDRULES.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'AddCond'); return false;\">".CONTROL_CLASS_CLASS_FORMS_ADDCOND_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='AddCond' id='AddCond'>".htmlspecialchars($Array->AddCond)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ADDLASTACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'AddActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_ADDACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='AddActionTemplate' id='AddActionTemplate'>".htmlspecialchars($Array->AddActionTemplate)."</TEXTAREA><br><br>";
                // START   REMIND_SAVE          
                print "<script type='text/javascript'> remind_add(); </script>";
                // END REMIND_SAVE
                }  break;
        case 2: {
                if ($type == 1) $UI_CONFIG = new ui_config_class('customedit', $ClassID);
                if ($type == 2) $UI_CONFIG = new ui_config_system_class('customedit', $SystemTableID);
                print CONTROL_CLASS_CLASS_FORMS_EDITFORM."".($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'EditTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITFORM_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='EditTemplate' id='EditTemplate'>".htmlspecialchars($Array->EditTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_EDITRULES.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'EditCond'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITCOND_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='EditCond' id='EditCond'>".htmlspecialchars($Array->EditCond)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_EDITLASTACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'EditActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_EDITACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='EditActionTemplate' id='EditActionTemplate'>".htmlspecialchars($Array->EditActionTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ONONACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'CheckActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_CHECKACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='CheckActionTemplate' id='CheckActionTemplate'>".htmlspecialchars($Array->CheckActionTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_ONDELACTION.($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'DeleteActionTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_DELETEACTION_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='DeleteActionTemplate' id='DeleteActionTemplate'>".htmlspecialchars($Array->DeleteActionTemplate)."</TEXTAREA><br><br>";
                // START   REMIND_SAVE    
                print "<script type='text/javascript'>remind_edit(); </script>";
                // END REMIND_SAVE
                } break;
        case 3: {
                if ($type == 1) $UI_CONFIG = new ui_config_class('customsearch', $ClassID);
                if ($type == 2) $UI_CONFIG = new ui_config_system_class('customsearch', $SystemTableID);
			    print CONTROL_CLASS_CLASS_FORMS_QSEARCH."".($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'FullSearchTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_QSEARCH_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='FullSearchTemplate' id='FullSearchTemplate'>".htmlspecialchars($Array->FullSearchTemplate)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_SEARCH."".($show_generate_link ? " (<a href='#' onclick=\"generateForm(".$ClassID.", ".$sysTable.", 'SearchTemplate'); return false;\">".CONTROL_CLASS_CLASS_FORMS_SEARCH_GEN."</a>)" : "").":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS=60 NAME='SearchTemplate' id='SearchTemplate'>".htmlspecialchars($Array->SearchTemplate)."</TEXTAREA><br><br>";
                // START   REMIND_SAVE   
                print "<script type='text/javascript'> remind_search(); </script>";
                // END REMIND_SAVE          
                } break;
        case 4: {
                if ($type == 1) $UI_CONFIG = new ui_config_class('customsubscribe', $ClassID);
                if ($type == 2) $UI_CONFIG = new ui_config_system_class('customsubscribe', $SystemTableID);
                print CONTROL_CLASS_CLASS_FORMS_MAILRULES.":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='SubscribeCond' id='SubscribeCond'>".htmlspecialchars($Array->SubscribeCond)."</TEXTAREA><br><br>";
                print CONTROL_CLASS_CLASS_FORMS_MAILTEXT.":<br><TEXTAREA ROWS='10' WRAP='OFF' COLS='60' NAME='SubscribeTemplate' id = 'SubscribeTemplate'>".htmlspecialchars($Array->SubscribeTemplate)."</TEXTAREA><br><br>";
                // START   REMIND_SAVE             
                print "<script type='text/javascript'> remind_subscrib(); </script>";
                 // END REMIND_SAVE  
                } break;
	}
       $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                           "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                           "action" => "mainView.submitIframeForm()"
                                          );
/*
	?>
	<hr size=1 color=cccccc>
	<div align=right><input type=reset class=s value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>'> <input type=submit value="<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>" class=s></div>
	<?
*/
 	print "<INPUT TYPE=HIDDEN NAME=ClassID VALUE=".$ClassID.">\n";
 	print "<input type=hidden name=phase value=".$phase.">";
 	print "<input type=hidden name=myaction value=".$myaction.">";
 	print "<input type=hidden name=type value=".$type.">";
	print "<input type=hidden name=ClassGroup value='".$ClassGroup."'>";
 	?>
	<input type='submit' class='hidden'>
  	</form>
 	<?
}

##############################################
#    
##############################################
function ClassActionCompleted ($myaction,$type)
{
	global $db;
	# type=1 -  
	# type=2 -   
	#  type=2 ClassID -     SystemTableID

	while (list($key, $val) = each($_POST))
		eval("global \$".$key.";");

	$update = "UPDATE Class SET ";
	 switch ($myaction) {

        case 1: {
                $update .= "AddTemplate=\"".$AddTemplate."\",";
                $update .= "AddCond=\"".$AddCond."\",";
                $update .= "AddActionTemplate=\"".$AddActionTemplate."\"";
        } break;

        case 2: {
                $update .= "EditTemplate=\"".$EditTemplate."\",";
                $update .= "EditCond=\"".$EditCond."\",";
                $update .= "EditActionTemplate=\"".$EditActionTemplate."\",";
                $update .= "CheckActionTemplate=\"".$CheckActionTemplate."\",";
                $update .= "DeleteActionTemplate=\"".$DeleteActionTemplate."\"";
        } break;

        case 3: {
                $update .= "FullSearchTemplate=\"".$FullSearchTemplate."\",";
                $update .= "SearchTemplate=\"".$SearchTemplate."\"";
        } break;

        case 4: {
                $update .= "SubscribeCond=\"".$SubscribeCond."\",";
                $update .= "SubscribeTemplate=\"".$SubscribeTemplate."\"";
        } break;
	}

	if ($type == 1)
		$update .= " WHERE Class_ID=".$ClassID;
	if ($type == 2)
		$update .= " WHERE System_Table_ID=".$ClassID;

 	$db->query($update);
}


function nc_class_info($class_id) {
  global $db, $UI_CONFIG;
  
  $info = $db->get_row("SELECT ClassDescription, CustomSettingsTemplate FROM Class WHERE Class_ID = '".$class_id."'", ARRAY_A);
  $fields = $db->get_results("SELECT Field_Name, Description FROM Field WHERE Class_ID = '".$class_id."' ORDER BY Priority", ARRAY_A);
  
  echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'><tr><td bgcolor='#CCCCCC'>\n<table border='0' cellpadding='6' cellspacing='1' width='100%'>";
  if ($info['ClassDescription']) echo "<tr><td colspan='2' bgcolor='#FFFFFF'><b>".CONTROL_CLASS_CLASS_DESCRIPTION.":</b><br><br>".$info['ClassDescription']."</td></tr>";
  echo "<tr>";
  echo "<td width='50%' bgcolor='#FFFFFF'>";
  
  if ($fields) {
    echo "<b>".CONTROL_CLASS_FIELDS.":</b><br>";
    echo "<ol>";
    foreach ($fields as $field) {
      echo "<li>".$field['Description']." (".$field['Field_Name'].")<br>\n";
    }
    echo "</ol>";
  } else {
    echo CONTROL_FIELD_LIST_NONE;
  }
  
  echo "</td>";
  echo "<td width='50%' bgcolor='#FFFFFF'>";
  if ($info['CustomSettingsTemplate']) {
    eval($info['CustomSettingsTemplate']);
    echo "<b>".CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE.":</b><br>";
    echo "<ol>";
    foreach($settings_array as $settings) {
      echo "<li>".$settings['caption']."<br>\n";
    }
    echo "</ol>";
  } else {
    echo CONTROL_CLASS_CUSTOM_SETTINGS_ISNOTSET;
  }
  echo "</td>";
  echo "</tr>";
  echo "</table>\n</td></tr></table>";
}


/**
 * Show using class
 *
 * @param array | null arrayClassID, if !isset - all class
 * @param int 0 - all, 1 - only used, 2 - only unused
 * @param show "checkbox" for clear subClass
 */
function nc_list_class_use ($arrayClassID, $param_show = 0, $withdeleted = 1) {
  global $db;
  
  $colspan = $withdeleted ? 5 : 4;
  
  if (!$arrayClassID) $arrayClassID = $db->get_col("SELECT `Class_ID` From `Class`");
 
  $where = "Class.`Class_ID` IN(".join(",", $arrayClassID).")";
  $query ="SELECT Class.`Class_ID` AS ClassID, Class.`Class_Name` AS ClassName, 
                  Sub_Class.`Sub_Class_ID` AS SubClassID, Sub_Class.`Sub_Class_Name` AS SubClassName, Sub_Class.`EnglishName` AS SubClassKeyword, 
                  Subdivision.`Subdivision_Name` AS SubName, Subdivision.`Subdivision_ID` AS SubID, Subdivision.`Hidden_URL` AS SubURL
            FROM `Class` 
            LEFT JOIN `Sub_Class` 
            ON Sub_Class.`Class_ID` = Class.`Class_ID`
            LEFT JOIN `Subdivision` 
            ON Subdivision.`Subdivision_ID` = Sub_Class.`Subdivision_ID`
            WHERE ".$where;
  $Result = $db->get_results($query, ARRAY_A);
  
  $curClass = -1;
  
  if ( $withdeleted ) echo "<form action='index.php' name='del' method='post' id='del'>\n";
  
  echo "
   <table border='0' cellpadding='0' cellspacing='0' width='100%'><tr><td bgcolor='#cccccc'>\n
    <table border='0' cellpadding='4' cellspacing='1' width='100%'>\n
      <tr>\n
        <td bgcolor='#eeeeee' width='30%'><font size='-2'><b>".CONTROL_CLASS."</b></td>\n
        <td bgcolor='#eeeeee' width='30%'><font size='-2'><b>".CONTROL_CONTENT_SUBDIVISION_FUNCS_SECTION."</b></td>\n
        <td bgcolor='#eeeeee' width='30%'><font size='-2'><b>".CONTROL_CONTENT_SUBDIVISION_CLASS."</b></td>\n
        <td bgcolor='#eeeeee' align='center'><font size='-2'><b>".CONTROL_CONTENT_SUBCLASS_TOTALOBJECTS."</b></td>\n".
        ($withdeleted ? "<td bgcolor='#eeeeee' align='center'><font size='-2'><b>".REPORTS_STAT_CLASS_CLEAR."</b></td>\n" : "")
      ."</tr>";
      
  $str = '';
  foreach ( $Result as $row  ) {

    if ( $curClass != $row['ClassID'] ) {
       
      switch ($param_show) {
        case 0:
          print($str); 
          break;
        case 1:
          if( $useSubClass ) print($str);
          break;
        case 2:
          if( !$useSubClass ) print($str);
          break; 
      }
           

      $str = $divider; // ,       
      $str .= "<tr>";
      $divider = "<tr><td colspan='".$colspan."' height='2px' bgcolor='#cccccc'  style='padding: 0px'></tr>"; 
      $curClass = $row['ClassID'];
      $query = "SELECT COUNT(`Message_ID`), `Sub_Class_ID` FROM `Message".$curClass."` GROUP BY `Sub_Class_ID`";
      $db->query($query);
      unset($countMes);
      if ($db->get_col(null, 1))
      $countMes = array_combine((array)$db->get_col(null, 1),  (array)$db->get_col(null, 0) );
      $query = "SELECT COUNT(`Message_ID`), `Sub_Class_ID` FROM `Message".$curClass."` WHERE `Checked` = 0 GROUP BY `Sub_Class_ID`";
      $db->query($query);
        
      unset($countMes_off);
      if ($db->get_col(null, 1))
        $countMes_off = array_combine((array)$db->get_col(null, 1),  (array)$db->get_col(null, 0) );  
      $useSubClass = false;
      if( $row['SubClassID']) $useSubClass = true;
        $str .= "<td bgcolor='#ffffff'><a href = '../class/index.php?phase=4&amp;ClassID=".$curClass."' style='text-decoration: none'>
                                   <b><font color='#000000'>".$curClass.". ".$row['ClassName']."</b></font></a></td>";
     
      }
      else { 
        $str .= "<tr><td bgcolor='#ffffff'><font size=-2></td>";
      }
      
      if ( $row['SubID']) {
        $temp1 = "<a href = '".$row['SubURL']."' style='text-decoration: none' target='_blank'>".$row['SubID'].". ".$row['SubName']."</a>";
        $temp2 = "<a href = '".$row['SubURL'].$row['SubClassKeyword'].".html' style='text-decoration: none' target='_blank'>".$row['SubClassID'].". ".$row['SubClassName']."</a>";    
      }
      else {
        $temp1 = $temp2 =  "-";  
      }
      
      $str .= "<td bgcolor='#ffffff'><font size='-2'>".$temp1."</td>
               <td bgcolor='#ffffff'><font size='-2'>".$temp2."</td>";
      
        $str .="<td align='center' bgcolor='#ffffff'>".$countMes[$row['SubClassID']];
        if ($countMes_off[$row['SubClassID']]) $str .= "(".$countMes_off[$row['SubClassID']].")";
        $str .= "</td>";
        if ($withdeleted ) {
          $str .= "<td align='center' bgcolor='#ffffff'>".($countMes[$row['SubClassID']]?("<input type='checkbox' value='".$row['SubClassID']."' name='Delete".$row['SubClassID']."'>"):'')."</td>";
        }
      $str .= "</tr>";
      
    }
    switch ($param_show) {
          case 0:
            print($str); 
            break;
          case 1:
            if( $useSubClass ) print($str);
            break;
          case 2:
            if( !$useSubClass ) print($str);
            break; 
        }
    print "</table></td></tr></table>";
    if ($withdeleted) print "<input type='hidden' name='phase' value='3'></form>\n";
    

}
class ui_config_class extends ui_config {

  function ui_config_class($active_tab = 'edit', $class_id, $class_group = '') {

    global $db;

    if ($class_id) {
    	$this->headerText = $db->get_var("SELECT Class_Name FROM Class WHERE Class_ID = $class_id");
    } elseif ($class_group) {
    	$this->headerText = $db->get_var("SELECT Class_Group FROM Class WHERE md5(Class_Group) = '".$class_group."' GROUP BY Class_Group");
    } else {
    	$this->headerText = SECTION_INDEX_DEV_CLASSES;
    }

    $this->headerImage = 'i_folder_big.gif';
    if ($active_tab == 'add') {
	    $this->tabs = array(
	                     array('id' => 'add',
	                           'caption' => CONTROL_CLASS_ADD_ACTION,
	                           'location' => "dataclass.add($class_group)"));
    } elseif ($active_tab == 'delete') {
	    $this->tabs = array(
	                     array('id' => 'delete',
	                           'caption' => CONTROL_CLASS_DELETE,
	                           'location' => "dataclass.delete($class_group)"));
    } else {
	    $this->tabs = array(
	                     array('id' => 'info',
	                           'caption' => CLASS_TAB_INFO,
	                           'location' => "dataclass.info($class_id)"),
	                     array('id' => 'edit',
	                           'caption' => CLASS_TAB_EDIT,
	                           'location' => "dataclass.edit($class_id)"),
	                     array('id' => 'customadd',
	                           'caption' => CLASS_TAB_CUSTOM_ADD,
	                           'location' => "dataclass.customadd($class_id)"),
	                     array('id' => 'customedit',
	                           'caption' => CLASS_TAB_CUSTOM_EDIT,
	                           'location' => "dataclass.customedit($class_id)"),
	                     array('id' => 'customsearch',
	                           'caption' => CLASS_TAB_CUSTOM_SEARCH,
	                           'location' => "dataclass.customsearch($class_id)"),
	                     array('id' => 'customsubscribe',
	                           'caption' => CLASS_TAB_CUSTOM_SUBSCRIBE,
	                           'location' => "dataclass.customsubscribe($class_id)"),
	                     array('id' => 'fields',
	                           'caption' => CONTROL_CLASS_FIELDS,
	                           'location' => "dataclass.fields($class_id)"));
    }

    $this->activeTab = $active_tab;

    if ($active_tab == 'add') {
    	$this->locationHash = "#dataclass.$active_tab($class_group)";
//	    $this->treeSelectedNode = "group-$class_group";
    } else {
    	$this->locationHash = "#dataclass.$active_tab($class_id)";
        $this->treeSelectedNode = "dataclass-{$class_id}";
    }

    $this->treeMode = 'developer';
  }

  function updateTreeClassNode($class_id, $class_name) {

    $this->treeChanges['updateNode'][] = array("nodeId" => "sub-$node_id",
                                               "name" => "$node_id. $node_name");
  }

}

class ui_config_class_group extends ui_config {

  function ui_config_class_group($active_tab = 'edit', $class_group) {

    global $db;

    $this->headerText = $db->get_var("SELECT Class_Group FROM Class WHERE md5(Class_Group) = '$class_group' GROUP BY Class_Group");
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
	                 array('id' => 'edit',
                           'caption' => CONTROL_CLASS_CLASS_GROUPS,
                           'location' => "classgroup.edit($class_group)")
	          );

    $this->activeTab = $active_tab;
    $this->locationHash = "classgroup.edit($class_group)";
    $this->treeMode = 'developer';
    $this->treeSelectedNode = "group-$class_group";
  }
}

class ui_config_classes extends ui_config {

  function ui_config_classes($active_tab = 'dataclass.list') {

    $this->headerText = SECTION_CONTROL_CLASS;
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
	                 array('id' => 'dataclass.list',
                           'caption' => SECTION_CONTROL_CLASS_LIST,
                           'location' => "dataclass.list()")
	          );
    $this->activeTab = $active_tab;

	$this->locationHash = "#dataclass.list()";
    $this->treeMode = 'developer';
    $this->treeSelectedNode = "dataclass.list()";
  }
}

class ui_config_system_class extends ui_config {

  function ui_config_system_class($active_tab = 'edit', $system_class_id) {

    global $db;
    
    $modules = $db->get_results("SELECT Keyword, Module_Name FROM Module ORDER BY Keyword", ARRAY_A);
    $system_class = $db->get_row("SELECT a.System_Table_ID, a.System_Table_Rus_Name, b.Class_ID, IF(b.AddTemplate<>'' OR b.AddCond<>'' OR b.AddActionTemplate<>'',1,0) AS IsAdd, IF(b.EditTemplate<>'' OR b.EditCond<>'' OR b.EditActionTemplate<>'' OR b.CheckActionTemplate<>'' OR b.DeleteActionTemplate<>'',1,0) AS IsEdit, IF(b.SearchTemplate<>'' OR b.FullSearchTemplate<>'',1,0) AS IsSearch, IF(b.SubscribeTemplate<>'' OR b.SubscribeCond<>'',1,0) AS IsSubscribe FROM System_Table AS a LEFT JOIN Class AS b ON a.System_Table_ID=b.System_Table_ID WHERE a.System_Table_ID = '".$system_class_id."'", ARRAY_A);

    $this->headerText = constant($system_class["System_Table_Rus_Name"]);
    $this->headerImage = 'i_folder_big.gif';
	if ($system_class["Class_ID"] || $system_class[System_Table_ID]) {
      if ($system_class_id == 3 && nc_deep_in_array('auth', $modules)) {
    	$this->tabs[] = array('id' => 'edit',
        	                  'caption' => CLASS_TAB_EDIT,
            	              'location' => "systemclass.edit($system_class[System_Table_ID])");
	    $this->tabs[] = array('id' => 'customadd',
	                          'caption' => CLASS_TAB_CUSTOM_ADD,
	                          'location' => "systemclass.customadd($system_class[System_Table_ID])");
	    $this->tabs[] = array('id' => 'customedit',
	                          'caption' => CLASS_TAB_CUSTOM_EDIT,
	                          'location' => "systemclass.customedit($system_class[System_Table_ID])");
	    $this->tabs[] = array('id' => 'customsearch',
	                          'caption' => CLASS_TAB_CUSTOM_SEARCH,
	                          'location' => "systemclass.customsearch($system_class[System_Table_ID])");
      }
	  $this->tabs[] = array('id' => 'fields',
	                        'caption' => CONTROL_CLASS_FIELDS,
	                        'location' => "systemclass.fields($system_class[System_Table_ID])");
	}
    $this->activeTab = $active_tab;
    $this->locationHash = "#systemclass.$active_tab($system_class[System_Table_ID])";

    $this->treeMode = 'developer';
    $this->treeSelectedNode = "systemclass-{$system_class[System_Table_ID]}";
  }
}

class ui_config_system_classes extends ui_config {

  function ui_config_system_classes($active_tab = 'systemclass.list') {

    $this->headerText = SECTION_CONTROL_CLASS;
    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
	                 array('id' => 'systemclass.list',
                           'caption' => SECTION_SECTIONS_OPTIONS_SYSTEM,
                           'location' => "systemclass.list")
	          );
    $this->activeTab = $active_tab;

    $this->treeMode = 'developer';
    $this->treeSelectedNode = "systemclass.list";
  }
}

?>
