<?
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require_once ($ADMIN_FOLDER."function.inc.php");
require_once ($ADMIN_FOLDER."admin.inc.php");

$inside_admin = 1;
?>

<html>

<head>
   <meta http-equiv='Content-Type' content='text/html; charset=<?=MAIN_ENCODING; ?>'>
   <title><?=($title?$title:"NetCat ".BEGINHTML_VERSION." $VERSION_ID $SYSTEM_NAME")?></title>
   <link type='text/css' rel='Stylesheet' href='<?=$ADMIN_TEMPLATE?>css/admin.css'>
   <script type='text/javascript' language='Javascript'>
     var NETCAT_PATH = '<?=$SUB_FOLDER.$HTTP_ROOT_PATH?>',
         ADMIN_PATH = '<?=$ADMIN_PATH?>',
         ICON_PATH = '<?=$ADMIN_TEMPLATE?>' + 'img/';
   </script>
   <script type='text/javascript' src='<?=$ADMIN_PATH?>js/lib.js'></script>
   <script type='text/javascript' src='<?=$ADMIN_PATH?>js/forms.js'></script>

<?php
     // MODULE URL DISPATCHERS
     $modules = $db->get_results("SELECT Keyword, Module_Name FROM Module ORDER BY Keyword", ARRAY_A);
//ADMIN_LANGUAGE
     foreach ($modules as $module) {
       if(file_exists($MODULE_FOLDER.$module['Keyword']."/".MAIN_LANG.".lang.php")) {
         require_once($MODULE_FOLDER.$module['Keyword']."/".MAIN_LANG.".lang.php");
       } else {
         require_once($MODULE_FOLDER.$module['Keyword']."/en.lang.php");
       }
     }
     include($ADMIN_FOLDER."modules/module_list.inc.php");
?>

</head>


<body class='admin_form'>
<?

  $favorites = GetFavorites();

  echo "<table border='0' width=100% id='main_page_table'>\n";
  echo "<tr>\n";
  echo "<td width=48%>\n";

  //Welcome
  echo "<div class='main_page_text'>\n";
  echo "\t<div class='block_title'>\n";
  echo "\t\t<img src='".$ADMIN_TEMPLATE."img/i_netcat_big.gif' alt='Netcat'>\n";
  echo "\t\t<span>".SECTION_INDEX_WELCOME."</span>\n";
  echo "\t</div>\n";
  echo "\t<div class='block_text'>\n";
  printf(SECTION_INDEX_WELCOME_MESSAGE, $perm->getLogin(), $PROJECT_NAME, $perm->GetMaxPerm());
  echo "\t</div>\n";
  echo "</div>\n";
  echo "<br style='clear: both'>";
  
  //Favorites
  if ($perm->isAccessSiteMap() || $perm->isGuest() ) {
    echo "<div class='main_page_block'>\n";
    echo "\t<div class='block_title'>\n";
    echo "\t\t<img src='".$ADMIN_TEMPLATE."img/i_favorites_big.gif' alt='".FAVORITE_HEADERTEXT."'>\n";
    echo "\t\t<span>".FAVORITE_HEADERTEXT."</span>\n";
    echo "\t</div>\n";
    if ($favorites) {
      $i = 0;
      foreach ($favorites as $favorite) {
        if ($catalogue != $favorite['Catalogue_ID']) {
          echo "\t<div class='block_title_line'><a href='subdivision/full.php?CatalogueID=".$favorite['Catalogue_ID']."'".(!$favorite['CatalogueChecked']?" class='gray'":"").">".$favorite['Catalogue_Name']."</a></div>\n";
          $catalogue = $favorite['Catalogue_ID'];
          $count++;
        }
        $subclass_id = $db->get_var("SELECT Sub_Class_ID
                                       FROM Sub_Class
                                      WHERE Subdivision_ID = '".$favorite['Subdivision_ID']."'
                                   ORDER BY Priority
                                      LIMIT 1");
  
        echo "\t<div class='".(($i%2)?"block_line":"block_line_gray")."'>\n";
        echo "\t\t<img src='".$ADMIN_TEMPLATE."img/i_folder".(!$favorite['SubChecked']?"_disabled":"").".gif' alt='".$favorite['Subdivision_Name']."'>\n";
        echo "\t\t<span><a href='".($subclass_id?"../?inside_admin=1&cc=$subclass_id":"subdivision/SubClass.php?phase=1&SubdivisionID=".$favorite['Subdivision_ID'])."' title='".$favorite['Subdivision_Name']."'".(!$favorite['SubChecked']?" class='gray'":"").">".$favorite['Subdivision_Name']."</a></span>\n";
        echo "\t\t<div class='block_line_link'><a href='".($subclass_id?"../add.php?inside_admin=1&cc=$subclass_id":"subdivision/SubClass.php?phase=1&SubdivisionID=".$favorite['Subdivision_ID'])."'><img border='0' src='".$ADMIN_TEMPLATE."img/i_".($subclass_id?"obj":"class")."_add".(!$favorite['SubChecked']?"_disabled":"").".gif' alt='".($subclass_id ? CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_ADD : CONTROL_CONTENT_CATALOUGE_FUNCS_A_ADDCLASSTOSECTION)."' title='".($subclass_id ? CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_ADD : CONTROL_CONTENT_CATALOUGE_FUNCS_A_ADDCLASSTOSECTION)."'></a><img border='0' src=".$ADMIN_TEMPLATE."img/px.gif width='16' height='16' style='margin:0px 2px 0px 2px;'><a href='".nc_subdivision_preview_link($favorite)."' target='_blank'><img border='0' src='".$ADMIN_TEMPLATE."img/i_preview.gif' alt='".CONTROL_CONTENT_SUBDIVISION_FUNCS_TOVIEW."' title='".CONTROL_CONTENT_SUBDIVISION_FUNCS_TOVIEW."'></a>".($subclass_id ? "<a href='http://".$EDIT_DOMAIN.$SUB_FOLDER.$HTTP_ROOT_PATH."?inside_admin=1&cc=".$subclass_id.(strlen(session_id()) > 0?"&".session_name()."=".session_id()."":"")."'><img border='0' src='".$ADMIN_TEMPLATE."img/i_folder_edit.gif' alt='".CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_EDIT."' title='".CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_A_EDIT."' style='margin:0px 2px 0px 2px;'></a>" : "<img border='0' src=".$ADMIN_TEMPLATE."img/px.gif width='16' height='16' style='margin:0px 2px 0px 2px;'>")."</div>\n";
        echo "\t</div>\n";
  
        $i++;
      }
    } else {
      echo "\t<div class='block_line_gray'>\n";
      echo "\t\t<span>".CONTROL_CONTENT_SUBDIVISION_FUNCS_NOONEFAVORITES."</span>\n";
      echo "\t</div>\n";
    }
    
    echo "</div>\n";
    echo "<br style='clear: both;'>";
    
 
    echo "<div class='main_page_text main_right'>\n";
    echo "\t<div class='block_text'>\n";
  //  echo "\t\t<img src='skins/default/img/i_sitemap.gif' alt='".SECTION_INDEX_FAVORITE_ANOTHER_SUB."'>";
  //  echo "\t\t<span><a href='#' onclick=\"window.open('/netcat/admin/subdivision/favorites.php?phase=4','LIST','top=50, left=100,directories=no,height=600,location=no,menubar=no,resizable=no,scrollbars=yes,status=yes,toolbar=no,width=400')\">".SECTION_INDEX_FAVORITE_ANOTHER_SUB."</a></span>\n";
    echo "\t\t<div class='block_line_link'><a href='subdivision/favorites.php?phase=1'><img border='0' src='".$ADMIN_TEMPLATE."img/i_settings.gif' alt='".SECTION_INDEX_FAVORITE_SETTINGS."' title='".SECTION_INDEX_FAVORITE_SETTINGS."'>&nbsp;".SECTION_INDEX_FAVORITE_SETTINGS."</a></div>\n";
    echo "\t</div>\n";
    echo "</div>\n";
  }
  
  echo "</td>";
  echo "<td width=20>&nbsp;</td>";
  echo "<td width=48%>";
  if ( $perm->isSupervisor() || $perm->isGuest() ) {
    //System info
    echo "<div class='main_page_text'>\n";
    echo "\t<div class='block_title'>\n";
    echo "\t\t<img src='".$ADMIN_TEMPLATE."img/i_info_big.gif' alt='".SECTION_INDEX_ADMIN_PATCHES_INFO."'>\n";
    echo "\t\t<span>".SECTION_INDEX_ADMIN_PATCHES_INFO."</span>\n";
    echo "\t</div>\n";

    echo "\t<div class='block_text'>\n";
    echo "\t\t".SECTION_INDEX_ADMIN_PATCHES_INFO_VERSION.": <b>".$VERSION_ID."</b><br>";
    if ($LAST_LOCAL_PATCH) echo "\t\t".SECTION_INDEX_ADMIN_PATCHES_INFO_LAST_PATCH."#: <b>".$LAST_LOCAL_PATCH."</b><br>";
    echo "\t\t".SECTION_INDEX_ADMIN_PATCHES_INFO_LAST_PATCH_DATE.": <b>".$PATCH_CHECK_DATE."</b><br><br>";
    echo "\t\t<img src='".$ADMIN_TEMPLATE."img/i_tool_patch.gif' alt='".SECTION_INDEX_ADMIN_PATCHES_INFO_CHECK_PATCH."'>";
    echo "<span><a href='patch/?phase=3'>".SECTION_INDEX_ADMIN_PATCHES_INFO_CHECK_PATCH."</a></span>";
    echo "\t</div>\n";

    echo "</div>\n";
  }
  echo "<br style='clear: both'>";

  if ( $perm->isSupervisor() || $perm->isGuest() ) {
  //Modules
  echo "<div class='main_page_block'>\n";
  echo "\t<div class='block_title'>\n";
  echo "\t<img src='".$ADMIN_TEMPLATE."img/i_modules_big.gif' alt='".NETCAT_MODULES."'>\n";
  echo "\t<span>".NETCAT_MODULES."</span>\n";
  echo "\t</div>\n";

  $have_modules="";
  if ($modules = $db->get_results("SELECT Module_ID,Module_Name,Keyword FROM Module")) {
    $i = 0;
    foreach ( (array)$modules as $module ) {
      $have_modules[$module->Keyword] = 1;
    
      echo "\t<div class='".(($i%2 == 0)?"block_line_gray":"block_line")."'>\n";
	  $modImg = file_exists($ADMIN_TEMPLATE_FOLDER."img/i_module_".$module->Keyword.".gif") ? "i_module_".$module->Keyword.".gif" : "i_modules.gif";
      echo "\t\t<img src='".$ADMIN_TEMPLATE."img/".$modImg."' alt='".constant($module->Module_Name)."'>\n";
      echo "\t\t<span><a href='".(file_exists($MODULE_FOLDER.$module->Keyword."/admin.php")?"../modules/".$module->Keyword."/admin.php":"modules/index.php?phase=2&module_name=".$module->Keyword)."' title='".constant($module->Module_Name)."'>".constant($module->Module_Name)."</a></span>\n";
      echo "\t\t<div class='block_line_link'><a href='modules/index.php?phase=2&module_name=".$module->Keyword."'><img border='0' src='".$ADMIN_TEMPLATE."img/i_settings.gif' alt='".TOOLS_MODULES_MOD_PREFS."' title='".TOOLS_MODULES_MOD_PREFS."'></a></div>\n";
      echo "\t</div>\n";
    
      $i++;
	  unset($modImg);
    }
  }

  $pre_modules_must_have="\t<div class='block_unordered'><span>".SECTION_INDEX_MODULES_MUSTHAVE."</span></div>";
  foreach ($real_modules as $key => $real_module) {
    if (!$have_modules[$key] && $key!='eshop') {
      $modules_must_have .= "\t<div class='".(($i%2 == 0)?"block_line_gray":"block_line")." unordered'>\n";
      $modules_must_have .= "\t\t<img src='".$ADMIN_TEMPLATE."img/i_module_".$key."_gray.gif' alt='".$real_module."'>\n";
      $modules_must_have .= "\t\t<span>".$real_module."</span>\n";
      $modules_must_have .= "\t\t<div class='block_line_link'><a href='http://netcat.ru/dealers/buynow/' target='_blank'>".SECTION_INDEX_MODULES_BUY."</a></div>\n";
      $modules_must_have .= "\t</div>\n";
    
      $i++;
    }
  }
  if ($modules_must_have) echo $pre_modules_must_have.$modules_must_have;

  echo "</div>\n";

  }

  echo "</td>";
  echo "</tr>";
  echo "</table>"; 
  
  $treeMode  ='users';
  if ($perm->isAccessDevelopment() ) {
    $treeMode ='developer';  
  }
  if ( $perm->isAccessSiteMap() || $perm->isGuest() ) {
    $treeMode ='sitemap';
  }
  

  $UI_CONFIG = new ui_config(array(
                              'headerText' => SECTION_INDEX_TITLE,
                              'headerImage' => 'i_netcat_big.gif',
                              'tabs' => array(array('id'=>'welcame', 'caption'=>SECTION_INDEX_TITLE)),
                              'activeTab' => 'welcame',

                              'treeMode' => $treeMode,
                              'locationHash' => "index",
                           ));
    global $UI_CONFIG;
    if (is_object($UI_CONFIG) && method_exists($UI_CONFIG, 'to_json')) { print $UI_CONFIG->to_json(); }
?>
</body>
</html>