<?php
/* $Id: ui.php 2242 2008-09-19 11:00:34Z denis $ */

/**
  *      UI  
  */
class ui_config_module extends ui_config {

  function ui_config_module($module_keyword, $active_tab = 'admin') {
    global $db;
    global $MODULE_FOLDER, $ADMIN_TEMPLATE_FOLDER;
    
    $module_data = $db->get_row("SELECT * FROM `Module` WHERE `Keyword` = '".$db->escape($module_keyword)."'", ARRAY_A);

    //    
    $this->headerText = constant($module_data['Module_Name']);
    $this->headerImage = (
      file_exists($ADMIN_TEMPLATE_FOLDER."img/i_module_".$module_data['Keyword']."_big.gif")
      ? "i_module_".$module_data['Keyword']."_big.gif"
      : "i_modules_big.gif"
    );

    if ( file_exists($MODULE_FOLDER.$module_data['Keyword']."/admin.php") ) {
      $this->tabs[] = array(
        'id' => 'admin',
        'caption'=>constant($module_data['Module_Name']),
        'location' => "module.".$module_data['Keyword']
      );
    }

    $this->tabs[] = array(
      'id' => 'settings',
      'caption' => TOOLS_MODULES_MOD_PREFS,
      'location' => "module.settings(".$module_data['Keyword'].")"
    );
    
    $this->activeTab = $active_tab;
    
    switch ($active_tab) {
      case 'admin':
        $this->locationHash = "module.".$module_data['Keyword'];
      break;
      case 'settings':
        $this->locationHash = "module.settings(".$module_data['Keyword'].")";
      break;
    }
    
    $this->treeMode = "modules";
    $this->treeSelectedNode = "module-".$module_data[Module_ID];
  }
  
}

?>