<?php
/* $Id: sub_class.inc.php 2317 2008-10-08 14:32:42Z vadim $ */

function GetSubClassName ($SubClassID) {
  global $db;

  $result = $db->get_var("SELECT `Sub_Class_Name` FROM `Sub_Class` WHERE `Sub_Class_ID` = '".(int)$SubClassID."'");

  return $result;
}


function GetSubdivisionBySubClass ($SubClassID) {
  global $db;

  $result = $db->get_var("SELECT `Subdivision_ID` FROM `Sub_Class` WHERE `Sub_Class_ID` = '".(int)$SubClassID."'");

  return $result;
}


function GetClassIDBySubClass ($SubClassID) {
  global $db;

  $result = $db->get_var("SELECT `Class_ID` FROM `Sub_Class` WHERE `Sub_Class_ID` = '".(int)$SubClassID."'");

  return $result;
}


/**
 * Delete all objects from SubClass
 *
 * @param int SubClassID
 */
function SubClassClear ($SubClassID) {
  global $db, $MODULE_FOLDER;
   // full info about this subclass
  $res = $db->get_row("SELECT `Catalogue_ID`, `Subdivision_ID`, `Class_ID` FROM `Sub_Class` WHERE `Sub_Class_ID` = '".$SubClassID."'", ARRAY_A);
  
  if ( nc_module_check_by_keyword("comments") ) {
    include_once ($MODULE_FOLDER."comments/function.inc.php");
    // delete comment rules
    nc_comments::dropRuleSubClass($db, $SubClassID);
    // delete comments
    nc_comments::dropComments($db, $SubClassID, "Sub_Class");
  }
  
  if ( nc_module_check_by_keyword("cache") ) {
    include_once ($MODULE_FOLDER."cache/function.inc.php");
    // init listener
    $nc_cache_listener = nc_cache_listener::getObject();
    // delete cache
    $nc_cache_listener->event("dropSubClass", $res['Catalogue_ID'], $res['Subdivision_ID'], $SubClassID);
    $nc_cache_listener->event("dropClass", $res['Class_ID']);
  }
  
  DeleteSubClassFiles($SubClassID, $res['Class_ID']);
  
  // delete from message
  $db->query("DELETE FROM `Message".$res['Class_ID']."` WHERE `Subdivision_ID` = '".$res['Subdivision_ID']."' AND `Sub_Class_ID` = '".$SubClassID."'");
  //$DeleteSubscriber = "DELETE FROM `Subscriber` WHERE `Sub_Class_ID` = '".$val."'";
  
  return;  
}



function DeleteSubClass ($SubClassID) {
  global $db;

  SubClassClear($SubClassID);
  $db->query("DELETE FROM `Sub_Class` WHERE `Sub_Class_ID` = '".$SubClassID."'");

  return;
}

function IsAllowedSubClassEnglishName ($EnglishName, $SubdivisionID, $SubClassID) {
  global $db;

  $select = "SELECT `EnglishName` FROM `Sub_Class` WHERE ";
  $select.= "`EnglishName` = '".$EnglishName."'";
  $select.= " AND `Subdivision_ID` = '".$SubdivisionID."'";
  $select.= " AND `Sub_Class_ID` <> '".$SubClassID."'";

  $Result = $db->query ($select);
  if ($db->num_rows==0)  return 1;

  return 0;
}

?>