<?php

/* $Id: drag_manager_message.php 2336 2008-10-25 15:19:07Z denis $ */
/**
  *  D&D
  *  - message to message (   ** ,
  *         -  Priority)
  */

ob_start("ob_gzhandler");

define("NC_ADMIN_ASK_PASSWORD", false);

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");

$dragged_id = (int)$dragged_id; if (!$dragged_id) die("0 /* Wrong parameters */");
$target_id =  (int)$target_id;  if (!$target_id)  die("0 /* Wrong parameters */");

// CHANGE MESSAGE PRIORITY
if ($dragged_type=='message' && $target_type=='message') {

  $dragged_class = (int)$dragged_class;
  $target_class = (int)$target_class;

  if (!$dragged_class) { die("0 /* No class */"); }
  if ($dragged_class != $target_class) {
    die("0 /* Dragged ($dragged_class) and target ($target_class) classes do not match */");
  }

  $dragged = $db->get_row("SELECT Subdivision_ID, Sub_Class_ID, Priority, Parent_Message_ID FROM Message{$dragged_class} WHERE Message_ID=$dragged_id", ARRAY_A);
  $target  = $db->get_row("SELECT Subdivision_ID, Sub_Class_ID, Priority, Parent_Message_ID FROM Message{$target_class}  WHERE Message_ID=$target_id", ARRAY_A);

  if (!$dragged || !$target) { die("0 /* Object not exists */"); }

  if ($dragged['Sub_Class_ID'] != $target['Sub_Class_ID']) {
    die("0 /* Message drop on message from another subclass is not supported */");
  }

  if ($dragged['Parent_Message_ID'] != $target['Parent_Message_ID']) {
    die("0 /* Message drop on message with distinct Parent_Message_ID is not supported */");
  }

  require_once($INCLUDE_FOLDER . "s_loadenv.inc.php");
  $cc_env = InheritSubClassEnv($target["Sub_Class_ID"]);
  if ($cc_env['SortBy']) { die("0 /* Subclass is not sorted by default */"); }

  if ( !$perm->isSubClassAdmin($target['Sub_Class_ID']) ) {
    die("0 /* No rights */");
  }

  // ,     - Priority DESC

  $direction = ($target['Priority'] < $dragged['Priority']) ? 'down' : 'up';

//  print "/* target $target[Priority], dragged $dragged[Priority], dir $direction */\n";

  if ($direction == 'up') {
    // Close gap at the position of the dragged object
    // and make space at the new position
    $db->query("UPDATE Message{$dragged_class}
                   SET Created=Created,
                       Priority=Priority-1
                 WHERE Sub_Class_ID = $dragged[Sub_Class_ID]
                   AND Priority BETWEEN $dragged[Priority] AND ($target[Priority]-1)");

    // Change dragged object's priority
    $db->query("UPDATE Message{$dragged_class}
                   SET Created=Created,
                       Priority=($target[Priority]-1)
                 WHERE Message_ID = $dragged_id");
  }
  elseif ($direction = 'down') {
    // Close gap at the position of the dragged object
    // and make space at the new position
    $db->query("UPDATE Message{$dragged_class}
                   SET Created=Created,
                       Priority=Priority+1
                 WHERE Sub_Class_ID = $dragged[Sub_Class_ID]
                   AND Priority BETWEEN $target[Priority] AND ($dragged[Priority]-1)");

    // Change dragged object's priority
    $db->query("UPDATE Message{$dragged_class}
                   SET Created=Created,
                       Priority=$target[Priority]
                 WHERE Message_ID = $dragged_id");
  }

  die("1 /* OK */");
}

// message to subclass
if ($dragged_type=='message' && $target_type=='subclass') {
  $dragged_class = (int)$dragged_class;
  if (!$dragged_class) { die("0 /* Wrong message class */"); }

  $subclass = $db->get_row("SELECT Sub_Class_ID, Subdivision_ID, Class_ID FROM Sub_Class WHERE Sub_Class_ID=$target_id", ARRAY_A);
  $message  = $db->get_row("SELECT Subdivision_ID, Sub_Class_ID FROM Message{$dragged_class} WHERE Message_ID=$dragged_id", ARRAY_A);

  if (!$subclass || $subclass['Class_ID'] != $dragged_class) {
    die("0 /* Can't move message between distinct classes or subclass [$target_id] doesn't exist */");
  }

  $res = nc_move_message($dragged_class, $dragged_id, $target_id);
  if (!$res) {
    die("0 /* Error while moving message */");
  }

  die("1 /* OK */");
}

die("0 /* Wrong request ['$dragged_type $dragged_id' $position '$target_type $target_id'] */");

?>