<?php
/* $Id: index.php 2383 2008-11-13 16:16:50Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");
require($ADMIN_FOLDER."catalogue/function.inc.php");
require($ADMIN_FOLDER."subdivision/subclass.inc.php");
require($INCLUDE_FOLDER."s_files.inc.php");
require($INCLUDE_FOLDER."s_common.inc.php");
require($ADMIN_FOLDER."subdivision/function.inc.php");

$Delimeter = " &gt ";
$main_section = "control";
$item_id = 1;
$Title1 = "<a href=\"".$ADMIN_PATH."catalogue/\">".CONTROL_CONTENT_SUBDIVISION_INDEX_SITES."</a>";
$Title2 = CONTROL_CONTENT_SUBDIVISION_INDEX_SECTIONS;

$Title3 = "<a href=\"".$ADMIN_PATH."subdivision/?";
if ( isset($CatalogueID) && $CatalogueID ) {
  $Title3 .= "CatalogueID=".$CatalogueID;
}
else {
  $Title3 .= "ParentSubID=".$ParentSubID;
}
$Title3 .= "\">".CONTROL_CONTENT_SUBDIVISION_INDEX_SITES."</a>";

$Title4 = CONTROL_CONTENT_SUBDIVISION_INDEX_ADDSECTION;
$SubdivisionName = GetSubdivisionNameByID ($SubdivisionID);
$Title5 = $SubdivisionName;
$Title8 = CONTROL_CONTENT_SUBDIVISION_INDEX_OPTIONSECTION;
$Title9 = CONTROL_CONTENT_SUBDIVISION_INDEX_DELETECONFIRMATION;
$Title10 = CONTROL_CONTENT_SUBDIVISION_INDEX_MOVESECTION;
$Title11 = CONTROL_CONTENT_SUBDIVISION_INDEX_SECTIONS;

$CatalogueURL = $ADMIN_PATH."catalogue/?phase=6&CatalogueID=";
$SubdivisionURL = $ADMIN_PATH."subdivision/?phase=4&SubdivisionID=";

$sh = new SubdivisionHierarchy ($Delimeter, $CatalogueURL, $SubdivisionURL);
$loc = new SubdivisionLocation ($CatalogueID, $ParentSubID, $SubdivisionID);

// default phase
if ( !isset($phase) ) $phase=1;

switch ($phase) {
  //   
  case 1:
    BeginHtml ($Title2, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title11, "http://".$DOC_DOMAIN."/management/sites/sections/");
    if ($CatalogueID) {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_INFO, $CatalogueID, 0, 0);
      $UI_CONFIG = new ui_config_catalogue('info', $CatalogueID, 'sublist', $loc->ParentSubID);
    }
    else {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_LIST, $ParentSubID, 0, 0);
      $UI_CONFIG = new ui_config_subdivision_info($ParentSubID, 'sublist');
    }
    ShowSubdivisionList ();
      break;
  
  //   
  case 2:
    BeginHtml($Title4, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title4, "http://".$DOC_DOMAIN."/management/sites/sections/add/");
    if ($ParentSubID)  {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_ADD, $ParentSubID, 0, 0);
    }
    else {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_ADDSUB, $CatalogueID, 0, 0);
    }
    SubdivisionForm(3, "index.php", 1, $full);
  break;
  
  //  
  case 3:
    BeginHtml($Title2, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title11, "http://".$DOC_DOMAIN."/management/sites/sections/");
    if ($ParentSubID) {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_ADD, $ParentSubID, 0, 1 );
    }
    else {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_ADDSUB, $CatalogueID, 0, 1);
    }
  
    //  
    if ($posting == 1) {
      //   
      if (!$Subdivision_Name) {
        nc_print_status(CONTROL_CONTENT_SUBDIVISION_INDEX_ERROR_THREE_NAME, 'error');
        SubdivisionForm (3, "index.php", 1, $full);
        break;
      }

      //       
      if ( !IsAllowedSubdivisionEnglishName ($EnglishName, $loc->ParentSubID, 0, $loc->CatalogueID) ) {
        nc_print_status(CONTROL_CONTENT_SUBDIVISION_INDEX_ERROR_THREE_KEYWORD, 'error');
        SubdivisionForm (3, "index.php", 1, $full);
        break;
      }

      //     
      if ( !preg_match("/^[a-z0-9-]+$/is", $EnglishName) ) {
        nc_print_status(CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD_INVALID, 'error');
        SubdivisionForm (3, "index.php", 1, $full);
        break;
      }

      //       
      if ($SubdivisionID = ActionSubdivisionCompleted ($type)) {
        if ($ClassID) {
          $settings_array = $db->get_var("SELECT CustomSettingsTemplate FROM Class WHERE Class_ID = $ClassID");
          if ($settings_array) {
            require_once($GLOBALS['ADMIN_FOLDER'] . "array_to_form.inc.php");
            $a2f = new nc_a2f($settings_array, $CustomSettings, 'CustomSettings');
            if ($a2f->has_errors()) {
              $error = $a2f->get_validation_errors();
            }
            $CustomSettings = $a2f->get_values_as_string();
          } else {
            $CustomSettings = "";
          }

          $insert = "INSERT INTO Sub_Class (Subdivision_ID, Catalogue_ID, Class_ID, Sub_Class_Name, Checked, EnglishName, AllowTags, NL2BR, Created, DefaultAction, UseCaptcha, CustomSettings) VALUES ($SubdivisionID, $CatalogueID, $ClassID, '".$Subdivision_Name."', 1, '".$EnglishName."', -1, -1, '".date("Y-m-d H:i:s")."', 'index', -1, '".addcslashes($CustomSettings, "'")."')";
          $db->query ($insert);
        }
          
        ob_end_clean();
        //     ,   
        // ( ),   
        //     sub-$SubdivisionID
        if ($ClassID) {
          header("Location: ".$ADMIN_PATH."subdivision/SubClass.php?SubdivisionID=".$SubdivisionID);
        }
        else {
          header("Location: ".$ADMIN_PATH."subdivision/SubClass.php?phase=1&SubdivisionID=".$SubdivisionID);
        }
        exit();
      }
    }

  break;
  
  //     
  case 4:
    BeginHtml ($Title5, $Title1.$Delimeter.$sh->Link, "http://".$DOC_DOMAIN."/management/sites/sections/info/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_INFO, $SubdivisionID, 0, 0);
    $UI_CONFIG = new ui_config_subdivision_info($SubdivisionID, 'info');
    ShowSubdivisionMenu ($SubdivisionID, 9, "index.php", 5, "index.php", 12, "index.php");
  break;
  
  //   
  case 5:
    BeginHtml($Title8, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title8, "http://".$DOC_DOMAIN."/management/sites/sections/settings/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_EDIT, $SubdivisionID, 0, 0);
    SubdivisionForm(6, "index.php", 2, $full);
  break;
  
  //  
  case 6:
    BeginHtml($Title2, $Title1.$Delimeter.$sh->Link, "http://".$DOC_DOMAIN."/management/sites/sections/info/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_EDIT, $SubdivisionID, 0, 1);

    if ($posting == 1) {
      //   
      if (!$Subdivision_Name) {
          $posting = 0;
          nc_print_status(CONTROL_CONTENT_SUBDIVISION_INDEX_ERROR_THREE_NAME, 'error');
          SubdivisionForm (6, "index.php", 2, $full);
          break;
      }

      //       
      if ( !IsAllowedSubdivisionEnglishName ($EnglishName, $loc->ParentSubID, $loc->SubdivisionID, $loc->CatalogueID) ) {
          $posting = 0;
          nc_print_status(CONTROL_CONTENT_SUBDIVISION_INDEX_ERROR_THREE_KEYWORD, 'error');
          SubdivisionForm (6, "index.php", 2, $full);
          break;
      }

      //      (            )
      if ( strspn(strtolower($EnglishName), "abcdefghijklmnopqrstuvwxyz0123456789-") != strlen($EnglishName) ) {
          $posting = 0;
          nc_print_status(CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD_INVALID, 'error');
          SubdivisionForm (6, "index.php", 2, $full);
          break;
      }

      //            
      if (ActionSubdivisionCompleted ($type)) {
        nc_print_status(CONTROL_CONTENT_SUBDIVISION_SUCCESS_EDIT, 'ok');
        SubdivisionForm (6, "index.php", 2, $full);
        break;
      }
    }
   

  break;

  // ,     
  case 7:
    foreach($_GET as $key => $val) {
      if (substr($key,0,6)=="Delete") $sub_id = substr($key,6,strlen($key)-6)+0;
    }
    if(!$ParentSubID && !$CatalogueID) list($CatalogueID, $ParentSubID) = $db->get_row("SELECT Catalogue_ID, Parent_Sub_ID FROM Subdivision WHERE Subdivision_ID = '".$sub_id."'", ARRAY_N);
 
    if (CheckIfDelete()) {
      BeginHtml ($Title9, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title9, "http://".$DOC_DOMAIN."/management/sites/sections/");
      if ($ParentSubID) {
        $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_DEL, $ParentSubID, 0, 1);
      }
      else {
        $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_DELSUB, $CatalogueID, 0, 1);
      }
      UpdateSubdivisionPriority (); 
      $UI_CONFIG = new ui_config_subdivision_delete($sub_id); 
      AscIfDeleteSubdivision (11, "index.php");
    }
    else {
      BeginHtml ($Title2, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title11, "http://".$DOC_DOMAIN."/management/sites/sections/");
      if ($ParentSubID) {  
        $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_DEL, $ParentSubID, 0, 1); 
        $UI_CONFIG = new ui_config_subdivision_info($ParentSubID, 'sublist'); 
      }
      else {
        $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_DELSUB, $CatalogueID, 0, 1);
        $UI_CONFIG = new ui_config_catalogue('info', $CatalogueID, 'sublist', $loc->ParentSubID);
      }
   
      UpdateSubdivisionPriority ();
      ShowSubdivisionList ();
    }
  break;
  
  //  [  ] 
  case 11:
    BeginHtml ($Title2, $Title1.$Delimeter.$sh->Link.$Delimeter.$Title11, "http://".$DOC_DOMAIN."/admin/catalogue/sections/");
    if ($ParentSubID) {  
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_DEL, $ParentSubID, 0, 1); 
      $UI_CONFIG = new ui_config_subdivision_info($ParentSubID, 'sublist');
    }
    else {
      $perm->ExitIfNotAccess(NC_PERM_ITEM_SITE, NC_PERM_ACTION_DELSUB, $CatalogueID, 0, 1);
      $UI_CONFIG = new ui_config_catalogue('map', $CatalogueID);
    }
    DeleteSubdivision ();
    ShowSubdivisionList ();
  break;
  
  case 13:
    // 2.4 -       
  break;
  
  case 14: //
    if ($SubClassID || $SubdivisionID) {
      if ($SubdivisionID) {
        $link = $db->get_var("SELECT Hidden_URL AS link FROM Subdivision WHERE Subdivision_ID = '".$SubdivisionID."'");
        $SubClassID = 0;
      }
      if ($SubClassID) {
        $link = $db->get_var("SELECT CONCAT(sub.Hidden_URL, cc.EnglishName, '.html') AS link FROM Subdivision AS sub LEFT JOIN Sub_Class AS cc ON sub.Subdivision_ID = cc.Subdivision_ID WHERE cc.Sub_Class_ID = '".$SubClassID."'");
        $SubdivisionID = 0;
      }
      $catalogue = $db->get_var("SELECT catalogue.Domain FROM Catalogue as catalogue LEFT JOIN Sub_Class as cc ON cc.Catalogue_ID = catalogue.Catalogue_ID WHERE cc.Sub_Class_ID = '".$SubClassID."' LIMIT 1");
      $href = "http://".($catalogue?(strchr($catalogue,".")?$catalogue:$catalogue.".".$DOMAIN_NAME):$DOMAIN_NAME).$SUB_FOLDER.$link;
      $UI_CONFIG = new ui_config_subdivision_preview($SubdivisionID,$SubClassID);
      $UI_CONFIG->actionButtons[] = array(
        "id" => "preview",
        "caption" => SUBDIVISION_TAB_PREVIEW_BUTTON_PREVIEW,
        "action" => "urlDispatcher.load('$href', '1')"
      );
      print "<script>window.onload = function(){ window.location.href='$href'; }</script>";
    }
  break;
  
  case 15: //    
    BeginHtml ($Title5, $Title1.$Delimeter.$sh->Link, "http://".$DOC_DOMAIN."/management/sites/sections/info/");
    $perm->ExitIfNotAccess(NC_PERM_ITEM_SUB, NC_PERM_ACTION_INFO, $SubdivisionID, 0, 0);
    $UI_CONFIG = new ui_config_subdivision_info($SubdivisionID, 'userlist');
    nc_show_subdivision_rights($SubdivisionID);
  break;

}

EndHtml ();
?>