<?php
/* $Id: full.php 2421 2008-11-24 17:07:14Z vadim $ */

#     

$action = "full";

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -2 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require ($INCLUDE_FOLDER."index.php");

$instance = $user_table_mode ? "user_table_env" : "current_cc";

// cache section
if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1) {
  try {
    $nc_cache_full = nc_cache_full::getObject();
    // check cached data
    $cached_result = $nc_cache_full->read($classID, $message, $REQUEST_URI, $current_cc['Cache_Lifetime']);
    if ($cached_result!=-1) {
      // get cached parameters
      list ($cached_data, $cached_eval) = $cached_result;
      // debug info
      $cache_debug_info = "Readed, sub[".$sub."], cc[".$cc."], Access_ID[".$current_cc['Cache_Access_ID']."], Lifetime[".$current_cc['Cache_Lifetime']."], bytes[".strlen($cached_data)."], eval[".(int)$cached_eval."]";
      $nc_cache_full->debugMessage($cache_debug_info, __FILE__, __LINE__);
      // return cache if cache data without "nocache" blocks
      if (!$cached_eval) {
        // template header
        eval ("echo \"".$template_header."\";");
        // echo simple html cached data
        echo $cached_data;
        // template footer
        eval ("echo \"".$template_footer."\";");
        exit;
      }
    }
    // set marks into the fields
    $nc_cache_full->nocacheStore( ${$instance} );
  }
  catch (Exception $e) {
    // for debug
    $nc_cache_full->errorMessage($e);
  }
}

// component custom settings
$cc_settings = array();
if ($current_cc['CustomSettingsTemplate']) {
  require_once($GLOBALS['ADMIN_FOLDER'] . "array_to_form.inc.php");
  $a2f = new nc_a2f($current_cc['CustomSettingsTemplate'], $current_cc['CustomSettings'], 'CustomSettings');
  $cc_settings = $a2f->get_values_as_array();
}

$ignore_user = true;

$message_level_count = 0;
$parent_message_tree[$message_level_count] = $message;

if (!$user_table_mode) {
  while ($parent_message_tree[$message_level_count]) {
    $parent_mess_res = $db->get_var("SELECT `Parent_Message_ID` FROM `Message".$classID."` WHERE `Message_ID` = '".(int)$parent_message_tree[$message_level_count]."'");
    if ($db->num_rows) {
      $message_level_count++;
      $parent_message_tree[$message_level_count] = $parent_mess_res;
    }
  }
}

// class settings execute
if (${$instance}["Settings"]) eval (${$instance}["Settings"]);

// cache eval section
if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1 && is_object($nc_cache_full) && $cached_eval && $cached_result!=-1) {
  // template header
  eval ("echo \"".$template_header."\";");
  // eval cached data
  eval("echo \"".$cached_data."\";");
  // template footer
  eval ("echo \"".$template_footer."\";");
  exit;
}

$res = $db->get_results("SELECT
  `Field_ID`,
  `Field_Name`,
  `TypeOfData_ID`,
  `Format`
  ".(!$user_table_mode ? ', `DoSearch`' : ', 1 AS DoSearch').",
  `Description`
	FROM `Field`
	WHERE ".($user_table_mode ? "`System_Table_ID` = '".$systemTableID."'" : "`Class_ID` = '".$classID."'")."
	ORDER BY `Priority`", ARRAY_A);

$field_count = $db->num_rows;
$field_names = "";
$field_vars = "";
$convert2txt = "";
$i = 0;
$eval_to_array =""; // for multilist
$use_multilist = false;

foreach ($res AS $field_array) {

  $field_name_query = "";
  $field_var = "";

  $field_name[$i] = $field_array["Field_Name"];
  $field_search[$i] = $field_array["DoSearch"];
  $field_type[$i] = $field_array["TypeOfData_ID"];
	$field_format[$i] = $field_array['Format'];
	$field_descript[$i] = $field_array['Description'];

  switch ($field_type[$i]) {
    // list field
    case 4:
      $joins .= " LEFT JOIN `Classificator_".$field_array["Format"]."` AS tbl".$field_array["Field_ID"]." ON a.`".$field_array["Field_Name"]."` = tbl".$field_array["Field_ID"].".".$field_array["Format"]."_ID ";

      $field_name_query = "tbl".$field_array["Field_ID"].".".$field_array["Format"]."_Name AS tbl".$field_array["Field_ID"]."name";
      $field_name_query .= ", tbl".$field_array["Field_ID"].".".$field_array["Format"]."_ID AS tbl".$field_array["Field_ID"]."id";

      $field_var = "\$f_".$field_array["Field_Name"];
      $field_var .= ", \$f_".$field_array["Field_Name"]."_id";
    break;
    // file field
    case 6:
      $field_name_query = "IF(a.".$field_array["Field_Name"]."<>'',CONCAT('".$HTTP_FILES_PATH.$field_array["Field_ID"]."_',".($user_table_mode?"a.User_ID":"a.Message_ID").",RIGHT(SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',1), LOCATE('.',REVERSE(SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',1))))),'')";
      $field_var = "\$f_".$field_array["Field_Name"];

      $field_name_query .= ", SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',1)";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_name";

      $field_name_query .= ", SUBSTRING_INDEX(SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',-2),':',1)";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_type";

      $field_name_query .= ", SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',-1)";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_size";
    break;
    // date field
    case 8:
      $field_name_query = "a.".$field_array["Field_Name"];
      $field_var = "\$f_".$field_array["Field_Name"];

      $field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%Y')";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_year";
      $field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%m')";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_month";
      $field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%d')";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_day";

      $field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%H')";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_hours";
      $field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%i')";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_minutes";
      $field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%s')";
      $field_var .= ", \$f_".$field_array["Field_Name"]."_seconds";

      if ($field_array["Format"]=="event" || $field_array["Format"]=="event_date") $date_field = $field_array["Field_Name"];
    break;
    // MultiList
    case 10:
      $field_array["Format"] = strtok($field_array["Format"], ':');
      
		  $joins .= " LEFT JOIN `Classificator_".$field_array["Format"]."` AS tbl".$field_array["Field_ID"]."  ON a.`".$field_array["Field_Name"]."` LIKE  CONCAT('%,' , tbl".$field_array["Field_ID"].".".$field_array["Format"]."_ID,  ',%') ";   
		 
		  $field_name_query = "GROUP_CONCAT( DISTINCT tbl".$field_array["Field_ID"].".".$field_array["Format"]."_Name ) AS tbl".$field_array["Field_ID"]."name";
		  $field_name_query .= ", GROUP_CONCAT(DISTINCT tbl".$field_array["Field_ID"].".".$field_array["Format"]."_ID ) AS tbl".$field_array["Field_ID"]."id";
		  
		  $field_var = "\$f_".$field_array["Field_Name"]; 
	    $field_var .= ", \$f_".$field_array["Field_Name"]."_id";
	    
	    #convert $f_pole to arrat $f_pole.  Explode return $f_pole[0] = "" if $f_pole = "" -> in this case - unset
      $eval_to_array .= "\$f_".$field_array['Field_Name']." = explode(',' , \$f_".$field_array['Field_Name']." );  if(!\$f_".$field_array['Field_Name']."[0]) unset(\$f_".$field_array['Field_Name']."[0]); ";
      $eval_to_array .= "\$f_".$field_array['Field_Name']."_id = explode(',' , \$f_".$field_array['Field_Name']."_id );  if(!\$f_".$field_array['Field_Name']."_id[0]) unset(\$f_".$field_array['Field_Name']."_id[0]); ";
      
      $use_multilist = true;
     
      break;	
    default:
      $field_name_query = "a.".$field_array["Field_Name"];
      $field_var = "\$f_".$field_array["Field_Name"];
    break;
  }
  
  if ($field_name_query && $field_var) {
    $field_names .= $field_name_query.",";
    $field_vars .= $field_var.",";
  }
  
  if (!${$instance}["AllowTags"] && ($field_type[$i]==3 || $field_type[$i]==1)) $convert2txt .= "\$f_".$field_name[$i]." = htmlspecialchars(\$f_".$field_name[$i].");";
  if (${$instance}["NL2BR"] && ($field_type[$i]==3 || $field_type[$i]==1)) $convert2txt .= "\$f_".$field_name[$i]." = nl2br(\$f_".$field_name[$i].");";
  $i++;
}

if (!$ignore_user) $cond_user = " AND a.`User_ID` = '".(int)$AUTH_USER_ID."'";
if (!$admin_mode && !$ignore_check)	$cond_mod = " AND a.`Checked` = 1";
if ($date) $cond_date = " AND a.`".$date_field."` LIKE '".$date."%'";

// query select
if ($query_select && $result_vars) {
  $cond_select = ", ".$query_select;
}
// query join
if ($query_join) $cond_join = $query_join;
// query from
if ($query_from) $cond_from = ",".$query_from;
// ignore section
if (!$ignore_sub && !$user_table_mode) $cond_where .= " AND a.`Subdivision_ID` = '".(int)$sub."'";
if (!$ignore_cc && !$user_table_mode) $cond_where .= " AND a.`Sub_Class_ID` = '".(int)$cc."'";
// query_where
if ($query_where) $cond_where .= " AND ".$query_where;

if (!$user_table_mode) {
  $table_extra = "a.Message_ID, a.User_ID, a.IP, a.UserAgent, a.LastUser_ID, a.LastIP, a.LastUserAgent, a.Priority, a.Keyword, a.Parent_Message_ID";
  $extra_vars = "\$f_RowID, \$f_UserID, \$f_IP, \$f_UserAgent, \$f_LastUserID, \$f_LastIP, \$f_LastUserAgent, \$f_Priority, \$f_Keyword, \$f_Parent_Message_ID, ";
}
else {
  $table_extra = "a.User_ID, a.PermissionGroup_ID";
  $extra_vars = "\$f_RowID, \$f_UserGroup, ";
}

if ( !$user_table_mode && $admin_mode && $AUTHORIZE_BY !== 'User_ID' ){
  $table_extra .= ", uNewAdminInterface.`".$AUTHORIZE_BY."` AS f_newAdminInterface_user_add, uNewAdminInterface2.`".$AUTHORIZE_BY."` AS f_newAdminInterface_user_change ";
  $extra_vars .= " \$f_newAdminInterface_user_add, \$f_newAdminInterface_user_change, ";
}

$table_extra .= ",a.Checked, a.Created, a.LastUpdated+0 AS LastUpdated ".$cond_select;

$message_select = "SELECT ".$field_names.$table_extra."
	FROM (`".($user_table_mode ? "User" : "Message".$classID)."` AS a ".$cond_from.")".$joins." ".$cond_join.
  (!$user_table_mode
    ? " LEFT JOIN `Subdivision` AS 	sub
				ON 	sub.`Subdivision_ID` = a.`Subdivision_ID`
			LEFT JOIN `Sub_Class` AS cc ON cc.`Sub_Class_ID` = a.`Sub_Class_ID`"
    : ""
  );

if ( !$user_table_mode && $admin_mode && $AUTHORIZE_BY !== 'User_ID' ){
	$message_select .= " LEFT JOIN `User` AS uNewAdminInterface ON a.`User_ID` = uNewAdminInterface.`User_ID`
    LEFT JOIN `User` AS uNewAdminInterface2 ON a.`LastUser_ID` = uNewAdminInterface2.`User_ID` ";
}
$message_select .= " WHERE 1=1 ".$cond_where.$cond_user.$cond_mod.$cond_date."
  AND a.`".($user_table_mode ? "User" : "Message")."_ID` = '".(int)$message."'";

if ( $use_multilist ) $message_select.= $user_table_mode ? " GROUP BY a.`User_ID`" : " GROUP BY a.`Message_ID`";

$resMsg = $db->get_row($message_select, ARRAY_N);

if (!$db->num_rows) {
	eval("echo \"".$template_header."\";");
	eval("echo \"".$template_footer."\";");
	exit;
}

$fetch_row = "list(".$field_vars.$extra_vars."\$f_Checked, \$f_Created, \$f_LastUpdated".($result_vars?",".$result_vars:"").") = \$resMsg;";
eval ($fetch_row);

eval ($convert2txt);

if ($eval_to_array) eval($eval_to_array); #Convert value to array (for Multilist)

// 'left join' used to provide compatibility with old fs ($f_File_url)
$res = $db->get_results("SELECT fd.`Field_Name` AS field, ft.`File_Path` AS path, ft.`Virt_Name` AS name
  FROM `Field` AS fd
  LEFT JOIN `Filetable` AS ft
  ON (fd.`Field_ID` = ft.`Field_ID` AND ft.`Message_ID` = '".(int)$message."')
  WHERE ".($user_table_mode
    ? "fd.`Class_ID` = 0 AND `System_Table_ID` = 3"
    : "fd.`Class_ID` = '".(int)$classID."'")."
  AND fd.`TypeOfData_ID` = 6", ARRAY_A);

foreach ((array)$res AS $row) {
  // file exists
  if ($row['name']) {
    ${"f_".$row['field']} = $SUB_FOLDER.rtrim($HTTP_FILES_PATH, '/').$row['path']."h_".$row['name'];
    ${"f_".$row['field']."_url"} = $SUB_FOLDER.rtrim($HTTP_FILES_PATH, '/').$row['path'].$row['name'];
  }
  else if (${"f_".$row['field']}) {
    // old fs file exists
    ${"f_".$row['field']."_url"} = &${"f_".$row['field']};
  }
}

// date values
$f_Created_year = substr($f_Created,0,4);
$f_Created_month = substr($f_Created,5,2);
$f_Created_day = substr($f_Created,8,2);
$f_Created_hours = substr($f_Created,11,2);
$f_Created_minutes = substr($f_Created,14,2);
$f_Created_seconds = substr($f_Created,17,2);

$f_LastUpdated_year = substr($f_LastUpdated,0,4);
$f_LastUpdated_month = substr($f_LastUpdated,4,2);
$f_LastUpdated_day = substr($f_LastUpdated,6,2);
$f_LastUpdated_hours = substr($f_LastUpdated,8,2);
$f_LastUpdated_minutes = substr($f_LastUpdated,10,2);
$f_LastUpdated_seconds = substr($f_LastUpdated,12,2);

if ($date_field) {
  if (!$admin_mode) {
    eval("\$dateLink = \$f_".$date_field."_year.\"/\".\$f_".$date_field."_month.\"/\".\$f_".$date_field."_day.\"/\";");
  }
  else {
    eval("\$dateLink = \$f_".$date_field."_year.\"-\".\$f_".$date_field."_month.\"-\".\$f_".$date_field."_day;");
  }
}

$subLink = $SUB_FOLDER.$current_sub["Hidden_URL"];
$subHost = "http://".($current_cc['Hidden_Host'] ? ( strchr($current_cc['Hidden_Host'], '.') ? $current_cc['Hidden_Host'] : $current_cc['Hidden_Host'].'.'.$DOMAIN_NAME ) : $DOMAIN_NAME);
$cc_keyword = $current_cc['EnglishName'];

// full link section
if ($admin_mode) {
  $fullLink = $admin_url_prefix."full.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID;
  $fullDateLink = $fullLink.$dateLink;
}
else {
  $fullLink = $subLink.($f_Keyword ? $f_Keyword : $cc_keyword."_".$f_RowID).".html";
  $fullDateLink = $subLink.$dateLink.($f_Keyword ? $f_Keyword : $cc_keyword."_".$f_RowID).".html";
}

if ($titleTemplate) eval("\$f_title = \"".$titleTemplate."\";");

$cc_keyword = $current_cc["EnglishName"];
$ccLink = $sub_url.$cc_keyword.".html";
$searchForm = $current_cc["FullSearchTemplate"];
$addForm = $current_cc["AddTemplate"];
$nc_search_form = "<form method='get' action='".$SUB_FOLDER.$current_sub['Hidden_URL']."'>".showSearchForm($field_descript, $field_type, $field_search, $field_format)."<input type='submit' value='".NETCAT_SEARCH_FIND_IT."' /></form>";

if ($admin_mode) {
	// ID   
	$f_AdminButtons_id = $f_RowID;
	//  
	$f_AdminButtons_priority = $f_Priority;
	// ID  
	$f_AdminButtons_user_add = $f_UserID;
	// ID  
	$f_AdminButtons_user_change = ($f_LastUserID ? $f_LastUserID : "");
	//  
	$f_AdminButtons_copy = $ADMIN_PATH."objects/copy_message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&message=".$f_RowID;
	// 
	$f_AdminButtons_change = $SUB_FOLDER.$HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID."&curPos=".$curPos;
	// 
	$f_AdminButtons_delete = $SUB_FOLDER.$HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID."&delete=1&curPos=".$curPos;
	// -
	$f_AdminButtons_check = $any_url_prefix.$SUB_FOLDER.$HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&message=".$f_RowID."&checked=".($f_Checked ? 1 : 2)."&posting=1&curPos=".$curPos.($admin_mode ? "&admin_mode=1" : "");

  $f_AdminButtons = "";
  if (!$user_table_mode) {
    if ($system_env['AdminButtonsType']) {
  		eval("\$f_AdminButtons = \"".$system_env['AdminButtons']."\";");
  	}
  	else {
  		$f_AdminButtons_buttons = "<a href='".$f_AdminButtons_change."'><img src='".$ADMIN_TEMPLATE."img/i_obj_edit.gif' alt='".NETCAT_MODERATION_CHANGE."' title='".NETCAT_MODERATION_CHANGE."'></a>";
      $f_AdminButtons_buttons.= "<a href='".$f_AdminButtons_delete."'><img src='".$ADMIN_TEMPLATE."img/i_obj_delete.gif' alt='".NETCAT_MODERATION_DELETE."' title='".NETCAT_MODERATION_DELETE."'></a>";
      $f_AdminButtons_buttons.= "<a href='#' onclick=\"window.open('".$f_AdminButtons_copy."', 'nc_popup_test1', 'width=800,height=500,menubar=no,resizable=no,scrollbars=no,toolbar=no,resizable=yes'); return false;\"><img src='".$ADMIN_TEMPLATE."img/i_obj_copy.gif' alt='".NETCAT_MODERATION_COPY_OBJECT."' title='".NETCAT_MODERATION_COPY_OBJECT."'></a>";
      $f_AdminButtons_buttons.= "<a href='".$f_AdminButtons_check."'><img src='".$ADMIN_TEMPLATE."img/i_obj_turn".($f_Checked ? 'on' : 'off' ).".gif' ".($f_Checked ? "alt='" . NETCAT_MODERATION_TURNTOOFF."'  title='".NETCAT_MODERATION_TURNTOOFF."'" : "alt='".NETCAT_MODERATION_TURNTOON."' title='".NETCAT_MODERATION_TURNTOON."'")."></a>";
  		$f_AdminButtons.= "<div class='nc_idtab".($f_Checked ? "" : " nc_idtab_disabled")."'>";
      
  		if ( CheckUserRights( $cc, 'moderate', 1 )==1 || ( CheckUserRights( $cc, 'change', 1 )==1 && $f_AdminButtons_user_add==$AUTH_USER_ID ) ) {
  			$f_AdminButtons.= "<div class='nc_idtab_handler' id='message".$classID."-".$f_RowID."_handler'></div>";
  			$f_AdminButtons.= "<div class='nc_idtab_id'>";
  			$f_AdminButtons.= "<div class='nc_idtab_messageid' title='".NETCAT_MODERATION_ID.": ".$f_AdminButtons_id."'>".$f_AdminButtons_id."</div>";
  			$f_AdminButtons.= "<div class='nc_idtab_priority' title='".NETCAT_MODERATION_PRIORITY.": ".$f_AdminButtons_priority."'>".$f_AdminButtons_priority."</div>";
  			$f_AdminButtons.= "<div class='nc_idtab_adduser' title='".NETCAT_MODERATION_ADDEDON.": ".$f_newAdminInterface_user_add."'	>".($f_newAdminInterface_user_add ? $f_newAdminInterface_user_add : $f_AdminButtons_user_add)."</div>";
  			$f_AdminButtons.= ($f_AdminButtons_user_change
          ? "<div class='nc_idtab_edituser' title='".NETCAT_MODERATION_CHANGED.": ".$f_newAdminInterface_user_change."'>".( $f_newAdminInterface_user_change ? $f_newAdminInterface_user_change : $f_AdminButtons_user_change )."</div>"
  				: "");
  			$f_AdminButtons.= "</div>";
  			$f_AdminButtons.= "<div class='nc_idtab_buttons'>".$f_AdminButtons_buttons."</div>";
  			$f_AdminButtons.= "<div class='ncf_row nc_clear'></div>";
  		}
      else {
  			$f_AdminButtons.= "<div class='nc_idtab_handler' id='message".$classID."-".$f_RowID."_handler'></div>";
  			$f_AdminButtons.= "<div class='nc_idtab_id'>";
  			$f_AdminButtons.= "<div class='nc_idtab_messageid error' title='".NETCAT_MODERATION_ERROR_NORIGHT."'>".NETCAT_MODERATION_ERROR_NORIGHT."</div>";
  			$f_AdminButtons.= "</div>";
  			$f_AdminButtons.= "<div class='ncf_row nc_clear'></div>";
  		}
  		$f_AdminButtons.= "</div><div class='ncf_row nc_clear'></div>";
  	}
  }
}


function nc_full_message_parse_buffer ($buffer) {
  global $REQUEST_URI, $classID, $message;
  global $MODULE_VARS, $nc_cache_full, $current_sub, $current_cc;
  
  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1 && is_object($nc_cache_full) ) {
    try {
      $bytes = $nc_cache_full->add($classID, $message, $REQUEST_URI, $buffer);
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, sub[".$current_sub['Subdivision_ID']."], cc[".$current_cc['Sub_Class_ID']."], Access_ID[".$current_cc['Cache_Access_ID']."], Lifetime[".$current_cc['Cache_Lifetime']."], bytes[".$bytes."]";
        $nc_cache_full->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_full->errorMessage($e);
    }
  }
  
  return $buffer;
}


eval ("echo \"".$template_header."\";");

if ( nc_module_check_by_keyword("cache") ) {
  ob_start("nc_full_message_parse_buffer");
  eval("echo \"".${$instance}["RecordTemplateFull"]."\";");
  ob_end_flush();
}
else {
  eval("echo \"".${$instance}["RecordTemplateFull"]."\";");
}

eval("echo \"".$template_footer."\";");

?>