<?
/* $Id: s_auth.inc.php 2363 2008-11-08 14:51:23Z denis $ */

 #   1 - read
 #   2 - add
 #   4 - subscribe
 #   8 - change
 #  16 - moderate

function s_auth ($cc_env,$action,$posting) {
	global $admin_mode, $MODULE_VARS, $AUTHORIZATION_TYPE;
	global $AUTH_USER_ID;

	if ($action=="index" || $action=="full" || $action=="search") $action = "read";

	$cc = $cc_env["Sub_Class_ID"];

	switch ($action) {
		case "add":		$f_access = $cc_env["Write_Access_ID"]; break;
		case "change":		$f_access = $cc_env["Edit_Access_ID"]; break;
		case "subscribe":	$f_access = $cc_env["Subscribe_Access_ID"]; break;
		case "comment":	  $f_access = $cc_env["Comment_Access_ID"]; break;
		case "moderate":  $f_access = 3; //,  ,   ,      . 
		default:		$f_access = $cc_env["Read_Access_ID"]; break;
	}

	switch ($f_access) {

		case 1: { // 
			if ($admin_mode) { 
				if (!Authorize()) return false;
				if (!CheckUserRights($cc,$action,1)) return false;
			}
		} break;

		case 2: {  //  
			if (!Authorize()) return false;
			global $perm;
			if ($perm->isBanned($cc_env, $action)) return false;
		} break;
 
		case 3: {   //  
			if (!Authorize()) return false;
			global $perm;
			if ($perm->isBanned($cc_env, $action)) return false;
			if (!CheckUserRights($cc,$action,$posting)) return false;
		} break;
		


		default: break;

	}

	return true;
}

?>