<?php
/* $Id: s_files.inc.php 2244 2008-09-19 13:28:18Z vadim $ */

function getFileCount($classID,$systemTableID) {
    global $db;

    $count = $db->get_var("SELECT count(*) FROM Field WHERE ".($systemTableID?"System_Table_ID=".$systemTableID:"Class_ID=".$classID)." AND TypeOfData_ID=6");

    return $count;
}

function unhtmlentities ($string) {
    $trans_tbl = get_html_translation_table (HTML_ENTITIES);
    $trans_tbl = array_flip ($trans_tbl);
    return strtr ($string, $trans_tbl);
}

#   
function DeleteFile ($field_id,$field_name,$classID,$systemTableName,$message) {
    global $FILES_FOLDER;
    global $db;

    eval("global \$f_".$field_name."_old;");

    $field = $db->get_var("SELECT ".$field_name." FROM ".($systemTableName?$systemTableName:"Message".$classID)." WHERE ".($systemTableName?$systemTableName:"Message")."_ID='".$message."'");

    list($name,$type,$size) = split(":",$field);
    $ext = substr($name,strrpos($name,"."));
    $fullPathToFile = $FILES_FOLDER.$field_id."_".$message.$ext;

    ##
	# Delete new-type file
	##
    if ($systemTableName == 'User')
    $File_Path = "u/";
    elseif ($systemTableName == 'Template')
    $File_Path = "t/";
    elseif ($systemTableName == 'Catalogue')
    $File_Path = "c/";
    elseif ($systemTableName)
    $File_Path = "{$message}/";
    else
    {
        list($subdivid, $subclassid) = $db->get_row("SELECT Subdivision_ID, Sub_Class_ID FROM Message{$classID} WHERE Message_ID='{$message}'",ARRAY_N);
        $File_Path = "{$subdivid}/$subclassid/";
    }

    $q = $db->get_row("SELECT ID, Virt_Name FROM Filetable WHERE Message_ID = '{$message}' AND Field_ID = '{$field_id}'", ARRAY_N);

    if ($db->num_rows)
    {
        list($fs_id, $fs_virt_name) = $q;

        //kxfs: @unlink($FILES_FOLDER.$File_Path.$fs_virt_name.$ext);
        @unlink($FILES_FOLDER.$File_Path.$fs_virt_name);
        $db->query("DELETE FROM Filetable WHERE ID = '{$fs_id}' LIMIT 1");
    }
   ##
	# End of Delete new-type file
	##

    eval("\$f_".$field_name."_old = \"\";");

    $res = $db->query("UPDATE ".($systemTableName?$systemTableName:"Message".$classID)." SET LastUpdated=LastUpdated,".$field_name."=\"\" WHERE ".($systemTableName?$systemTableName:"Message")."_ID='".$message."'");

    if ($res) @unlink($fullPathToFile);
}

#       ,    
function DeleteMessageFiles ($classID,$message) {
    global $FILES_FOLDER;
    global $db;

    $res = $db->get_results("SELECT a.Field_ID,a.Field_Name,b.System_Table_Name FROM Field AS a LEFT JOIN System_Table AS b ON a.System_Table_ID=b.System_Table_ID WHERE a.Class_ID='$classID' AND a.TypeOfData_ID=6",ARRAY_N);
    if (!$db->num_rows) return;

    foreach ($res as $field) {
        list($field_id,$field_name,$systenTableName) = $field;
        DeleteFile ($field_id,$field_name,$classID,$systemTableName,$message);
    }
}

function DeleteSystemTableFiles($table, $message_id)
{
   global $db;

   $systables = array('Catalogue'=>1, 'Subdivision'=>2, 'User'=>3, 'Template'=>4);
   if (!in_array($table, array_keys($systables)))
   {
      trigger_error("Wrong parameter \$table for DeleteSystemTableMessageFiles() [$table]", E_USER_WARNING);
      return;
   }

   $res = $db->get_results("SELECT Field_ID, Field_Name
                              FROM Field
                             WHERE Class_ID=0
                               AND System_Table_ID='$systables[$table]'
                               AND TypeOfData_ID=6",ARRAY_N);

   if (!$count=$db->num_rows) return;

   foreach ($res as $field)
   {
       list($field_id,$field_name) = $field;
       DeleteFile ($field_id, $field_name, 0, $table, $message_id);
   }
}

/**
 *       $cc
 * @param int $cc    
 * @return bool
 */

function DeleteSubClassDir($cc) {
	global $db;
	global $FILES_FOLDER;

	$dir_path = $db->get_row("SELECT Subdivision_ID, Sub_Class_ID FROM Sub_Class WHERE Sub_Class_ID = '".$cc."'", ARRAY_A);
	if ($dir_path['Subdivision_ID'] && is_dir($FILES_FOLDER.$dir_path['Subdivision_ID']."/".$dir_path['Sub_Class_ID'])) {
		$files = array();
		$dh  = opendir($FILES_FOLDER.$dir_path['Subdivision_ID']."/".$dir_path['Sub_Class_ID']);
		while (false !== ($filename = readdir($dh))) {
			if ($filename != '.' && $filename != '..')$files[] = $filename;
		}
		closedir($dh);
		if ( count($files)==0 && is_writable($FILES_FOLDER.$dir_path['Subdivision_ID']."/".$dir_path['Sub_Class_ID']."/") ) {
			rmdir($FILES_FOLDER.$dir_path['Subdivision_ID']."/".$dir_path['Sub_Class_ID']."/");
		}
	}
}

/**
 *      $sub
 * @param int $sub  
 * @return bool
 */

function DeleteSubdivisionDir($sub) {
	global $db;
	global $FILES_FOLDER;

	if ($sub && is_dir($FILES_FOLDER.$sub)) {
		$files = array();
		$dh  = opendir($FILES_FOLDER.$sub);
		while (false !== ($filename = readdir($dh))) {
			if ($filename != '.' && $filename != '..')$files[] = $filename;
		}
		closedir($dh);
		if (count($files) == 0) {
			rmdir($FILES_FOLDER.$sub);
		}
	}
}

/**
 *      $cc    $classID
 * @param int $cc    
 * @param int $classID  
 * @return bool
 */

function DeleteSubClassFiles ($cc, $classID) {
	global $db;

	$res = $db->get_results("SELECT `Field_ID`, `Field_Name`
    FROM `Field`
    WHERE `Class_ID` = '".(int)$classID."'
    AND `System_Table_ID` = 0
    AND `TypeOfData_ID` = 6", ARRAY_A);
	if($res) {
		foreach ($res as $field) {
			$messages = $db->get_col("SELECT `Message_ID`, `".$field['Field_Name']."` FROM `Message".$classID."` WHERE `Sub_Class_ID` = '".(int)$cc."'");
			if ($messages) {
				foreach($messages as $message_id) {
					DeleteFile($field['Field_ID'], $field['Field_Name'], $classID, '', $message_id);
				}
			}
		}
	}
	// delete dir
  DeleteSubClassDir($cc);
  
	return true;
}

function DeleteOwnSubClassFiles ($cc, $classID, $user_id) {
}


?>